# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from etsi_its_cam_ts_msgs/BasicVehicleContainerLowFrequency.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import etsi_its_cam_ts_msgs.msg

class BasicVehicleContainerLowFrequency(genpy.Message):
  _md5sum = "003f66045290fdf6e06ad4319e8f35e9"
  _type = "etsi_its_cam_ts_msgs/BasicVehicleContainerLowFrequency"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
#   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
#   -t
#   cam_ts
#   -o
#   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
# * This type contains detaild information of the Basic Vehicle Container Low Frequency.
# *
# * It shall include the following components:
# *
# * @field vehicleRole: represent the role of the vehicle ITS-S that originates the CAM. Only values 0 to 7 shall be used.
# *
# * @field exteriorLights: represent the status of the most important exterior lights switches of the vehicle ITS-S that originates the CAM.
# *
# * @field pathHistory: which represents the vehicle's recent movement over some past time and/or distance. It consists of a list of path points,
# * each represented as DF PathPoint. The list of path points may consist of up to 23 elements. 
# */
# BasicVehicleContainerLowFrequency  ::= SEQUENCE {
# 	vehicleRole VehicleRole,
# 	exteriorLights ExteriorLights,
# 	pathHistory Path
# }
# ------------------------------------------------------------------------------

VehicleRole vehicle_role

ExteriorLights exterior_lights

Path path_history


================================================================================
MSG: etsi_its_cam_ts_msgs/VehicleRole
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
#   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
#   -t
#   cam_ts
#   -o
#   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE indicates the role played by a vehicle at a point in time.
#  *
#  * The value shall be set to:
#  * - 0 `default`          - to indicate the default vehicle role as indicated by the vehicle type,
#  * - 1 `publicTransport`  - to indicate that the vehicle is used to operate public transport service,
#  * - 2 `specialTransport` - to indicate that the vehicle is used for special transport purpose, e.g. oversized trucks,
#  * - 3 `dangerousGoods`   - to indicate that the vehicle is used for dangerous goods transportation,
#  * - 4 `roadWork`         - to indicate that the vehicle is used to realize roadwork or road maintenance mission,
#  * - 5 `rescue`           - to indicate that the vehicle is used for rescue purpose in case of an accident, e.g. as a towing service,
#  * - 6 `emergency`        - to indicate that the vehicle is used for emergency mission, e.g. ambulance, fire brigade,
#  * - 7 `safetyCar`        - to indicate that the vehicle is used for public safety, e.g. patrol,
#  * - 8 `agriculture`      - to indicate that the vehicle is used for agriculture, e.g. farm tractor, 
#  * - 9 `commercial`       - to indicate that the vehicle is used for transportation of commercial goods,
#  * - 10 `military`        - to indicate that the vehicle is used for military purpose, 
#  * - 11 `roadOperator`    - to indicate that the vehicle is used in road operator missions,
#  * - 12 `taxi`            - to indicate that the vehicle is used to provide an authorized taxi service,
#  * - 13 `uvar`            - to indicate that the vehicle is authorized to enter a zone according to the applicable Urban Vehicle Access Restrictions.
#  * - 14 `rfu1`            - is reserved for future usage.
#  * - 15 `rfu2`            - is reserved for future usage.
#  * 
#  * @category: Vehicle Information
#  * @revision: Description updated in V2.1.1 (removed reference to CEN/TS 16157-3), value 13 assigned in V2.2.1
#  */
# VehicleRole ::= ENUMERATED {
#     default         (0), 
#     publicTransport (1), 
#     specialTransport(2), 
#     dangerousGoods  (3), 
#     roadWork        (4), 
#     rescue          (5), 
#     emergency       (6), 
#     safetyCar       (7), 
#     agriculture     (8), 
#     commercial      (9), 
#     military        (10), 
#     roadOperator    (11), 
#     taxi            (12), 
#     uvar            (13), 
#     rfu1            (14), 
#     rfu2            (15)
# }
# ------------------------------------------------------------------------------

uint8 value
uint8 DEFAULT = 0
uint8 PUBLIC_TRANSPORT = 1
uint8 SPECIAL_TRANSPORT = 2
uint8 DANGEROUS_GOODS = 3
uint8 ROAD_WORK = 4
uint8 RESCUE = 5
uint8 EMERGENCY = 6
uint8 SAFETY_CAR = 7
uint8 AGRICULTURE = 8
uint8 COMMERCIAL = 9
uint8 MILITARY = 10
uint8 ROAD_OPERATOR = 11
uint8 TAXI = 12
uint8 UVAR = 13
uint8 RFU1 = 14
uint8 RFU2 = 15


================================================================================
MSG: etsi_its_cam_ts_msgs/ExteriorLights
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
#   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
#   -t
#   cam_ts
#   -o
#   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE describes the status of the exterior light switches of a vehicle incl. VRU vehicles.
#  *
#  * The corresponding bit shall be set to 1 under the following conditions:
#  * - 0 - `lowBeamHeadlightsOn`    - when the low beam head light switch is on,
#  * - 1 - `highBeamHeadlightsOn`   - when the high beam head light switch is on,
#  * - 2 - `leftTurnSignalOn`       - when the left turnSignal switch is on,
#  * - 3 - `rightTurnSignalOn`      - when the right turn signal switch is on,
#  * - 4 - `daytimeRunningLightsOn` - when the daytime running light switch is on,
#  * - 5 - `reverseLightOn`         - when the reverse light switch is on,
#  * - 6 - `fogLightOn`             - when the tail fog light switch is on,
#  * - 7 - `parkingLightsOn`        - when the parking light switch is on.
#  * 
#  * @note: The value of each bit indicates the state of the switch, which commands the corresponding light.
#  * The bit corresponding to a specific light is set to `1`, when the corresponding switch is turned on,
#  * either manually by the driver or automatically by a vehicle system. The bit value does not indicate
#  * if the corresponding lamps are alight or not.
#  * 
#  * If a vehicle is not equipped with a certain light or if the light switch status information is not available,
#  * the corresponding bit shall be set to `0`.
#  * 
#  * As the bit value indicates only the state of the switch, the turn signal and hazard signal bit values shall not
#  * alternate with the blinking interval.
#  * 
#  * For hazard indicator, the `leftTurnSignalOn (2)` and `rightTurnSignalOn (3)` shall be both set to `1`.
#  * 
#  * @category Vehicle information
#  * @revision: Description revised in V2.1.1
#  */
# ExteriorLights ::= BIT STRING {
#     lowBeamHeadlightsOn      (0),
#     highBeamHeadlightsOn     (1),
#     leftTurnSignalOn         (2),
#     rightTurnSignalOn        (3),
#     daytimeRunningLightsOn   (4),
#     reverseLightOn           (5),
#     fogLightOn               (6),
#     parkingLightsOn          (7)
# } (SIZE(8))
# ------------------------------------------------------------------------------

uint8[] value
uint8 bits_unused
uint8 SIZE_BITS = 8
uint8 BIT_INDEX_LOW_BEAM_HEADLIGHTS_ON = 0
uint8 BIT_INDEX_HIGH_BEAM_HEADLIGHTS_ON = 1
uint8 BIT_INDEX_LEFT_TURN_SIGNAL_ON = 2
uint8 BIT_INDEX_RIGHT_TURN_SIGNAL_ON = 3
uint8 BIT_INDEX_DAYTIME_RUNNING_LIGHTS_ON = 4
uint8 BIT_INDEX_REVERSE_LIGHT_ON = 5
uint8 BIT_INDEX_FOG_LIGHT_ON = 6
uint8 BIT_INDEX_PARKING_LIGHTS_ON = 7


================================================================================
MSG: etsi_its_cam_ts_msgs/Path
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
#   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
#   -t
#   cam_ts
#   -o
#   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DF represents a path with a set of path points.
#  * It shall contain up to `40` @ref PathPoint. 
#  * 
#  * The first PathPoint presents an offset delta position with regards to an external reference position.
#  * Each other PathPoint presents an offset delta position and optionally an offset travel time with regards to the previous PathPoint. 
#  *
#  * @category: GeoReference information, Vehicle information
#  * @revision: created in V2.1.1 based on PathHistory
#  */
# Path::= SEQUENCE (SIZE(0..40)) OF PathPoint
# ------------------------------------------------------------------------------

PathPoint[] array
uint8 MIN_SIZE = 0
uint8 MAX_SIZE = 40


================================================================================
MSG: etsi_its_cam_ts_msgs/PathPoint
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
#   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
#   -t
#   cam_ts
#   -o
#   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DF defines an offset waypoint position within a path.
#  *
#  * It shall include the following components: 
#  *
#  * @field pathPosition: The waypoint position defined as an offset position with regards to a pre-defined reference position. 
#  *
#  * @field pathDeltaTime: The optional travel time separated from a waypoint to the predefined reference position.
#  *
#  * @category GeoReference information
#  * @revision: semantics updated in V2.1.1
#  */
# PathPoint ::= SEQUENCE {
#     pathPosition     DeltaReferencePosition,
#     pathDeltaTime    PathDeltaTime OPTIONAL
# }
# ------------------------------------------------------------------------------

DeltaReferencePosition path_position

PathDeltaTime path_delta_time
bool path_delta_time_is_present


================================================================================
MSG: etsi_its_cam_ts_msgs/DeltaReferencePosition
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
#   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
#   -t
#   cam_ts
#   -o
#   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DF defines a geographical point position as a 3 dimensional offset position to a geographical reference point.
#  *
#  * It shall include the following components: 
#  *
#  * @field deltaLatitude: A delta latitude offset with regards to the latitude value of the reference position.
#  *
#  * @field deltaLongitude: A delta longitude offset with regards to the longitude value of the reference position.
#  *
#  * @field deltaAltitude: A delta altitude offset with regards to the altitude value of the reference position.
#  *
#  * @category: GeoReference information
#  * @revision:  V1.3.1
#  */
# DeltaReferencePosition ::= SEQUENCE {
#     deltaLatitude     DeltaLatitude,
#     deltaLongitude    DeltaLongitude,
#     deltaAltitude     DeltaAltitude
# }
# ------------------------------------------------------------------------------

DeltaLatitude delta_latitude

DeltaLongitude delta_longitude

DeltaAltitude delta_altitude


================================================================================
MSG: etsi_its_cam_ts_msgs/DeltaLatitude
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
#   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
#   -t
#   cam_ts
#   -o
#   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE represents an offset latitude with regards to a defined latitude value.
#  * It may be used to describe a geographical point with regards to a specific reference geographical position.
#  *
#  * The value shall be set to:
#  * - `n` (`n >= -131 071` and `n < 0`) for offset n x 10^-7 degree towards the south from the reference position,
#  * - `0` for no latitudinal offset,
#  * - `n` (`n > 0` and `n < 131 072`) for offset n x 10^-7 degree towards the north from the reference position,
#  * - `131 072` when the information is unavailable.
#  *
#  * @unit: 10^-7 degree
#  * @category: GeoReference information
#  * @revision: editorial update in V2.1.1
#  */
# DeltaLatitude ::= INTEGER {
#     unavailable (131072)
# } (-131071..131072)
# ------------------------------------------------------------------------------

int32 value
int32 MIN = -131071
int32 MAX = 131072
int32 UNAVAILABLE = 131072


================================================================================
MSG: etsi_its_cam_ts_msgs/DeltaLongitude
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
#   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
#   -t
#   cam_ts
#   -o
#   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE represents an offset longitude with regards to a defined longitude value.
#  * It may be used to describe a geographical point with regards to a specific reference geographical position.
#  *
#  * The value shall be set to:
#  * - `n` (`n >= -131 071` and `n < 0`) for offset n x 10^-7 degree towards the west from the reference position,
#  * - `0` for no longitudinal offset,
#  * - `n` (`n > 0` and `n < 131 072`) for offset n x 10^-7 degree towards the east from the reference position, 
#  * - `131 072` when the information is unavailable.
#  *
#  * @unit: 10^-7 degree
#  * @category: GeoReference information
#  * @revision: editorial update in V2.1.1
#  */
# DeltaLongitude ::= INTEGER {
#     unavailable (131072)
# } (-131071..131072)
# ------------------------------------------------------------------------------

int32 value
int32 MIN = -131071
int32 MAX = 131072
int32 UNAVAILABLE = 131072


================================================================================
MSG: etsi_its_cam_ts_msgs/DeltaAltitude
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
#   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
#   -t
#   cam_ts
#   -o
#   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE represents an offset altitude with regards to a defined altitude value.
#  * It may be used to describe a geographical point with regards to a specific reference geographical position.
#  *
#  * The value shall be set to:
#  * - `-12 700` for values equal to or lower than -127 metres,
#  * - `n` (`n > -12 700` and `n <= 0`) for altitude offset n x 0,01 metre below the reference position,
#  * - `0` for no altitudinal offset,
#  * - `n` (`n > 0` and `n < 12799`) for altitude offset n x 0,01 metre above the reference position,
#  * - `12 799` for values equal to or greater than 127,99 metres,
#  * - `12 800` when the information is unavailable.
#  *
#  * @unit: 0,01 metre
#  * @category: GeoReference information
#  * @revision: editorial update in V2.1.1
#  */
# DeltaAltitude ::= INTEGER {
#     negativeOutOfRange (-12700),
#     positiveOutOfRange (12799),
#     unavailable        (12800)
# } (-12700..12800)
# ------------------------------------------------------------------------------

int16 value
int16 MIN = -12700
int16 MAX = 12800
int16 NEGATIVE_OUT_OF_RANGE = -12700
int16 POSITIVE_OUT_OF_RANGE = 12799
int16 UNAVAILABLE = 12800


================================================================================
MSG: etsi_its_cam_ts_msgs/PathDeltaTime
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
#   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
#   -t
#   cam_ts
#   -o
#   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE represents the recorded or estimated travel time between a position and a predefined reference position. 
#  *
#  * @unit 0,01 second
#  * @category: Basic information
#  * @revision: V1.3.1
#  */
# PathDeltaTime ::= INTEGER (1..65535, ...) 
# ------------------------------------------------------------------------------

uint16 value
uint16 MIN = 1
uint16 MAX = 65535

"""
  __slots__ = ['vehicle_role','exterior_lights','path_history']
  _slot_types = ['etsi_its_cam_ts_msgs/VehicleRole','etsi_its_cam_ts_msgs/ExteriorLights','etsi_its_cam_ts_msgs/Path']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       vehicle_role,exterior_lights,path_history

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(BasicVehicleContainerLowFrequency, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.vehicle_role is None:
        self.vehicle_role = etsi_its_cam_ts_msgs.msg.VehicleRole()
      if self.exterior_lights is None:
        self.exterior_lights = etsi_its_cam_ts_msgs.msg.ExteriorLights()
      if self.path_history is None:
        self.path_history = etsi_its_cam_ts_msgs.msg.Path()
    else:
      self.vehicle_role = etsi_its_cam_ts_msgs.msg.VehicleRole()
      self.exterior_lights = etsi_its_cam_ts_msgs.msg.ExteriorLights()
      self.path_history = etsi_its_cam_ts_msgs.msg.Path()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self.vehicle_role.value
      buff.write(_get_struct_B().pack(_x))
      _x = self.exterior_lights.value
      length = len(_x)
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
      else:
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.exterior_lights.bits_unused
      buff.write(_get_struct_B().pack(_x))
      length = len(self.path_history.array)
      buff.write(_struct_I.pack(length))
      for val1 in self.path_history.array:
        _v1 = val1.path_position
        _v2 = _v1.delta_latitude
        _x = _v2.value
        buff.write(_get_struct_i().pack(_x))
        _v3 = _v1.delta_longitude
        _x = _v3.value
        buff.write(_get_struct_i().pack(_x))
        _v4 = _v1.delta_altitude
        _x = _v4.value
        buff.write(_get_struct_h().pack(_x))
        _v5 = val1.path_delta_time
        _x = _v5.value
        buff.write(_get_struct_H().pack(_x))
        _x = val1.path_delta_time_is_present
        buff.write(_get_struct_B().pack(_x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.vehicle_role is None:
        self.vehicle_role = etsi_its_cam_ts_msgs.msg.VehicleRole()
      if self.exterior_lights is None:
        self.exterior_lights = etsi_its_cam_ts_msgs.msg.ExteriorLights()
      if self.path_history is None:
        self.path_history = etsi_its_cam_ts_msgs.msg.Path()
      end = 0
      start = end
      end += 1
      (self.vehicle_role.value,) = _get_struct_B().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.exterior_lights.value = str[start:end]
      start = end
      end += 1
      (self.exterior_lights.bits_unused,) = _get_struct_B().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.path_history.array = []
      for i in range(0, length):
        val1 = etsi_its_cam_ts_msgs.msg.PathPoint()
        _v6 = val1.path_position
        _v7 = _v6.delta_latitude
        start = end
        end += 4
        (_v7.value,) = _get_struct_i().unpack(str[start:end])
        _v8 = _v6.delta_longitude
        start = end
        end += 4
        (_v8.value,) = _get_struct_i().unpack(str[start:end])
        _v9 = _v6.delta_altitude
        start = end
        end += 2
        (_v9.value,) = _get_struct_h().unpack(str[start:end])
        _v10 = val1.path_delta_time
        start = end
        end += 2
        (_v10.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (val1.path_delta_time_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.path_delta_time_is_present = bool(val1.path_delta_time_is_present)
        self.path_history.array.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self.vehicle_role.value
      buff.write(_get_struct_B().pack(_x))
      _x = self.exterior_lights.value
      length = len(_x)
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
      else:
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.exterior_lights.bits_unused
      buff.write(_get_struct_B().pack(_x))
      length = len(self.path_history.array)
      buff.write(_struct_I.pack(length))
      for val1 in self.path_history.array:
        _v11 = val1.path_position
        _v12 = _v11.delta_latitude
        _x = _v12.value
        buff.write(_get_struct_i().pack(_x))
        _v13 = _v11.delta_longitude
        _x = _v13.value
        buff.write(_get_struct_i().pack(_x))
        _v14 = _v11.delta_altitude
        _x = _v14.value
        buff.write(_get_struct_h().pack(_x))
        _v15 = val1.path_delta_time
        _x = _v15.value
        buff.write(_get_struct_H().pack(_x))
        _x = val1.path_delta_time_is_present
        buff.write(_get_struct_B().pack(_x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.vehicle_role is None:
        self.vehicle_role = etsi_its_cam_ts_msgs.msg.VehicleRole()
      if self.exterior_lights is None:
        self.exterior_lights = etsi_its_cam_ts_msgs.msg.ExteriorLights()
      if self.path_history is None:
        self.path_history = etsi_its_cam_ts_msgs.msg.Path()
      end = 0
      start = end
      end += 1
      (self.vehicle_role.value,) = _get_struct_B().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.exterior_lights.value = str[start:end]
      start = end
      end += 1
      (self.exterior_lights.bits_unused,) = _get_struct_B().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.path_history.array = []
      for i in range(0, length):
        val1 = etsi_its_cam_ts_msgs.msg.PathPoint()
        _v16 = val1.path_position
        _v17 = _v16.delta_latitude
        start = end
        end += 4
        (_v17.value,) = _get_struct_i().unpack(str[start:end])
        _v18 = _v16.delta_longitude
        start = end
        end += 4
        (_v18.value,) = _get_struct_i().unpack(str[start:end])
        _v19 = _v16.delta_altitude
        start = end
        end += 2
        (_v19.value,) = _get_struct_h().unpack(str[start:end])
        _v20 = val1.path_delta_time
        start = end
        end += 2
        (_v20.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (val1.path_delta_time_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.path_delta_time_is_present = bool(val1.path_delta_time_is_present)
        self.path_history.array.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_B = None
def _get_struct_B():
    global _struct_B
    if _struct_B is None:
        _struct_B = struct.Struct("<B")
    return _struct_B
_struct_H = None
def _get_struct_H():
    global _struct_H
    if _struct_H is None:
        _struct_H = struct.Struct("<H")
    return _struct_H
_struct_h = None
def _get_struct_h():
    global _struct_h
    if _struct_h is None:
        _struct_h = struct.Struct("<h")
    return _struct_h
_struct_i = None
def _get_struct_i():
    global _struct_i
    if _struct_i is None:
        _struct_i = struct.Struct("<i")
    return _struct_i
