# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from etsi_its_cam_ts_msgs/PublicTransportContainer.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import etsi_its_cam_ts_msgs.msg

class PublicTransportContainer(genpy.Message):
  _md5sum = "6e0db2bcdf856f30d6400e662ae61b19"
  _type = "etsi_its_cam_ts_msgs/PublicTransportContainer"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
#   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
#   -t
#   cam_ts
#   -o
#   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
# * This type contains detaild information of the Public Transport Container.
# *
# * It shall include the following components:
# *
# * @field embarkationStatus: It indicates whether the passenger embarkation is currently ongoing. 
# *
# * @field ptActivation: an optional component used for controlling traffic lights, barriers, bollards, etc.
# */
# PublicTransportContainer ::= SEQUENCE {
# 	embarkationStatus EmbarkationStatus,
# 	ptActivation PtActivation OPTIONAL
# }
# ------------------------------------------------------------------------------

EmbarkationStatus embarkation_status

PtActivation pt_activation
bool pt_activation_is_present


================================================================================
MSG: etsi_its_cam_ts_msgs/EmbarkationStatus
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
#   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
#   -t
#   cam_ts
#   -o
#   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE indicates whether a vehicle (e.g. public transport vehicle, truck) is under the embarkation process.
#  * If that is the case, the value is *TRUE*, otherwise *FALSE*.
#  *
#  * @category: Vehicle information
#  * @revision: editorial update in V2.1.1
#  */
# EmbarkationStatus ::= BOOLEAN
# ------------------------------------------------------------------------------

bool value


================================================================================
MSG: etsi_its_cam_ts_msgs/PtActivation
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
#   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
#   -t
#   cam_ts
#   -o
#   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DF represents activation data for real-time systems designed for operations control, traffic light priorities, track switches, barriers, etc.
#  * using a range of activation devices equipped in public transport vehicles.
#  *
#  * The activation of the corresponding equipment is triggered by the approach or passage of a public transport
#  * vehicle at a certain point (e.g. a beacon).
#  *
#  * @field ptActivationType: type of activation. 
#  *
#  * @field ptActicationData: data of activation. 
#  *
#  * Today there are different payload variants defined for public transport activation-data. The R09.x is one of
#  * the industry standard used by public transport vehicles (e.g. buses, trams) in Europe (e.g. Germany Austria)
#  * for controlling traffic lights, barriers, bollards, etc. This DF shall include information like route, course,
#  * destination, priority, etc.
#  * 
#  * The R09.x content is defined in VDV recommendation 420 [7]. It includes following information:
#  * - Priority Request Information (pre-request, request, ready to start)
#  * - End of Prioritization procedure
#  * - Priority request direction
#  * - Public Transport line number
#  * - Priority of public transport
#  * - Route line identifier of the public transport
#  * - Route number identification
#  * - Destination of public transport vehicle
#  *
#  * Other countries may use different message sets defined by the local administration.
#  * @category: Vehicle information
#  * @revision: V1.3.1
#  */
# PtActivation ::= SEQUENCE {
#     ptActivationType    PtActivationType,
#     ptActivationData    PtActivationData
# }
# ------------------------------------------------------------------------------

PtActivationType pt_activation_type

PtActivationData pt_activation_data


================================================================================
MSG: etsi_its_cam_ts_msgs/PtActivationType
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
#   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
#   -t
#   cam_ts
#   -o
#   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE indicates a certain coding type of the PtActivationData data.
#  *
#  * The folowing value are specified:
#  * - 0 `undefinedCodingType`  : undefined coding type,
#  * - 1 `r09-16CodingType`     : coding of PtActivationData conform to VDV recommendation 420 [7],
#  * - 2 `vdv-50149CodingType`  : coding of PtActivationData based on VDV recommendation 420 [7].
#  * - 3 - 255                  : reserved for alternative and future use.
#  * 
#  * @category: Vehicle information 
#  * @revision: V1.3.1
#  */
# PtActivationType ::= INTEGER {
#     undefinedCodingType (0), 
#     r09-16CodingType    (1), 
#     vdv-50149CodingType (2)
# } (0..255)
# ------------------------------------------------------------------------------

uint8 value
uint8 MIN = 0
uint8 MAX = 255
uint8 UNDEFINED_CODING_TYPE = 0
uint8 R09_16_CODING_TYPE = 1
uint8 VDV_50149_CODING_TYPE = 2


================================================================================
MSG: etsi_its_cam_ts_msgs/PtActivationData
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
#   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
#   -t
#   cam_ts
#   -o
#   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE is used for various tasks in the public transportation environment, especially for controlling traffic
#  * signal systems to prioritize and speed up public transportation in urban area (e.g. intersection "_bottlenecks_").
#  * The traffic lights may be controlled by an approaching bus or tram automatically. This permits "_In Time_" activation
#  * of the green phase, will enable the individual traffic to clear a potential traffic jam in advance. Thereby the
#  * approaching bus or tram may pass an intersection with activated green light without slowing down the speed due to
#  * traffic congestion. Other usage of the DE is the provision of information like the public transport line number
#  * or the schedule delay of a public transport vehicle.
#  * 
#  * @category: Vehicle information
#  * @revision: V1.3.1
#  */
# PtActivationData ::= OCTET STRING (SIZE(1..20))
# ------------------------------------------------------------------------------

uint8[] value
uint8 MIN_SIZE = 1
uint8 MAX_SIZE = 20

"""
  __slots__ = ['embarkation_status','pt_activation','pt_activation_is_present']
  _slot_types = ['etsi_its_cam_ts_msgs/EmbarkationStatus','etsi_its_cam_ts_msgs/PtActivation','bool']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       embarkation_status,pt_activation,pt_activation_is_present

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(PublicTransportContainer, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.embarkation_status is None:
        self.embarkation_status = etsi_its_cam_ts_msgs.msg.EmbarkationStatus()
      if self.pt_activation is None:
        self.pt_activation = etsi_its_cam_ts_msgs.msg.PtActivation()
      if self.pt_activation_is_present is None:
        self.pt_activation_is_present = False
    else:
      self.embarkation_status = etsi_its_cam_ts_msgs.msg.EmbarkationStatus()
      self.pt_activation = etsi_its_cam_ts_msgs.msg.PtActivation()
      self.pt_activation_is_present = False

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_2B().pack(_x.embarkation_status.value, _x.pt_activation.pt_activation_type.value))
      _x = self.pt_activation.pt_activation_data.value
      length = len(_x)
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
      else:
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.pt_activation_is_present
      buff.write(_get_struct_B().pack(_x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.embarkation_status is None:
        self.embarkation_status = etsi_its_cam_ts_msgs.msg.EmbarkationStatus()
      if self.pt_activation is None:
        self.pt_activation = etsi_its_cam_ts_msgs.msg.PtActivation()
      end = 0
      _x = self
      start = end
      end += 2
      (_x.embarkation_status.value, _x.pt_activation.pt_activation_type.value,) = _get_struct_2B().unpack(str[start:end])
      self.embarkation_status.value = bool(self.embarkation_status.value)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.pt_activation.pt_activation_data.value = str[start:end]
      start = end
      end += 1
      (self.pt_activation_is_present,) = _get_struct_B().unpack(str[start:end])
      self.pt_activation_is_present = bool(self.pt_activation_is_present)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_2B().pack(_x.embarkation_status.value, _x.pt_activation.pt_activation_type.value))
      _x = self.pt_activation.pt_activation_data.value
      length = len(_x)
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
      else:
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.pt_activation_is_present
      buff.write(_get_struct_B().pack(_x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.embarkation_status is None:
        self.embarkation_status = etsi_its_cam_ts_msgs.msg.EmbarkationStatus()
      if self.pt_activation is None:
        self.pt_activation = etsi_its_cam_ts_msgs.msg.PtActivation()
      end = 0
      _x = self
      start = end
      end += 2
      (_x.embarkation_status.value, _x.pt_activation.pt_activation_type.value,) = _get_struct_2B().unpack(str[start:end])
      self.embarkation_status.value = bool(self.embarkation_status.value)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.pt_activation.pt_activation_data.value = str[start:end]
      start = end
      end += 1
      (self.pt_activation_is_present,) = _get_struct_B().unpack(str[start:end])
      self.pt_activation_is_present = bool(self.pt_activation_is_present)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_2B = None
def _get_struct_2B():
    global _struct_2B
    if _struct_2B is None:
        _struct_2B = struct.Struct("<2B")
    return _struct_2B
_struct_B = None
def _get_struct_B():
    global _struct_B
    if _struct_B is None:
        _struct_B = struct.Struct("<B")
    return _struct_B
