# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from etsi_its_cam_ts_msgs/CamParameters.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import etsi_its_cam_ts_msgs.msg

class CamParameters(genpy.Message):
  _md5sum = "7959b222849f32df04ba19bbf00a2f0d"
  _type = "etsi_its_cam_ts_msgs/CamParameters"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
#   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
#   -t
#   cam_ts
#   -o
#   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
# * @field basicContainer: the mandatory basic container of the CAM.
# *
# * @field highFrequencyContainer: the mandatory container represents the high frequency of the CAM.
# * 
# * @field lowFrequencyContainer: the optional conatainer represents the low frequency of the CAM.
# *
# * @field specialVehicleContainer: The special container of the CAM shall be present as defined in clause 6.1.2. 
# * The content of the container shall be set according to the value of the vehicleRole component as specified in Table 5. 
# */
# CamParameters ::= SEQUENCE {
# 	basicContainer           BasicContainer,
# 	highFrequencyContainer   HighFrequencyContainer,
# 	lowFrequencyContainer    LowFrequencyContainer OPTIONAL,
# 	specialVehicleContainer  SpecialVehicleContainer OPTIONAL,
# 	...
# }
# ------------------------------------------------------------------------------

BasicContainer basic_container

HighFrequencyContainer high_frequency_container

LowFrequencyContainer low_frequency_container
bool low_frequency_container_is_present

SpecialVehicleContainer special_vehicle_container
bool special_vehicle_container_is_present


================================================================================
MSG: etsi_its_cam_ts_msgs/BasicContainer
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
#   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
#   -t
#   cam_ts
#   -o
#   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /** 
#  * This DE represents a general container for usage in various types of messages.
#  *
#  * It shall include the following components: 
#  *
#  * @field stationType: the type of technical context in which the ITS-S that has generated the message is integrated in.
#  *
#  * @field referencePosition: the reference position of the station that has generated the message that contains the basic container.
#  *
#  * @category: Basic information
#  * @revision: Created in V2.1.1
# */
# BasicContainer ::= SEQUENCE {
# 	stationType          TrafficParticipantType,
# 	referencePosition    ReferencePositionWithConfidence,
# 	...
# }
# ------------------------------------------------------------------------------

TrafficParticipantType station_type

ReferencePositionWithConfidence reference_position


================================================================================
MSG: etsi_its_cam_ts_msgs/TrafficParticipantType
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
#   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
#   -t
#   cam_ts
#   -o
#   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE represents the type of a traffic participant.
#  * 
#  * The value shall be set to:
#  * - 0 `unknown`          - information about traffic participant is not provided,
#  * - 1 `pedestrian`       - human being not using a mechanical device for their trip (VRU profile 1),
#  * - 2 `cyclist`          - non-motorized unicycles, bicycles , tricycles, quadracycles (VRU profile 2),
#  * - 3 `moped`            - light motor vehicles with less than four wheels as defined in UNECE/TRANS/WP.29/78/Rev.4 [16] class L1, L2 (VRU Profile 3),
#  * - 4 `motorcycles`      - motor vehicles with less than four wheels as defined in UNECE/TRANS/WP.29/78/Rev.4 [16] class L3, L4, L5, L6, L7 (VRU Profile 3),
#  * - 5 `passengerCar`     - small passenger vehicles as defined in UNECE/TRANS/WP.29/78/Rev.4 [16] class M1,
#  * - 6 `bus`              - large passenger vehicles as defined in UNECE/TRANS/WP.29/78/Rev.4 [16] class M2, M3,
#  * - 7 `lightTruck`       - light Goods Vehicles as defined in UNECE/TRANS/WP.29/78/Rev.4 [16] class N1,
#  * - 8 `heavyTruck`       - Heavy Goods Vehicles as defined in UNECE/TRANS/WP.29/78/Rev.4 [16] class N2 and N3,
#  * - 9 `trailer`          - unpowered vehicle that is intended to be towed by a powered vehicle as defined in UNECE/TRANS/WP.29/78/Rev.4 [16] class O,
#  * - 10 `specialVehicles` - vehicles which have special purposes other than the above (e.g. moving road works vehicle),
#  * - 11 `tram`            - vehicle which runs on tracks along public streets,
#  * - 12 `lightVruVehicle` - human being traveling on light vehicle, incl. possible use of roller skates or skateboards (VRU profile 2),
#  * - 13 `animal`          - animal presenting a safety risk to other road users e.g. domesticated dog in a city or horse (VRU Profile 4),
#  * - 14 `agricultural`    - agricultural and forestry vehicles as defined in UNECE/TRANS/WP.29/78/Rev.4 [16] class T,
#  * - 15 `roadSideUnit`    - infrastructure typically positioned outside of the drivable roadway (e.g. on a gantry, on a pole, 
#                             on a stationary road works trailer); the infrastructure is static during the entire operation period of the ITS-S (e.g. no stop and go activity),
#  * - 16-255               - are reserved for future usage.
#  * 
#  * @category: Communication information.
#  * @revision: Created in V2.1.1 based on StationType
#  */
# TrafficParticipantType ::= INTEGER {
#     unknown         (0), 
#     pedestrian      (1), 
#     cyclist         (2), 
#     moped           (3), 
#     motorcycle      (4), 
#     passengerCar    (5), 
#     bus             (6), 
#     lightTruck      (7), 
#     heavyTruck      (8), 
#     trailer         (9), 
#     specialVehicle  (10), 
#     tram            (11), 
#     lightVruVehicle (12), 
#     animal          (13),
#     agricultural    (14), 
#     roadSideUnit    (15)
# } (0..255)
# ------------------------------------------------------------------------------

uint8 value
uint8 MIN = 0
uint8 MAX = 255
uint8 UNKNOWN = 0
uint8 PEDESTRIAN = 1
uint8 CYCLIST = 2
uint8 MOPED = 3
uint8 MOTORCYCLE = 4
uint8 PASSENGER_CAR = 5
uint8 BUS = 6
uint8 LIGHT_TRUCK = 7
uint8 HEAVY_TRUCK = 8
uint8 TRAILER = 9
uint8 SPECIAL_VEHICLE = 10
uint8 TRAM = 11
uint8 LIGHT_VRU_VEHICLE = 12
uint8 ANIMAL = 13
uint8 AGRICULTURAL = 14
uint8 ROAD_SIDE_UNIT = 15


================================================================================
MSG: etsi_its_cam_ts_msgs/ReferencePositionWithConfidence
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
#   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
#   -t
#   cam_ts
#   -o
#   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * A position within a geographic coordinate system together with a confidence ellipse. 
#  *
#  * It shall include the following components: 
#  *
#  * @field latitude: the latitude of the geographical point.
#  *
#  * @field longitude: the longitude of the geographical point.
#  *
#  * @field positionConfidenceEllipse: the confidence ellipse associated to the geographical position.
#  *
#  * @field altitude: the altitude and an altitude accuracy of the geographical point.
#  *
#  * @category: GeoReference information
#  * @revision: created in V2.1.1 based on @ref ReferencePosition but using @ref PositionConfidenceEllipse.
#  */
# ReferencePositionWithConfidence ::= SEQUENCE {
#     latitude                     Latitude,
#     longitude                    Longitude,
#     positionConfidenceEllipse    PositionConfidenceEllipse,
#     altitude                     Altitude
# }
# ------------------------------------------------------------------------------

Latitude latitude

Longitude longitude

PositionConfidenceEllipse position_confidence_ellipse

Altitude altitude


================================================================================
MSG: etsi_its_cam_ts_msgs/Latitude
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
#   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
#   -t
#   cam_ts
#   -o
#   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE represents the absolute geographical latitude in a WGS84 coordinate system, providing a range of 90 degrees in north or
#  * in south hemisphere.
#  * The specific WGS84 coordinate system is specified by the corresponding standards applying this DE.
#  *
#  * The value shall be set to:
#  * - `n` (`n >= -900 000 000` and `n < 0`) x 10^-7 degree, i.e. negative values for latitudes south of the Equator,
#  * - `0` is used for the latitude of the equator,
#  * - `n` (`n > 0` and `n < 900 000 001`) x 10^-7 degree, i.e. positive values for latitudes north of the Equator,
#  * - `900 000 001` when the information is unavailable.
#  *
#  * @unit: 10^-7 degree
#  * @category: GeoReference information
#  * @revision: Editorial update in V2.1.1
#  */
# Latitude ::= INTEGER {
#     unavailable(900000001)
# } (-900000000..900000001)
# ------------------------------------------------------------------------------

int32 value
int32 MIN = -900000000
int32 MAX = 900000001
int32 UNAVAILABLE = 900000001


================================================================================
MSG: etsi_its_cam_ts_msgs/Longitude
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
#   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
#   -t
#   cam_ts
#   -o
#   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE represents the absolute geographical longitude in a WGS84 coordinate system, providing a range of 180 degrees
#  * to the east or to the west of the prime meridian.
#  * The specific WGS84 coordinate system is specified by the corresponding standards applying this DE.
#  *
#  * The value shall be set to:
#  * - `n` (`n > -1 800 000 000` and `n < 0`) x 10^-7 degree, i.e. negative values for longitudes to the west,
#  * - `0` to indicate the prime meridian,
#  * - `n` (`n > 0` and `n < 1 800 000 001`) x 10^-7 degree, i.e. positive values for longitudes to the east,
#  * - `1 800 000 001` when the information is unavailable.
#  *
#  * The value -1 800 000 000 shall not be used. 
#  * 
#  * @unit: 10^-7 degree
#  * @category: GeoReference information
#  * @revision: Description revised in V2.1.1
#  */
# Longitude ::= INTEGER {
#     valueNotUsed (-1800000000),
#     unavailable  (1800000001)
# } (-1800000000..1800000001)
# ------------------------------------------------------------------------------

int32 value
int32 MIN = -1800000000
int32 MAX = 1800000001
int32 VALUE_NOT_USED = -1800000000
int32 UNAVAILABLE = 1800000001


================================================================================
MSG: etsi_its_cam_ts_msgs/PositionConfidenceEllipse
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
#   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
#   -t
#   cam_ts
#   -o
#   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DF indicates the horizontal position confidence ellipse which represents the estimated accuracy with a 
#  * confidence level of 95 %. The centre of the ellipse shape corresponds to the reference
#  * position point for which the position accuracy is evaluated.
#  *
#  * It shall include the following components: 
#  *
#  * @field semiMajorAxisLength: half of length of the major axis, i.e. distance between the centre point
#  * and major axis point of the position accuracy ellipse. 
#  *
#  * @field semiMinorAxisLength: half of length of the minor axis, i.e. distance between the centre point
#  * and minor axis point of the position accuracy ellipse. 
#  *
#  * @field semiMajorAxisOrientation: orientation direction of the ellipse major axis of the position accuracy
#  * ellipse with regards to the WGS84 north. 
#  * The specific WGS84 coordinate system is specified by the corresponding standards applying this DE.
#  *
#  * @category GeoReference information
#  * @revision: created in V2.1.1 based on @ref PosConfidenceEllipse
#  */
# PositionConfidenceEllipse ::= SEQUENCE {
#     semiMajorAxisLength         SemiAxisLength,
#     semiMinorAxisLength         SemiAxisLength,
#     semiMajorAxisOrientation    Wgs84AngleValue
# }
# ------------------------------------------------------------------------------

SemiAxisLength semi_major_axis_length

SemiAxisLength semi_minor_axis_length

Wgs84AngleValue semi_major_axis_orientation


================================================================================
MSG: etsi_its_cam_ts_msgs/SemiAxisLength
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
#   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
#   -t
#   cam_ts
#   -o
#   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE indicates the horizontal position confidence value which represents the estimated absolute position accuracy, in one of the axis direction as defined in a shape of ellipse with a 
#  * confidence level of 95 %. 
#  * 
#  * The value shall be set to:
#  * - `n` (`n > 0` and `n < 4 094`) if the accuracy is equal to or less than n * 0,01 metre,
#  * - `4 094` if the accuracy is out of range, i.e. greater than 4,093 m,
#  * - `4 095` if the accuracy information is unavailable.
#  *
#  * The value 0 shall not be used.
#  * 
#  * @note: The fact that a position coordinate value is received with confidence value set to `unavailable(4095)`.
#  * can be caused by several reasons, such as:
#  * - the sensor cannot deliver the accuracy at the defined confidence level because it is a low-end sensor,
#  * - the sensor cannot calculate the accuracy due to lack of variables, or
#  * - there has been a vehicle bus (e.g. CAN bus) error.
#  * In all 3 cases above, the position coordinate value may be valid and used by the application.
#  * If a position coordinate value is received and its confidence value is set to `outOfRange(4094)`, it means that
#  * the position coordinate value is not valid and therefore cannot be trusted. Such value is not useful
#  * for the application.
# 
#  * @unit 0,01 metre 
#  * @category: GeoReference Information
#  * @revision: Description revised in V2.1.1
#  */
# SemiAxisLength ::= INTEGER{
#     doNotUse    (0),
#     outOfRange  (4094), 
#     unavailable (4095)
# } (0..4095)
# ------------------------------------------------------------------------------

uint16 value
uint16 MIN = 0
uint16 MAX = 4095
uint16 DO_NOT_USE = 0
uint16 OUT_OF_RANGE = 4094
uint16 UNAVAILABLE = 4095


================================================================================
MSG: etsi_its_cam_ts_msgs/Wgs84AngleValue
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
#   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
#   -t
#   cam_ts
#   -o
#   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /** 
#  * This DE represents an angle value in degrees described in the WGS84 reference system with respect to the WGS84 north.
#  * The specific WGS84 coordinate system is specified by the corresponding standards applying this DE.
#  * When the information is not available, the DE shall be set to 3 601. The value 3600 shall not be used.
#  *
#  * @unit 0,1 degrees
#  * @category: GeoReference Information
#  * @revision: Created in V2.1.1
# */
# Wgs84AngleValue ::= INTEGER { 
#     wgs84North  (0),
#     wgs84East   (900),
#     wgs84South  (1800),
#     wgs84West   (2700),
#     doNotUse    (3600),
#     unavailable (3601)
# } (0..3601)
# ------------------------------------------------------------------------------

uint16 value
uint16 MIN = 0
uint16 MAX = 3601
uint16 WGS84_NORTH = 0
uint16 WGS84_EAST = 900
uint16 WGS84_SOUTH = 1800
uint16 WGS84_WEST = 2700
uint16 DO_NOT_USE = 3600
uint16 UNAVAILABLE = 3601


================================================================================
MSG: etsi_its_cam_ts_msgs/Altitude
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
#   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
#   -t
#   cam_ts
#   -o
#   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DF provides the altitude and confidence level of an altitude information in a WGS84 coordinate system.
#  * The specific WGS84 coordinate system is specified by the corresponding standards applying this DE.
#  *
#  * It shall include the following components: 
#  *
#  * @field altitudeValue: altitude of a geographical point.
#  *
#  * @field altitudeConfidence: confidence level of the altitudeValue.
#  *
#  * @note: this DF is kept for backwards compatibility reasons only. It is recommended to use the @ref AltitudeWithConfidence instead. 
#  * @category: GeoReference information
#  * @revision: Description revised in V2.1.1
#  */
# Altitude ::= SEQUENCE {
#     altitudeValue         AltitudeValue,
#     altitudeConfidence    AltitudeConfidence
# }
# ------------------------------------------------------------------------------

AltitudeValue altitude_value

AltitudeConfidence altitude_confidence


================================================================================
MSG: etsi_its_cam_ts_msgs/AltitudeValue
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
#   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
#   -t
#   cam_ts
#   -o
#   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE represents the altitude value in a WGS84 coordinate system.
#  * The specific WGS84 coordinate system is specified by the corresponding standards applying this DE.
#  *
#  * The value shall be set to: 
#  * - `-100 000` if the altitude is equal to or less than -1 000 m,
#  * - `n` (`n > -100 000` and `n < 800 000`) if the altitude is equal to or less than n  x 0,01 metre and greater than (n-1) x 0,01 metre,
#  * - `800 000` if the altitude  greater than 7 999,99 m,
#  * - `800 001` if the information is not available.
#  *
#  * @note: the range of this DE does not use the full binary encoding range, but all reasonable values are covered. In order to cover all possible altitude ranges a larger encoding would be necessary.
#  * @unit: 0,01 metre
#  * @category: GeoReference information
#  * @revision: Description revised in V2.1.1 (definition of 800 000 has slightly changed) 
#  */
# AltitudeValue ::= INTEGER {
#     negativeOutOfRange (-100000),
#     postiveOutOfRange  (800000),
#     unavailable        (800001)
# } (-100000..800001)
# ------------------------------------------------------------------------------

int32 value
int32 MIN = -100000
int32 MAX = 800001
int32 NEGATIVE_OUT_OF_RANGE = -100000
int32 POSTIVE_OUT_OF_RANGE = 800000
int32 UNAVAILABLE = 800001


================================================================================
MSG: etsi_its_cam_ts_msgs/AltitudeConfidence
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
#   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
#   -t
#   cam_ts
#   -o
#   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE indicates the altitude confidence value which represents the estimated absolute accuracy of an altitude value of a geographical point with a default confidence level of 95 %.
#  * If required, the confidence level can be defined by the corresponding standards applying this DE.
#  *
#  * The value shall be set to: 
#  *   - 0  - `alt-000-01`   - if the confidence value is equal to or less than 0,01 metre,
#  *   - 1  - `alt-000-02`   - if the confidence value is equal to or less than 0,02 metre and greater than 0,01 metre,
#  *   - 2  - `alt-000-05`   - if the confidence value is equal to or less than 0,05 metre and greater than 0,02 metre,            
#  *   - 3  - `alt-000-10`   - if the confidence value is equal to or less than 0,1 metre and greater than 0,05 metre,            
#  *   - 4  - `alt-000-20`   - if the confidence value is equal to or less than 0,2 metre and greater than 0,1 metre,            
#  *   - 5  - `alt-000-50`   - if the confidence value is equal to or less than 0,5 metre and greater than 0,2 metre,             
#  *   - 6  - `alt-001-00`   - if the confidence value is equal to or less than 1 metre and greater than 0,5 metre,             
#  *   - 7  - `alt-002-00`   - if the confidence value is equal to or less than 2 metres and greater than 1 metre,             
#  *   - 8  - `alt-005-00`   - if the confidence value is equal to or less than 5 metres and greater than 2 metres,              
#  *   - 9  - `alt-010-00`   - if the confidence value is equal to or less than 10 metres and greater than 5 metres,             
#  *   - 10 - `alt-020-00`   - if the confidence value is equal to or less than 20 metres and greater than 10 metres,            
#  *   - 11 - `alt-050-00`   - if the confidence value is equal to or less than 50 metres and greater than 20 metres,            
#  *   - 12 - `alt-100-00`   - if the confidence value is equal to or less than 100 metres and greater than 50 metres,           
#  *   - 13 - `alt-200-00`   - if the confidence value is equal to or less than 200 metres and greater than 100 metres,           
#  *   - 14 - `outOfRange`   - if the confidence value is out of range, i.e. greater than 200 metres,
#  *   - 15 - `unavailable`  - if the confidence value is unavailable.       
#  *
#  * @note: The fact that an altitude value is received with confidence value set to `unavailable(15)` can be caused
#  * by several reasons, such as:
#  * - the sensor cannot deliver the accuracy at the defined confidence level because it is a low-end sensor,
#  * - the sensor cannot calculate the accuracy due to lack of variables, or
#  * - there has been a vehicle bus (e.g. CAN bus) error.
#  * In all 3 cases above, the altitude value may be valid and used by the application.
#  * 
#  * @note: If an altitude value is received and its confidence value is set to `outOfRange(14)`, it means that the  
#  * altitude value is not valid and therefore cannot be trusted. Such value is not useful for the application.             
#  *
#  * @category: GeoReference information
#  * @revision: Description revised in V2.1.1
#  */
# AltitudeConfidence ::= ENUMERATED {
#     alt-000-01  (0),
#     alt-000-02  (1),
#     alt-000-05  (2),
#     alt-000-10  (3),
#     alt-000-20  (4),
#     alt-000-50  (5),
#     alt-001-00  (6),
#     alt-002-00  (7),
#     alt-005-00  (8),
#     alt-010-00  (9),
#     alt-020-00  (10),
#     alt-050-00  (11),
#     alt-100-00  (12),
#     alt-200-00  (13),
#     outOfRange  (14),
#     unavailable (15)
# }
# ------------------------------------------------------------------------------

uint8 value
uint8 ALT_000_01 = 0
uint8 ALT_000_02 = 1
uint8 ALT_000_05 = 2
uint8 ALT_000_10 = 3
uint8 ALT_000_20 = 4
uint8 ALT_000_50 = 5
uint8 ALT_001_00 = 6
uint8 ALT_002_00 = 7
uint8 ALT_005_00 = 8
uint8 ALT_010_00 = 9
uint8 ALT_020_00 = 10
uint8 ALT_050_00 = 11
uint8 ALT_100_00 = 12
uint8 ALT_200_00 = 13
uint8 OUT_OF_RANGE = 14
uint8 UNAVAILABLE = 15


================================================================================
MSG: etsi_its_cam_ts_msgs/HighFrequencyContainer
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
#   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
#   -t
#   cam_ts
#   -o
#   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
# * This type represents the high frequency container.
# * 
# * It shall include the following components: 
# *
# * @field basicVehicleContainerHighFrequency: The mandatory high frequency container of the CAM when the originating ITS-S is of the type vehicle ITS-S.
# *
# * @field rsuContainerHighFrequency: The mandatory high frequency container of CAM when the type of the originating ITS-S is RSU ITS-S.
# */
# HighFrequencyContainer ::= CHOICE {
# 	basicVehicleContainerHighFrequency BasicVehicleContainerHighFrequency,
# 	rsuContainerHighFrequency          RSUContainerHighFrequency,
# 	...
# }
# ------------------------------------------------------------------------------

uint8 choice

BasicVehicleContainerHighFrequency basic_vehicle_container_high_frequency
uint8 CHOICE_BASIC_VEHICLE_CONTAINER_HIGH_FREQUENCY = 0

RSUContainerHighFrequency rsu_container_high_frequency
uint8 CHOICE_RSU_CONTAINER_HIGH_FREQUENCY = 1


================================================================================
MSG: etsi_its_cam_ts_msgs/BasicVehicleContainerHighFrequency
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
#   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
#   -t
#   cam_ts
#   -o
#   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
# * This type contains detaild information of the Basic Vehicle Container High Frequency.
# *
# * It shall include the following components:
# *
# * @field heading: It represent the heading and heading accuracy of the vehicle movement of the originating ITS-S with regards to the true north. 
# * The heading accuracy provided in the heading Confidence value shall provide the accuracy of the measured vehicle heading with a confidence level 
# * of 95 %. Otherwise, the value of the headingConfidence shall be set to unavailable.
# *
# * @field speed: It represent driving speed and speed accuracy of the originating ITS-S. The speed accuracy provided in the speedConfidence shall 
# * provide the accuracy of the speed value with a confidence level of 95 %. Otherwise, the speedConfidence shall be set to unavailable.
# *
# * @field driveDirection: This component represent the vehicle drive direction (forward or backward) of the originating ITS-S.
# *
# * @field vehicleLength: This component represent the vehicle length value and vehicle length confidence indication of the vehicle ITS-S that 
# * originate the CAM. 
# *
# * @field vehicleWidth: This component represents the Vehicle Width of the vehicle ITS-S that originates the CAM excluding side mirrors and possible
# * similar extensions.
# *
# * @field longitudinalAcceleration: It represent the vehicle Longitudinal Acceleration of the originating ITS-S in the centre of the mass of the 
# * empty vehicle. It shall include the measured vehicle longitudinal acceleration and its accuracy value with the confidence level of 95 %. 
# * Otherwise, the longitudinalAccelerationConfidence shall be set to unavailable. 
# *
# * @field curvature: this component reppresent the actual trajectory of the vehicle. 
# *
# * @field curvatureCalculationMode: It indicates whether vehicle yaw-rate is used in the calculation of the curvature of the vehicle ITS-S that
# * originates the CAM.
# *
# * @field yawRate: It denotes the vehicle rotation around the centre of mass of the empty vehicle. The leading sign denotes the direction of 
# * rotation. The value is negative if the motion is clockwise when viewing from the top.
# * yawRateConfidence denotes the accuracy for the 95 % confidence level for the measured yawRateValue. Otherwise, the value of yawRateConfidence
# * shall be set to unavailable.
# *
# * @field accelerationControl: an optional component which represents the current status of the vehcile mechnanisms controlling the longitudinal movement of the vehcile ITS-S
# * (e.g. brake pedal,  gas pedal, etc. engaged) that originate the CAM.
# *
# * @field lanePosition: an optional component which represents the lanePosition of the referencePosition of a vehicle. This component shall be present if the data is 
# * available at the originating ITS-S.
# *
# * @field steeringWheelAngle: an optional component which indicates the steering wheel angle and accuracy as measured at the vehicle ITS-S that originates the CAM.
# *
# * @field lateralAcceleration: an optional component which represents the vehicle lateral acceleration of the originating ITS-S in the centre of the mass of the empty vehicle. 
# * It shall include the measured vehicle lateral acceleration and its accuracy value with the confidence level of 95%.
# *
# * @field verticalAcceleration: an optional component which indicates the originating ITS-S in the centre of the mass of the empty vehicle.
# * 
# * @field performanceClass: an optional component characterizes the maximum age of the CAM data elements with regard to the generation delta time.
# *
# * @field cenDsrcTollingZone: an optional component which represents the information about the position of a CEN DSRC Tolling Station operating in the 5,8 GHz frequency band.
# */
# BasicVehicleContainerHighFrequency ::= SEQUENCE {
# 	heading Heading,
# 	speed Speed,
# 	driveDirection DriveDirection,
# 	vehicleLength VehicleLength,
# 	vehicleWidth VehicleWidth,
# 	longitudinalAcceleration AccelerationComponent,
# 	curvature Curvature,
# 	curvatureCalculationMode CurvatureCalculationMode,
# 	yawRate YawRate,
# 	accelerationControl AccelerationControl OPTIONAL,
# 	lanePosition LanePosition OPTIONAL,
# 	steeringWheelAngle SteeringWheelAngle OPTIONAL,
# 	lateralAcceleration AccelerationComponent OPTIONAL,
# 	verticalAcceleration AccelerationComponent OPTIONAL,
# 	performanceClass PerformanceClass OPTIONAL,
# 	cenDsrcTollingZone CenDsrcTollingZone OPTIONAL
# }
# ------------------------------------------------------------------------------

Heading heading

Speed speed

DriveDirection drive_direction

VehicleLength vehicle_length

VehicleWidth vehicle_width

AccelerationComponent longitudinal_acceleration

Curvature curvature

CurvatureCalculationMode curvature_calculation_mode

YawRate yaw_rate

AccelerationControl acceleration_control
bool acceleration_control_is_present

LanePosition lane_position
bool lane_position_is_present

SteeringWheelAngle steering_wheel_angle
bool steering_wheel_angle_is_present

AccelerationComponent lateral_acceleration
bool lateral_acceleration_is_present

AccelerationComponent vertical_acceleration
bool vertical_acceleration_is_present

PerformanceClass performance_class
bool performance_class_is_present

CenDsrcTollingZone cen_dsrc_tolling_zone
bool cen_dsrc_tolling_zone_is_present


================================================================================
MSG: etsi_its_cam_ts_msgs/Heading
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
#   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
#   -t
#   cam_ts
#   -o
#   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DF represents the Heading in a WGS84 co-ordinates system.
#  * The specific WGS84 coordinate system is specified by the corresponding standards applying this DE.
#  *
#  * It shall include the following components: 
#  * 
#  * @field headingValue: the heading value.
#  * 
#  * @field headingConfidence: the confidence value of the heading value with a predefined confidence level.
#  * 
#  * @note: this DF is kept for backwards compatibility reasons only. It is recommended to use the @ref Wgs84Angle instead. 
#  * @category: Kinematic Information
#  * @revision: Description revised in V2.1.1
#  */
# Heading ::= SEQUENCE {
#     headingValue         HeadingValue,
#     headingConfidence    HeadingConfidence
# }
# ------------------------------------------------------------------------------

HeadingValue heading_value

HeadingConfidence heading_confidence


================================================================================
MSG: etsi_its_cam_ts_msgs/HeadingValue
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
#   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
#   -t
#   cam_ts
#   -o
#   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE represents the orientation of the horizontal velocity vector with regards to the WGS84 north.
#  * When the information is not available, the DE shall be set to 3 601. The value 3600 shall not be used.
#  *
#  * @note: this DE is kept for backwards compatibility reasons only. It is recommended to use the @ref Wgs84AngleValue instead. 
#  *
#  * Unit: 0,1 degree
#  * Categories: GeoReference information
#  * @revision: Description revised in V2.1.1 (usage of value 3600 specified) 
# */
# HeadingValue ::= INTEGER { 
#     wgs84North  (0),
#     wgs84East   (900),
#     wgs84South  (1800),
#     wgs84West   (2700),
#     doNotUse    (3600),
#     unavailable (3601)
# } (0..3601)
# ------------------------------------------------------------------------------

uint16 value
uint16 MIN = 0
uint16 MAX = 3601
uint16 WGS84_NORTH = 0
uint16 WGS84_EAST = 900
uint16 WGS84_SOUTH = 1800
uint16 WGS84_WEST = 2700
uint16 DO_NOT_USE = 3600
uint16 UNAVAILABLE = 3601


================================================================================
MSG: etsi_its_cam_ts_msgs/HeadingConfidence
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
#   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
#   -t
#   cam_ts
#   -o
#   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE indicates the heading confidence value which represents the estimated absolute accuracy of a heading value with a confidence level of 95 %.
#  * 
#  * The value shall be set to:
#  * - `n` (`n > 0` and `n < 126`) if the confidence value is equal to or less than n x 0,1 degree and more than (n-1) x 0,1 degree,
#  * - `126` if the confidence value is out of range, i.e. greater than 12,5 degrees,
#  * - `127` if the confidence value information is not available.
#  * 
#  * @note:	The fact that a value is received with confidence value set to `unavailable(127)` can be caused by several reasons,
#  * such as:
#  * - the sensor cannot deliver the accuracy at the defined confidence level because it is a low-end sensor,
#  * - the sensor cannot calculate the accuracy due to lack of variables, or
#  * - there has been a vehicle bus (e.g. CAN bus) error.
#  * In all 3 cases above, the heading value may be valid and used by the application.
#  *
#  * @note: If a heading value is received and its confidence value is set to `outOfRange(126)`, it means that the 
#  * heading value is not valid and therefore cannot be trusted. Such value is not useful for the application.
#  * @note: this DE is kept for backwards compatibility reasons only. It is recommended to use the @ref Wgs84AngleConfidence instead. 
#  * 
#  * @unit: 0,1 degree
#  * @category: GeoReference information
#  * @revision: Description revised in V2.1.1
#  */
# HeadingConfidence ::= INTEGER {
#     outOfRange  (126), 
#     unavailable (127)  
# } (1..127)
# ------------------------------------------------------------------------------

uint8 value
uint8 MIN = 1
uint8 MAX = 127
uint8 OUT_OF_RANGE = 126
uint8 UNAVAILABLE = 127


================================================================================
MSG: etsi_its_cam_ts_msgs/Speed
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
#   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
#   -t
#   cam_ts
#   -o
#   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DF represents the speed and associated confidence value.
#  *
#  * It shall include the following components: 
#  * 
#  * @field speedValue: the speed value.
#  * 
#  * @field speedConfidence: the confidence value of the speed value.
#  *
#  * @category: Kinematic information
#  * @revision: V1.3.1
#  */
# Speed ::= SEQUENCE {
#     speedValue         SpeedValue,
#     speedConfidence    SpeedConfidence
# }
# ------------------------------------------------------------------------------

SpeedValue speed_value

SpeedConfidence speed_confidence


================================================================================
MSG: etsi_its_cam_ts_msgs/SpeedValue
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
#   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
#   -t
#   cam_ts
#   -o
#   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE represents a speed value, i.e. the magnitude of the velocity-vector. 
#  *
#  * The value shall be set to:
#  * - `0` in a standstill situation.
#  * - `n` (`n > 0` and `n < 16 382`) if the applicable value is equal to or less than n x 0,01 m/s, and greater than (n-1) x 0,01 m/s,
#  * - `16 382` for speed values greater than 163,81 m/s,
#  * - `16 383` if the speed accuracy information is not available.
#  * 
#  * @note: the definition of standstill is out of scope of the present document.
#  *
#  * @unit: 0,01 m/s
#  * @category: Kinematic information
#  * @revision: Description revised in V2.1.1 (the meaning of 16382 has changed slightly) 
# */
# SpeedValue ::= INTEGER {
#     standstill  (0), 
#     outOfRange  (16382), 
#     unavailable (16383)
# } (0..16383)
# ------------------------------------------------------------------------------

uint16 value
uint16 MIN = 0
uint16 MAX = 16383
uint16 STANDSTILL = 0
uint16 OUT_OF_RANGE = 16382
uint16 UNAVAILABLE = 16383


================================================================================
MSG: etsi_its_cam_ts_msgs/SpeedConfidence
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
#   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
#   -t
#   cam_ts
#   -o
#   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE indicates the speed confidence value which represents the estimated absolute accuracy of a speed value with a default confidence level of 95 %.
#  * If required, the confidence level can be defined by the corresponding standards applying this DE.
#  * 
#  * The value shall be set to:
#  * - `n` (`n > 0` and `n < 126`) if the confidence value is equal to or less than n * 0,01 m/s.
#  * - `126` if the confidence value is out of range, i.e. greater than 1,25 m/s,
#  * - `127` if the confidence value information is not available.
#  *  
#  * @note: The fact that a speed value is received with confidence value set to `unavailable(127)` can be caused by several reasons, such as:
#  * - the sensor cannot deliver the accuracy at the defined confidence level because it is a low-end sensor,
#  * - the sensor cannot calculate the accuracy due to lack of variables, or
#  * - there has been a vehicle bus (e.g. CAN bus) error.
#  * In all 3 cases above, the speed value may be valid and used by the application.
#  * 
#  * @note: If a speed value is received and its confidence value is set to `outOfRange(126)`, it means that the speed value is not valid 
#  * and therefore cannot be trusted. Such is not useful for the application.
#  *
#  * @unit: 0,01 m/s
#  * @category: Vehicle information
#  * @revision: Description revised in V2.1.1 
#  */
# SpeedConfidence ::= INTEGER {
#     outOfRange  (126), 
#     unavailable (127)
# } (1..127)
# ------------------------------------------------------------------------------

uint8 value
uint8 MIN = 1
uint8 MAX = 127
uint8 OUT_OF_RANGE = 126
uint8 UNAVAILABLE = 127


================================================================================
MSG: etsi_its_cam_ts_msgs/DriveDirection
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
#   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
#   -t
#   cam_ts
#   -o
#   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE indicates in which direction something is moving.
#  *
#  * The value shall be set to:
#  * - 0 - `forward`     - to indicate it is moving forward,
#  * - 1 - `backwards`   - to indicate it is moving backwards,
#  * - 2 - `unavailable` - to indicate that the information is unavailable.
#  *
#  * @category: Kinematic information
#  * @revision: editorial update in V2.1.1
#  */
# DriveDirection ::= ENUMERATED {
#     forward     (0), 
#     backward    (1), 
#     unavailable (2)
# }
# ------------------------------------------------------------------------------

uint8 value
uint8 FORWARD = 0
uint8 BACKWARD = 1
uint8 UNAVAILABLE = 2


================================================================================
MSG: etsi_its_cam_ts_msgs/VehicleLength
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
#   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
#   -t
#   cam_ts
#   -o
#   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DF represents the length of vehicle and accuracy indication information.
#  *
#  * It shall include the following components: 
#  * 
#  * @field vehicleLengthValue: length of vehicle. 
#  * 
#  * @field vehicleLengthConfidenceIndication: indication of the length value confidence.
#  * 
#  * @note: this DF is kept for backwards compatibility reasons only. It is recommended to use @ref VehicleLengthV2 instead.
#  * @category: Vehicle information
#  * @revision: V1.3.1
#  */
# VehicleLength ::= SEQUENCE {
#     vehicleLengthValue                   VehicleLengthValue,
#     vehicleLengthConfidenceIndication    VehicleLengthConfidenceIndication
# }
# ------------------------------------------------------------------------------

VehicleLengthValue vehicle_length_value

VehicleLengthConfidenceIndication vehicle_length_confidence_indication


================================================================================
MSG: etsi_its_cam_ts_msgs/VehicleLengthValue
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
#   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
#   -t
#   cam_ts
#   -o
#   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE represents the length of a vehicle.
#  *
#  * The value shall be set to:
#  * - `n` (`n > 0` and `n < 1022`) to indicate the applicable value n is equal to or less than n x 0,1 metre, and greater than (n-1) x 0,1 metre,
#  * - `1 022` to indicate that the vehicle length is greater than 102.1 metres,
#  * - `1 023` to indicate that the information in unavailable.
#  * 
#  * 
#  * @unit: 0,1 metre
#  * @category: Vehicle information
#  * @revision: Description updated in V2.1.1 (the meaning of 1 022 has changed slightly).
#  */
# VehicleLengthValue ::= INTEGER {
#     outOfRange(1022), 
#     unavailable(1023)
# }  (1..1023)
# ------------------------------------------------------------------------------

uint16 value
uint16 MIN = 1
uint16 MAX = 1023
uint16 OUT_OF_RANGE = 1022
uint16 UNAVAILABLE = 1023


================================================================================
MSG: etsi_its_cam_ts_msgs/VehicleLengthConfidenceIndication
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
#   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
#   -t
#   cam_ts
#   -o
#   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE provides information about the presence of a trailer. 
#  *
#  * The value shall be set to:
#  * - 0 `noTrailerPresent`                - to indicate that no trailer is present, i.e. either the vehicle is physically not enabled to tow a trailer or it has been detected that no trailer is present,
#  * - 1 `trailerPresentWithKnownLength`   - to indicate that a trailer has been detected as present and the length is  included in the vehicle length value,
#  * - 2 `trailerPresentWithUnknownLength` - to indicate that a trailer has been detected as present and the length is not included in the vehicle length value,
#  * - 3 `trailerPresenceIsUnknown`        - to indicate that information about the trailer presence is unknown, i.e. the vehicle is physically enabled to tow a trailer but the detection of trailer presence/absence is not possible,
#  * - 4 `unavailable`                     - to indicate that the information about the presence of a trailer is not available, i.e. it is neither known whether the vehicle is able to tow a trailer, 
#  *                                        nor the detection of trailer presence/absence is possible.
#  * 
#  * @note: this DE is kept for backwards compatibility reasons only. It is recommended to use the @ref TrailerPresenceInformation instead. 
#  * @category: Vehicle information
#  * @revision: Description revised in V2.1.1
# */
# VehicleLengthConfidenceIndication ::= ENUMERATED {
#     noTrailerPresent                (0), 
#     trailerPresentWithKnownLength   (1), 
#     trailerPresentWithUnknownLength (2), 
#     trailerPresenceIsUnknown        (3), 
#     unavailable                     (4)
# }
# ------------------------------------------------------------------------------

uint8 value
uint8 NO_TRAILER_PRESENT = 0
uint8 TRAILER_PRESENT_WITH_KNOWN_LENGTH = 1
uint8 TRAILER_PRESENT_WITH_UNKNOWN_LENGTH = 2
uint8 TRAILER_PRESENCE_IS_UNKNOWN = 3
uint8 UNAVAILABLE = 4


================================================================================
MSG: etsi_its_cam_ts_msgs/VehicleWidth
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
#   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
#   -t
#   cam_ts
#   -o
#   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE represents the width of a vehicle, excluding side mirrors and possible similar extensions.
# 
#  * The value shall be set to:
#  * - `n` (`n > 0` and `n < 61`) indicates the applicable value is equal to or less than n x 0,1 metre, and greater than (n-1) x 0,1 metre,
#  * - `61` indicates that the vehicle width is greater than 6,0 metres,
#  * - `62` indicates that the information in unavailable.
#  * 
#  * @unit: 0,1 metre
#  * @category: Vehicle information 
#  * @revision: Description updated in V2.1.1 (the meaning of 61 has changed slightly).
#  */
# VehicleWidth ::= INTEGER {
#     outOfRange  (61),  
#     unavailable (62)
# } (1..62)
# ------------------------------------------------------------------------------

uint8 value
uint8 MIN = 1
uint8 MAX = 62
uint8 OUT_OF_RANGE = 61
uint8 UNAVAILABLE = 62


================================================================================
MSG: etsi_its_cam_ts_msgs/AccelerationComponent
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
#   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
#   -t
#   cam_ts
#   -o
#   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /** 
#  * This DF represents an acceleration component along with a confidence value.
#  *
#  * It shall include the following components: 
#  *
#  * @field value: the value of the acceleration component which can be estimated as the mean of the current distribution.
#  *
#  * @field confidence: the confidence value associated to the provided value.
#  *
#  * @category: Kinematic Information
#  * @revision: Created in V2.1.1
#  */
# AccelerationComponent ::= SEQUENCE {
#     value         AccelerationValue,
#     confidence    AccelerationConfidence
# }
# ------------------------------------------------------------------------------

AccelerationValue value

AccelerationConfidence confidence


================================================================================
MSG: etsi_its_cam_ts_msgs/AccelerationValue
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
#   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
#   -t
#   cam_ts
#   -o
#   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /** 
#  * This DE represents the value of an acceleration component in a defined coordinate system.
#  *
#  * The value shall be set to:
#  * - `-160` for acceleration values equal to or less than -16 m/s^2,
#  * - `n` (`n > -160` and `n <= 0`) to indicate negative acceleration equal to or less than n x 0,1 m/s^2, and greater than (n-1) x 0,1 m/s^2,
#  * - `n` (`n > 0` and `n < 160`) to indicate positive acceleration equal to or less than n x 0,1 m/s^2, and greater than (n-1) x 0,1 m/s^2,
#  * - `160` for acceleration values greater than 15,9 m/s^2,
#  * - `161` when the data is unavailable.
#  *
#  * @note: the formula for values > -160 and <160 results in rounding up to the next value. Zero acceleration is indicated using n=0.
#  * @unit 0,1 m/s^2
#  * @category: Kinematic information
#  * @revision: Created in V2.1.1
# */
# AccelerationValue ::= INTEGER {
#     negativeOutOfRange (-160),
#     positiveOutOfRange (160),
#     unavailable        (161)  
# } (-160 .. 161)
# ------------------------------------------------------------------------------

int16 value
int16 MIN = -160
int16 MAX = 161
int16 NEGATIVE_OUT_OF_RANGE = -160
int16 POSITIVE_OUT_OF_RANGE = 160
int16 UNAVAILABLE = 161


================================================================================
MSG: etsi_its_cam_ts_msgs/AccelerationConfidence
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
#   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
#   -t
#   cam_ts
#   -o
#   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE indicates the acceleration confidence value which represents the estimated absolute accuracy of an acceleration value with a default confidence level of 95 %. 
#  * If required, the confidence level can be defined by the corresponding standards applying this DE.
#  *
#  * The value shall be set to:
#  * - `n` (`n > 0` and `n < 101`) if the confidence value is equal to or less than n x 0,1 m/s^2, and greater than (n-1) x 0,1 m/s^2,
#  * - `101` if the confidence value is out of range i.e. greater than 10 m/s^2,
#  * - `102` if the confidence value is unavailable.
#  *
#  * The value 0 shall not be used.
#  *
#  * @note: The fact that an acceleration value is received with confidence value set to `unavailable(102)` can be caused by several reasons, such as:
#  * - the sensor cannot deliver the accuracy at the defined confidence level because it is a low-end sensor,
#  * - the sensor cannot calculate the accuracy due to lack of variables, or
#  * - there has been a vehicle bus (e.g. CAN bus) error.
#  * In all 3 cases above, the acceleration value may be valid and used by the application.
#  * 
#  * @note: If an acceleration value is received and its confidence value is set to `outOfRange(101)`, it means that the value is not valid and therefore cannot be trusted. Such value is not useful for the application.
#  *
#  * @unit 0,1 m/s^2
#  * @category: Kinematic information
#  * @revision: Description revised in V2.1.1
#  */
# AccelerationConfidence ::= INTEGER {
#     outOfRange                 (101), 
#     unavailable                (102)
# } (0..102)
# ------------------------------------------------------------------------------

uint8 value
uint8 MIN = 0
uint8 MAX = 102
uint8 OUT_OF_RANGE = 101
uint8 UNAVAILABLE = 102


================================================================================
MSG: etsi_its_cam_ts_msgs/Curvature
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
#   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
#   -t
#   cam_ts
#   -o
#   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DF represents the curvature of the vehicle trajectory and the associated confidence value.
#  * The curvature detected by a vehicle represents the curvature of actual vehicle trajectory.
#  *
#  * It shall include the following components: 
#  * 
#  * @field curvatureValue: Detected curvature of the vehicle trajectory.
#  * 
#  * @field curvatureConfidence: along with a confidence value of the curvature value with a predefined confidence level. 
#  * 
#  * @category: Vehicle information
#  * @revision: Description revised in V2.1.1
#  */
# Curvature ::= SEQUENCE {
#     curvatureValue         CurvatureValue,
#     curvatureConfidence    CurvatureConfidence
# }
# ------------------------------------------------------------------------------

CurvatureValue curvature_value

CurvatureConfidence curvature_confidence


================================================================================
MSG: etsi_its_cam_ts_msgs/CurvatureValue
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
#   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
#   -t
#   cam_ts
#   -o
#   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE describes vehicle turning curve with the following information:
#  * ```
#  *     Value = 1 / Radius * 10000
#  * ```
#  * wherein radius is the vehicle turning curve radius in metres. 
#  * 
#  * Positive values indicate a turning curve to the left hand side of the driver.
#  * It corresponds to the vehicle coordinate system as defined in ISO 8855 [21].
#  *
#  * The value shall be set to:
#  * - `-1023` for  values smaller than -1023,
#  * - `n` (`n > -1023` and `n < 0`) for negative values equal to or less than `n`, and greater than `(n-1)`,
#  * - `0` when the vehicle is moving straight,
#  * - `n` (`n > 0` and `n < 1022`) for positive values equal to or less than `n`, and greater than `(n-1)`,
#  * - `1022`, for values  greater than 1021,
#  * - `1023`, if the information is not available.
#  * 
#  * @note: The present DE is limited to vehicle types as defined in ISO 8855 [21].
#  * 
#  * @unit: 1 over 10 000 metres
#  * @category: Vehicle information
#  * @revision: description revised in V2.1.1 (the definition of value 1022 has changed slightly)
#  */
# CurvatureValue ::= INTEGER {
#     outOfRangeNegative (-1023),
#     straight           (0),
#     outOfRangePositive (1022), 
#     unavailable        (1023)
# } (-1023..1023)
# ------------------------------------------------------------------------------

int16 value
int16 MIN = -1023
int16 MAX = 1023
int16 OUT_OF_RANGE_NEGATIVE = -1023
int16 STRAIGHT = 0
int16 OUT_OF_RANGE_POSITIVE = 1022
int16 UNAVAILABLE = 1023


================================================================================
MSG: etsi_its_cam_ts_msgs/CurvatureConfidence
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
#   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
#   -t
#   cam_ts
#   -o
#   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE indicates the acceleration confidence value which represents the estimated absolute accuracy range of a curvature value with a confidence level of 95 %.
#  * If required, the confidence level can be defined by the corresponding standards applying this DE.
#  * 
#  * The value shall be set to:
#  * - 0 - `onePerMeter-0-00002` - if the confidence value is less than or equal to 0,00002 m-1,
#  * - 1 - `onePerMeter-0-0001`  - if the confidence value is less than or equal to 0,0001 m-1 and greater than 0,00002 m-1,
#  * - 2 - `onePerMeter-0-0005`  - if the confidence value is less than or equal to 0,0005 m-1 and greater than 0,0001 m-1,
#  * - 3 - `onePerMeter-0-002`   - if the confidence value is less than or equal to 0,002 m-1 and greater than 0,0005 m-1,
#  * - 4 - `nePerMeter-0-01`     - if the confidence value is less than or equal to 0,01 m-1 and greater than 0,002 m-1,
#  * - 5 - `nePerMeter-0-1`      - if the confidence value is less than or equal to 0,1 m-1  and greater than 0,01 m-1,
#  * - 6 - `outOfRange`          - if the confidence value is out of range, i.e. greater than 0,1 m-1,
#  * - 7 - `unavailable`         - if the confidence value is not available.
#  * 
#  * @note:	The fact that a curvature value is received with confidence value set to `unavailable(7)` can be caused by
#  * several reasons, such as:
#  * - the sensor cannot deliver the accuracy at the defined confidence level because it is a low-end sensor,
#  * - the sensor cannot calculate the accuracy due to lack of variables, or
#  * - there has been a vehicle bus (e.g. CAN bus) error.
#  * In all 3 cases above, the curvature value may be valid and used by the application.
#  * 
#  * @note: If a curvature value is received and its confidence value is set to `outOfRange(6)`, it means that the curvature value is not valid 
#  * and therefore cannot be trusted. Such value is not useful for the application.
#  * 
#  * @category: Vehicle information
#  * @revision: Description revised in V2.1.1
# */
# CurvatureConfidence ::= ENUMERATED {
#     onePerMeter-0-00002 (0),
#     onePerMeter-0-0001  (1),
#     onePerMeter-0-0005  (2),
#     onePerMeter-0-002   (3),
#     onePerMeter-0-01    (4),
#     onePerMeter-0-1     (5),
#     outOfRange          (6),
#     unavailable         (7)
# }
# ------------------------------------------------------------------------------

uint8 value
uint8 ONE_PER_METER_0_00002 = 0
uint8 ONE_PER_METER_0_0001 = 1
uint8 ONE_PER_METER_0_0005 = 2
uint8 ONE_PER_METER_0_002 = 3
uint8 ONE_PER_METER_0_01 = 4
uint8 ONE_PER_METER_0_1 = 5
uint8 OUT_OF_RANGE = 6
uint8 UNAVAILABLE = 7


================================================================================
MSG: etsi_its_cam_ts_msgs/CurvatureCalculationMode
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
#   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
#   -t
#   cam_ts
#   -o
#   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * The DE describes whether the yaw rate is used to calculate the curvature for a curvature value.
#  * 
#  * The value shall be set to:
#  * - 0 - `yawRateUsed`    - if the yaw rate is used,
#  * - 1 - `yawRateNotUsed` - if the yaw rate is not used,
#  * - 2 - `unavailable`    - if the information of curvature calculation mode is unknown.
#  *
#  * @category: Vehicle information
#  * @revision: V1.3.1
#  */
# CurvatureCalculationMode ::= ENUMERATED {
#     yawRateUsed    (0), 
#     yawRateNotUsed (1), 
#     unavailable    (2), 
#     ...
# }
# ------------------------------------------------------------------------------

uint8 value
uint8 YAW_RATE_USED = 0
uint8 YAW_RATE_NOT_USED = 1
uint8 UNAVAILABLE = 2


================================================================================
MSG: etsi_its_cam_ts_msgs/YawRate
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
#   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
#   -t
#   cam_ts
#   -o
#   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DF represents a yaw rate of vehicle at a point in time.
#  *
#  * It shall include the following components: 
#  * 
#  * @field yawRateValue: yaw rate value at a point in time.
#  * 
#  * @field yawRateConfidence: confidence value associated to the yaw rate value.
#  * 
#  * @category: Vehicle Information
#  * @revision: V1.3.1
#  */
# YawRate::= SEQUENCE {
#     yawRateValue         YawRateValue,
#     yawRateConfidence    YawRateConfidence
# }
# ------------------------------------------------------------------------------

YawRateValue yaw_rate_value

YawRateConfidence yaw_rate_confidence


================================================================================
MSG: etsi_its_cam_ts_msgs/YawRateValue
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
#   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
#   -t
#   cam_ts
#   -o
#   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE represents the vehicle rotation around z-axis of the coordinate system centred on the centre of mass of the empty-loaded
#  * vehicle. The leading sign denotes the direction of rotation.
#  * 
#  * The value shall be provided in the vehicle coordinate system as defined in ISO 8855 [21], clause 2.11.
#  *
#  * The value shall be set to:
#  * - `-32 766` to indicate that the yaw rate is equal to or greater than 327,66 degrees/second to the right,
#  * - `n` (`n > -32 766` and `n <= 0`) to indicate that the rotation is clockwise (i.e. to the right) and is equal to or less than n x 0,01 degrees/s, 
#       and greater than (n-1) x 0,01 degrees/s,
#  * - `n` (`n > 0` and `n < 32 766`) to indicate that the rotation is anti-clockwise (i.e. to the left) and is equal to or less than n x 0,01 degrees/s, 
#       and greater than (n-1) x 0,01 degrees/s,
#  * - `32 766` to indicate that the yaw rate is greater than 327.65 degrees/second to the left,
#  * - `32 767` to indicate that the information is not available.
#  * 
#  * The yaw rate value shall be a raw data value, i.e. not filtered, smoothed or otherwise modified.
#  * The reading instant should be the same as for the vehicle acceleration.
#  * 
#  * @note: The empty load vehicle is defined in ISO 1176 [8], clause 4.6.
#  * 
#  * @unit: 0,01 degree per second. 
#  * @category: Vehicle Information
#  * @revision: Desription revised in V2.1.1 (the meaning of 32766 has changed slightly). 
# */
# YawRateValue ::= INTEGER {
#     negativeOutOfRange (-32766), 
#     positiveOutOfRange (32766), 
#     unavailable        (32767)
# } (-32766..32767)
# ------------------------------------------------------------------------------

int16 value
int16 MIN = -32766
int16 MAX = 32767
int16 NEGATIVE_OUT_OF_RANGE = -32766
int16 POSITIVE_OUT_OF_RANGE = 32766
int16 UNAVAILABLE = 32767


================================================================================
MSG: etsi_its_cam_ts_msgs/YawRateConfidence
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
#   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
#   -t
#   cam_ts
#   -o
#   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE indicates the yaw rate confidence value which represents the estimated accuracy for a yaw rate value with a default confidence level of 95 %.
#  * If required, the confidence level can be defined by the corresponding standards applying this DE.
#  * 
#  * The value shall be set to:
#  * - `0` if the confidence value is equal to or less than 0,01 degree/second,
#  * - `1` if the confidence value is equal to or less than 0,05 degrees/second or greater than 0,01 degree/second,
#  * - `2` if the confidence value is equal to or less than 0,1 degree/second or greater than 0,05 degree/second,
#  * - `3` if the confidence value is equal to or less than 1 degree/second or greater than 0,1 degree/second,
#  * - `4` if the confidence value is equal to or less than 5 degrees/second or greater than 1 degrees/second,
#  * - `5` if the confidence value is equal to or less than 10 degrees/second or greater than 5 degrees/second,
#  * - `6` if the confidence value is equal to or less than 100 degrees/second or greater than 10 degrees/second,
#  * - `7` if the confidence value is out of range, i.e. greater than 100 degrees/second,
#  * - `8` if the confidence value is unavailable.
#  * 
#  * NOTE: The fact that a yaw rate value is received with confidence value set to `unavailable(8)` can be caused by
#  * several reasons, such as:
#  * - the sensor cannot deliver the accuracy at the defined confidence level because it is a low-end sensor,
#  * - the sensor cannot calculate the accuracy due to lack of variables, or
#  * - there has been a vehicle bus (e.g. CAN bus) error.
#  * In all 3 cases above, the yaw rate value may be valid and used by the application.
#  * 
#  * If a yaw rate value is received and its confidence value is set to `outOfRange(7)`, it means that the 
#  * yaw rate value is not valid and therefore cannot be trusted. Such value is not useful the application.
#  * 
#  * @category: Vehicle information
#  * @revision: Description revised in V2.1.1
#  */
# YawRateConfidence ::= ENUMERATED {
#     degSec-000-01 (0),
#     degSec-000-05 (1),
#     degSec-000-10 (2),
#     degSec-001-00 (3), 
#     degSec-005-00 (4),
#     degSec-010-00 (5),
#     degSec-100-00 (6),
#     outOfRange    (7),
#     unavailable   (8)
# }
# ------------------------------------------------------------------------------

uint8 value
uint8 DEG_SEC_000_01 = 0
uint8 DEG_SEC_000_05 = 1
uint8 DEG_SEC_000_10 = 2
uint8 DEG_SEC_001_00 = 3
uint8 DEG_SEC_005_00 = 4
uint8 DEG_SEC_010_00 = 5
uint8 DEG_SEC_100_00 = 6
uint8 OUT_OF_RANGE = 7
uint8 UNAVAILABLE = 8


================================================================================
MSG: etsi_its_cam_ts_msgs/AccelerationControl
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
#   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
#   -t
#   cam_ts
#   -o
#   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE indicates the current controlling mechanism for longitudinal movement of the vehicle.
#  * The data may be provided via the in-vehicle network. It indicates whether a specific in-vehicle
#  * acceleration control system is engaged or not. Currently, this DE includes the information of the
#  * vehicle brake pedal, gas pedal, emergency brake system, collision warning system, adaptive cruise
#  * control system, cruise control system and speed limiter system.
#  *
#  * The corresponding bit shall be set to 1 under the following conditions:
#  * - 0 - `brakePedalEngaged`      - Driver is stepping on the brake pedal,
#  * - 1 - `gasPedalEngaged`        - Driver is stepping on the gas pedal,
#  * - 2 - `emergencyBrakeEngaged`  - emergency brake system is engaged,
#  * - 3 - `collisionWarningEngaged`- collision warning system is engaged,
#  * - 4 - `accEngaged`             - ACC is engaged,
#  * - 5 - `cruiseControlEngaged`   - cruise control is engaged,
#  * - 6 - `speedLimiterEngaged`    - speed limiter is engaged.
#  *
#  * Otherwise (for example when the corresponding system is not available due to non equipped system
#  * or information is unavailable), the corresponding bit shall be set to 0.
#  *
#  * @note: The system engagement condition is OEM specific and therefore out of scope of the present document.
#  * @category: Vehicle information
#  * @revision: V1.3.1
#  */
# AccelerationControl ::= BIT STRING {
#     brakePedalEngaged       (0),
#     gasPedalEngaged         (1),
#     emergencyBrakeEngaged   (2),
#     collisionWarningEngaged (3),
#     accEngaged              (4),
#     cruiseControlEngaged    (5),
#     speedLimiterEngaged     (6)
# } (SIZE(7))
# ------------------------------------------------------------------------------

uint8[] value
uint8 bits_unused
uint8 SIZE_BITS = 7
uint8 BIT_INDEX_BRAKE_PEDAL_ENGAGED = 0
uint8 BIT_INDEX_GAS_PEDAL_ENGAGED = 1
uint8 BIT_INDEX_EMERGENCY_BRAKE_ENGAGED = 2
uint8 BIT_INDEX_COLLISION_WARNING_ENGAGED = 3
uint8 BIT_INDEX_ACC_ENGAGED = 4
uint8 BIT_INDEX_CRUISE_CONTROL_ENGAGED = 5
uint8 BIT_INDEX_SPEED_LIMITER_ENGAGED = 6


================================================================================
MSG: etsi_its_cam_ts_msgs/LanePosition
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
#   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
#   -t
#   cam_ts
#   -o
#   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE indicates a transversal position on the carriageway at a specific longitudinal position, in resolution of lanes of the carriageway. 
#  *
#  * For right-hand traffic roads, the value shall be set to:
#  * - `-1` if the position is off, i.e. besides the road,
#  * - `0` if the position is on the inner hard shoulder, i.e. the hard should adjacent to the leftmost lane,
#  * - `n` (`n > 0` and `n < 14`), if the position is on the n-th driving lane counted from the leftmost lane to the rightmost lane of a specific traffic direction,
#  * - `14` if the position is on the outer hard shoulder, i.e. the hard should adjacent to rightmost lane (if present).
#  *
#  * For left-hand traffic roads, the value shall be set to:
#  * - `-1` if the position is off, i.e. besides the road,
#  * - `0` if the position is on the inner hard shoulder, i.e. the hard should adjacent to the rightmost lane,
#  * - `n` (`n > 0` and `n < 14`), if the position is on the n-th driving lane counted from the rightmost lane to the leftmost lane of a specific traffic direction,
#  * - `14` if the position is on the outer hard shoulder, i.e. the hard should adjacent to leftmost lane (if present).
#  *
#  *  @note: in practice this means that the position is counted from "inside" to "outside" no matter which traffic practice is used.
#  *
#  * If the carriageway allows only traffic in one direction (e.g. in case of dual or multiple carriageway roads), the position is counted from the physical border of the carriageway. 
#  * If the carriageway allows traffic in both directions and there is no physical delimitation between traffic directions (e.g. on a single carrriageway road), 
#  * the position is counted from the legal (i.e. optical) separation between traffic directions (horizontal marking). 
#  *
#  * If not indicated otherwise (by lane markings or traffic signs), the legal separation on carriageways allowing traffic on both directions is identified as follows:
#  * - If the total number of lanes N is even, the lanes are divided evenly between the traffic directions starting from the outside of the carriageway on both sides and the 
#  *   imaginary separation between traffic directions is on the border between the even number of lanes N/2.
#  * - If the total number of lanes N is odd, the lanes are divided evenly between traffic direction starting from the outside of the carriageway on both sides. 
#  *   The remaining middle lane is assigned to both traffic directions as innermost lane.
#  *
#  * @category: Road topology information
#  * @revision: Description of the legal separation of carriageways added in V2.2.1
# */
# LanePosition ::= INTEGER {
#     offTheRoad           (-1), 
#     innerHardShoulder    (0), 
#     outerHardShoulder    (14) 
# } (-1..14)
# ------------------------------------------------------------------------------

int8 value
int8 MIN = -1
int8 MAX = 14
int8 OFF_THE_ROAD = -1
int8 INNER_HARD_SHOULDER = 0
int8 OUTER_HARD_SHOULDER = 14


================================================================================
MSG: etsi_its_cam_ts_msgs/SteeringWheelAngle
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
#   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
#   -t
#   cam_ts
#   -o
#   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DF represents the steering wheel angle of the vehicle at certain point in time.
#  *
#  * It shall include the following components: 
#  * 
#  * @field steeringWheelAngleValue: steering wheel angle value.
#  * 
#  * @field steeringWheelAngleConfidence: confidence value of the steering wheel angle value.
#  * 
#  * @category: Vehicle information
#  * @revision: Created in V2.1.1
#  */
# SteeringWheelAngle ::= SEQUENCE {
#     steeringWheelAngleValue         SteeringWheelAngleValue,
#     steeringWheelAngleConfidence    SteeringWheelAngleConfidence
# }
# ------------------------------------------------------------------------------

SteeringWheelAngleValue steering_wheel_angle_value

SteeringWheelAngleConfidence steering_wheel_angle_confidence


================================================================================
MSG: etsi_its_cam_ts_msgs/SteeringWheelAngleValue
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
#   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
#   -t
#   cam_ts
#   -o
#   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE represents the steering wheel angle of the vehicle at certain point in time.
#  * The value shall be provided in the vehicle coordinate system as defined in ISO 8855 [21], clause 2.11.
#  * 
#  * The value shall be set to:
#  * - `-511` if the steering wheel angle is equal to or greater than 511 x 1,5 degrees = 766,5 degrees to the right,
#  * - `n` (`n > -511` and `n <= 0`) if  the steering wheel angle is equal to or less than n x 1,5 degrees, and greater than (n-1) x 1,5 degrees, 
#       turning clockwise (i.e. to the right),
#  * - `n` (`n >= 1` and `n < 511`) if the steering wheel angle is equal to or less than n x 0,1 degrees, and greater than (n-1) x 0,1 degrees, 
#       turning counter-clockwise (i.e. to the left),
#  * - `511` if the steering wheel angle is greater than 510 x 1,5 degrees = 765 degrees to the left,
#  * - `512` if information is not available.
#  *
#  * @unit: 1,5 degree
#  * @revision: Description revised in V2.1.1 (meaning of value 511 has changed slightly).
#  */
# SteeringWheelAngleValue ::= INTEGER { 
#     negativeOutOfRange (-511),
#     positiveOutOfRange (511),
#     unavailable        (512)
# } (-511..512)
# ------------------------------------------------------------------------------

int16 value
int16 MIN = -511
int16 MAX = 512
int16 NEGATIVE_OUT_OF_RANGE = -511
int16 POSITIVE_OUT_OF_RANGE = 511
int16 UNAVAILABLE = 512


================================================================================
MSG: etsi_its_cam_ts_msgs/SteeringWheelAngleConfidence
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
#   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
#   -t
#   cam_ts
#   -o
#   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE indicates the steering wheel angle confidence value which represents the estimated absolute accuracy for a  steering wheel angle value with a confidence level of 95 %.
#  * 
#  * The value shall be set to:
#  * - `n` (`n > 0` and `n < 126`) if the confidence value is equal to or less than n x 1,5 degrees,
#  * - `126` if the confidence value is out of range, i.e. greater than 187,5 degrees,
#  * - `127` if the confidence value is not available.
#  * 
#  * @note: The fact that a steering wheel angle value is received with confidence value set to `unavailable(127)`
#  * can be caused by several reasons, such as:
#  * - the sensor cannot deliver the accuracy at the defined confidence level because it is a low-end sensor,
#  * - the sensor cannot calculate the accuracy due to lack of variables, or
#  * - there has been a vehicle bus (e.g. CAN bus) error.
#  * In all 3 cases above, the steering wheel angle value may be valid and used by the application.
#  * 
#  * If a steering wheel angle value is received and its confidence value is set to `outOfRange(126)`,
#  * it means that the steering wheel angle value is not valid and therefore cannot be trusted.
#  * Such value is not useful for the application.
#  * 
#  * @unit: 1,5 degree
#  * @category: Vehicle Information
#  * @revision: Description revised in V2.1.1
# */
# SteeringWheelAngleConfidence ::= INTEGER {
#     outOfRange                      (126), 
#     unavailable                     (127)
# } (1..127)
# ------------------------------------------------------------------------------

uint8 value
uint8 MIN = 1
uint8 MAX = 127
uint8 OUT_OF_RANGE = 126
uint8 UNAVAILABLE = 127


================================================================================
MSG: etsi_its_cam_ts_msgs/PerformanceClass
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
#   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
#   -t
#   cam_ts
#   -o
#   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE denotes the ability of an ITS-S to provide up-to-date information.
#  * A performance class value is used to describe age of data. The exact values are out of scope of the present document.
#  * 
#  *  The value shall be set to:
#  * - `0` if  the performance class is unknown,
#  * - `1` for performance class A as defined in ETSI TS 101 539-1 [5],
#  * - `2` for performance class B as defined in ETSI TS 101 539-1 [5],
#  * -  3-7 reserved for future use.
#  *
#  * @category: Vehicle information
#  * @revision: Editorial update in V2.1.1
#  */
# PerformanceClass ::= INTEGER {
#     unavailable       (0), 
#     performanceClassA (1), 
#     performanceClassB (2)
# } (0..7)
# ------------------------------------------------------------------------------

uint8 value
uint8 MIN = 0
uint8 MAX = 7
uint8 UNAVAILABLE = 0
uint8 PERFORMANCE_CLASS_A = 1
uint8 PERFORMANCE_CLASS_B = 2


================================================================================
MSG: etsi_its_cam_ts_msgs/CenDsrcTollingZone
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
#   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
#   -t
#   cam_ts
#   -o
#   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * The DF describes the position of a CEN DSRC road side equipment.
#  *
#  * It shall include the following components: 
#  * 
#  * @field protectedZoneLatitude: the latitude of the CEN DSRC road side equipment.
#  * 
#  * @field protectedZoneLongitude: the latitude of the CEN DSRC road side equipment. 
#  * 
#  * @field cenDsrcTollingZoneID: the optional ID of the CEN DSRC road side equipment.
#  * 
#  * @category: Infrastructure information, Communication information
#  * @revision: revised in V2.1.1 (cenDsrcTollingZoneId is directly of type ProtectedZoneId)
#  */
# CenDsrcTollingZone ::= SEQUENCE {
#     protectedZoneLatitude     Latitude,
#     protectedZoneLongitude    Longitude,
#     cenDsrcTollingZoneId      ProtectedZoneId OPTIONAL,
#     ...
# }
# ------------------------------------------------------------------------------

Latitude protected_zone_latitude

Longitude protected_zone_longitude

ProtectedZoneId cen_dsrc_tolling_zone_id
bool cen_dsrc_tolling_zone_id_is_present


================================================================================
MSG: etsi_its_cam_ts_msgs/ProtectedZoneId
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
#   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
#   -t
#   cam_ts
#   -o
#   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE represents the indentifier of a protected communication zone.
#  * 
#  * 
#  * @category: Infrastructure information, Communication information
#  * @revision: Revision in V2.1.1 (changed name from ProtectedZoneID to ProtectedZoneId)
#  */
# ProtectedZoneId ::= INTEGER (0.. 134217727)
# ------------------------------------------------------------------------------

uint32 value
uint32 MIN = 0
uint32 MAX = 134217727


================================================================================
MSG: etsi_its_cam_ts_msgs/RSUContainerHighFrequency
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
#   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
#   -t
#   cam_ts
#   -o
#   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
# * This type contains detaild information of the RSU Container High Frequency.
# *
# * It shall include the following components:
# *
# * @field protectedCommunicationZonesRSU: an optional Information about position of a CEN DSRC Tolling Station operating in the 5,8 GHz frequency 
# * band. If this information is provided by RSUs a receiving vehicle ITS-S is prepared to adopt mitigation techniques when being in the vicinity of
# * CEN DSRC tolling stations. 
# 
# */
# RSUContainerHighFrequency ::= SEQUENCE {
# 	protectedCommunicationZonesRSU ProtectedCommunicationZonesRSU OPTIONAL,
# 	...
# }
# ------------------------------------------------------------------------------

ProtectedCommunicationZonesRSU protected_communication_zones_rsu
bool protected_communication_zones_rsu_is_present


================================================================================
MSG: etsi_its_cam_ts_msgs/ProtectedCommunicationZonesRSU
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
#   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
#   -t
#   cam_ts
#   -o
#   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DF shall contain a list of @ref ProtectedCommunicationZone provided by a road side ITS-S (Road Side Unit RSU).
#  *
#  * It may provide up to 16 protected communication zones information.
#  *
#  * @category: Infrastructure information, Communication information
#  * @revision: V1.3.1
#  */
# ProtectedCommunicationZonesRSU ::= SEQUENCE (SIZE(1..16)) OF ProtectedCommunicationZone 
# ------------------------------------------------------------------------------

ProtectedCommunicationZone[] array
uint8 MIN_SIZE = 1
uint8 MAX_SIZE = 16


================================================================================
MSG: etsi_its_cam_ts_msgs/ProtectedCommunicationZone
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
#   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
#   -t
#   cam_ts
#   -o
#   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DF describes a zone of protection inside which the ITS communication should be restricted.
#  *
#  * It shall include the following components: 
#  * 
#  * @field protectedZoneType: type of the protected zone. 
#  * 
#  * @field expiryTime: optional time at which the validity of the protected communication zone will expire.
#  * 
#  * @field protectedZoneLatitude: latitude of the centre point of the protected communication zone.
#  * 
#  * @field protectedZoneLongitude: longitude of the centre point of the protected communication zone.
#  * 
#  * @field protectedZoneRadius: optional radius of the protected communication zone in metres.
#  * 
#  * @field protectedZoneId: the optional ID of the protected communication zone.
#  * 
#  * @note: A protected communication zone may be defined around a CEN DSRC road side equipment.
#  * 
#  * @category: Infrastructure information, Communication information
#  * @revision: revised in V2.1.1 (changed protectedZoneID to protectedZoneId)
#  */
# ProtectedCommunicationZone ::= SEQUENCE {
#     protectedZoneType         ProtectedZoneType,
#     expiryTime                TimestampIts OPTIONAL,
#     protectedZoneLatitude     Latitude,
#     protectedZoneLongitude    Longitude,
#     protectedZoneRadius       ProtectedZoneRadius OPTIONAL,
#     protectedZoneId           ProtectedZoneId OPTIONAL,
#     ...
# }
# ------------------------------------------------------------------------------

ProtectedZoneType protected_zone_type

TimestampIts expiry_time
bool expiry_time_is_present

Latitude protected_zone_latitude

Longitude protected_zone_longitude

ProtectedZoneRadius protected_zone_radius
bool protected_zone_radius_is_present

ProtectedZoneId protected_zone_id
bool protected_zone_id_is_present


================================================================================
MSG: etsi_its_cam_ts_msgs/ProtectedZoneType
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
#   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
#   -t
#   cam_ts
#   -o
#   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE indicates the type of a protected communication zone, so that an ITS-S is aware of the actions to do
#  * while passing by such zone (e.g. reduce the transmit power in case of a DSRC tolling station).
#  * 
#  * The protected zone type is defined in ETSI TS 102 792 [14].
#  * 
#  * 
#  * @category: Communication information
#  * @revision: V1.3.1
#  */
# ProtectedZoneType::= ENUMERATED {
#     permanentCenDsrcTolling (0), 
#     ..., 
#     temporaryCenDsrcTolling (1) 
# }
# ------------------------------------------------------------------------------

uint8 value
uint8 PERMANENT_CEN_DSRC_TOLLING = 0
uint8 TEMPORARY_CEN_DSRC_TOLLING = 1


================================================================================
MSG: etsi_its_cam_ts_msgs/TimestampIts
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
#   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
#   -t
#   cam_ts
#   -o
#   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE represents the number of elapsed (TAI) milliseconds since the ITS Epoch. 
#  * The ITS epoch is `00:00:00.000 UTC, 1 January 2004`.
#  * "Elapsed" means that the true number of milliseconds is continuously counted without interruption,
#  *  i.e. it is not altered by leap seconds, which occur in UTC.
#  * 
#  * @note: International Atomic Time (TAI) is the time reference coordinate on the basis of the readings of atomic clocks, 
#  * operated in accordance with the definition of the second, the unit of time of the International System of Units. 
#  * TAI is a continuous time scale. UTC has discontinuities, as it is occasionally adjusted by leap seconds. 
#  * As of 1 January, 2022, TimestampIts is 5 seconds ahead of UTC, because since the ITS epoch on 1 January 2004 00:00:00.000 UTC, 
#  * further 5 leap seconds have been inserted in UTC.
#  * 
#  * EXAMPLE: The value for TimestampIts for 1 January 2007 00:00:00.000 UTC is `94 694 401 000` milliseconds,
#  * which includes one leap second insertion since the ITS epoch.
#  * @unit: 0,001 s
#  * @category: Basic information
#  * @revision: Description revised in in V2.1.1
#  */
# TimestampIts ::= INTEGER (0..4398046511103)
# ------------------------------------------------------------------------------

uint64 value
uint64 MIN = 0
uint64 MAX = 4398046511103


================================================================================
MSG: etsi_its_cam_ts_msgs/ProtectedZoneRadius
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
#   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
#   -t
#   cam_ts
#   -o
#   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE represents the radius of a protected communication zone. 
#  * 
#  * 
#  * @unit: metre
#  * @category: Infrastructure information, Communication information
#  * @revision: V1.3.1
#  */
# ProtectedZoneRadius ::= INTEGER (1..255,...)
# ------------------------------------------------------------------------------

uint8 value
uint8 MIN = 1
uint8 MAX = 255


================================================================================
MSG: etsi_its_cam_ts_msgs/LowFrequencyContainer
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
#   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
#   -t
#   cam_ts
#   -o
#   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
# * This type represents the low frequency container.
# * 
# * It shall include the following components: 
# *
# * The low frequency container of the CAM when the originating ITS-S is of the type vehicle ITS-S. It shall be present as defined in clause 6.1.2.
# */
#  LowFrequencyContainer ::= CHOICE {
#   basicVehicleContainerLowFrequency BasicVehicleContainerLowFrequency (WITH COMPONENTS {..., pathHistory (SIZE (0..23))}),
# 	...
# }
# ------------------------------------------------------------------------------

uint8 choice

BasicVehicleContainerLowFrequency basic_vehicle_container_low_frequency
uint8 CHOICE_BASIC_VEHICLE_CONTAINER_LOW_FREQUENCY = 0


================================================================================
MSG: etsi_its_cam_ts_msgs/BasicVehicleContainerLowFrequency
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
#   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
#   -t
#   cam_ts
#   -o
#   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
# * This type contains detaild information of the Basic Vehicle Container Low Frequency.
# *
# * It shall include the following components:
# *
# * @field vehicleRole: represent the role of the vehicle ITS-S that originates the CAM. Only values 0 to 7 shall be used.
# *
# * @field exteriorLights: represent the status of the most important exterior lights switches of the vehicle ITS-S that originates the CAM.
# *
# * @field pathHistory: which represents the vehicle's recent movement over some past time and/or distance. It consists of a list of path points,
# * each represented as DF PathPoint. The list of path points may consist of up to 23 elements. 
# */
# BasicVehicleContainerLowFrequency  ::= SEQUENCE {
# 	vehicleRole VehicleRole,
# 	exteriorLights ExteriorLights,
# 	pathHistory Path
# }
# ------------------------------------------------------------------------------

VehicleRole vehicle_role

ExteriorLights exterior_lights

Path path_history


================================================================================
MSG: etsi_its_cam_ts_msgs/VehicleRole
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
#   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
#   -t
#   cam_ts
#   -o
#   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE indicates the role played by a vehicle at a point in time.
#  *
#  * The value shall be set to:
#  * - 0 `default`          - to indicate the default vehicle role as indicated by the vehicle type,
#  * - 1 `publicTransport`  - to indicate that the vehicle is used to operate public transport service,
#  * - 2 `specialTransport` - to indicate that the vehicle is used for special transport purpose, e.g. oversized trucks,
#  * - 3 `dangerousGoods`   - to indicate that the vehicle is used for dangerous goods transportation,
#  * - 4 `roadWork`         - to indicate that the vehicle is used to realize roadwork or road maintenance mission,
#  * - 5 `rescue`           - to indicate that the vehicle is used for rescue purpose in case of an accident, e.g. as a towing service,
#  * - 6 `emergency`        - to indicate that the vehicle is used for emergency mission, e.g. ambulance, fire brigade,
#  * - 7 `safetyCar`        - to indicate that the vehicle is used for public safety, e.g. patrol,
#  * - 8 `agriculture`      - to indicate that the vehicle is used for agriculture, e.g. farm tractor, 
#  * - 9 `commercial`       - to indicate that the vehicle is used for transportation of commercial goods,
#  * - 10 `military`        - to indicate that the vehicle is used for military purpose, 
#  * - 11 `roadOperator`    - to indicate that the vehicle is used in road operator missions,
#  * - 12 `taxi`            - to indicate that the vehicle is used to provide an authorized taxi service,
#  * - 13 `uvar`            - to indicate that the vehicle is authorized to enter a zone according to the applicable Urban Vehicle Access Restrictions.
#  * - 14 `rfu1`            - is reserved for future usage.
#  * - 15 `rfu2`            - is reserved for future usage.
#  * 
#  * @category: Vehicle Information
#  * @revision: Description updated in V2.1.1 (removed reference to CEN/TS 16157-3), value 13 assigned in V2.2.1
#  */
# VehicleRole ::= ENUMERATED {
#     default         (0), 
#     publicTransport (1), 
#     specialTransport(2), 
#     dangerousGoods  (3), 
#     roadWork        (4), 
#     rescue          (5), 
#     emergency       (6), 
#     safetyCar       (7), 
#     agriculture     (8), 
#     commercial      (9), 
#     military        (10), 
#     roadOperator    (11), 
#     taxi            (12), 
#     uvar            (13), 
#     rfu1            (14), 
#     rfu2            (15)
# }
# ------------------------------------------------------------------------------

uint8 value
uint8 DEFAULT = 0
uint8 PUBLIC_TRANSPORT = 1
uint8 SPECIAL_TRANSPORT = 2
uint8 DANGEROUS_GOODS = 3
uint8 ROAD_WORK = 4
uint8 RESCUE = 5
uint8 EMERGENCY = 6
uint8 SAFETY_CAR = 7
uint8 AGRICULTURE = 8
uint8 COMMERCIAL = 9
uint8 MILITARY = 10
uint8 ROAD_OPERATOR = 11
uint8 TAXI = 12
uint8 UVAR = 13
uint8 RFU1 = 14
uint8 RFU2 = 15


================================================================================
MSG: etsi_its_cam_ts_msgs/ExteriorLights
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
#   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
#   -t
#   cam_ts
#   -o
#   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE describes the status of the exterior light switches of a vehicle incl. VRU vehicles.
#  *
#  * The corresponding bit shall be set to 1 under the following conditions:
#  * - 0 - `lowBeamHeadlightsOn`    - when the low beam head light switch is on,
#  * - 1 - `highBeamHeadlightsOn`   - when the high beam head light switch is on,
#  * - 2 - `leftTurnSignalOn`       - when the left turnSignal switch is on,
#  * - 3 - `rightTurnSignalOn`      - when the right turn signal switch is on,
#  * - 4 - `daytimeRunningLightsOn` - when the daytime running light switch is on,
#  * - 5 - `reverseLightOn`         - when the reverse light switch is on,
#  * - 6 - `fogLightOn`             - when the tail fog light switch is on,
#  * - 7 - `parkingLightsOn`        - when the parking light switch is on.
#  * 
#  * @note: The value of each bit indicates the state of the switch, which commands the corresponding light.
#  * The bit corresponding to a specific light is set to `1`, when the corresponding switch is turned on,
#  * either manually by the driver or automatically by a vehicle system. The bit value does not indicate
#  * if the corresponding lamps are alight or not.
#  * 
#  * If a vehicle is not equipped with a certain light or if the light switch status information is not available,
#  * the corresponding bit shall be set to `0`.
#  * 
#  * As the bit value indicates only the state of the switch, the turn signal and hazard signal bit values shall not
#  * alternate with the blinking interval.
#  * 
#  * For hazard indicator, the `leftTurnSignalOn (2)` and `rightTurnSignalOn (3)` shall be both set to `1`.
#  * 
#  * @category Vehicle information
#  * @revision: Description revised in V2.1.1
#  */
# ExteriorLights ::= BIT STRING {
#     lowBeamHeadlightsOn      (0),
#     highBeamHeadlightsOn     (1),
#     leftTurnSignalOn         (2),
#     rightTurnSignalOn        (3),
#     daytimeRunningLightsOn   (4),
#     reverseLightOn           (5),
#     fogLightOn               (6),
#     parkingLightsOn          (7)
# } (SIZE(8))
# ------------------------------------------------------------------------------

uint8[] value
uint8 bits_unused
uint8 SIZE_BITS = 8
uint8 BIT_INDEX_LOW_BEAM_HEADLIGHTS_ON = 0
uint8 BIT_INDEX_HIGH_BEAM_HEADLIGHTS_ON = 1
uint8 BIT_INDEX_LEFT_TURN_SIGNAL_ON = 2
uint8 BIT_INDEX_RIGHT_TURN_SIGNAL_ON = 3
uint8 BIT_INDEX_DAYTIME_RUNNING_LIGHTS_ON = 4
uint8 BIT_INDEX_REVERSE_LIGHT_ON = 5
uint8 BIT_INDEX_FOG_LIGHT_ON = 6
uint8 BIT_INDEX_PARKING_LIGHTS_ON = 7


================================================================================
MSG: etsi_its_cam_ts_msgs/Path
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
#   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
#   -t
#   cam_ts
#   -o
#   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DF represents a path with a set of path points.
#  * It shall contain up to `40` @ref PathPoint. 
#  * 
#  * The first PathPoint presents an offset delta position with regards to an external reference position.
#  * Each other PathPoint presents an offset delta position and optionally an offset travel time with regards to the previous PathPoint. 
#  *
#  * @category: GeoReference information, Vehicle information
#  * @revision: created in V2.1.1 based on PathHistory
#  */
# Path::= SEQUENCE (SIZE(0..40)) OF PathPoint
# ------------------------------------------------------------------------------

PathPoint[] array
uint8 MIN_SIZE = 0
uint8 MAX_SIZE = 40


================================================================================
MSG: etsi_its_cam_ts_msgs/PathPoint
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
#   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
#   -t
#   cam_ts
#   -o
#   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DF defines an offset waypoint position within a path.
#  *
#  * It shall include the following components: 
#  *
#  * @field pathPosition: The waypoint position defined as an offset position with regards to a pre-defined reference position. 
#  *
#  * @field pathDeltaTime: The optional travel time separated from a waypoint to the predefined reference position.
#  *
#  * @category GeoReference information
#  * @revision: semantics updated in V2.1.1
#  */
# PathPoint ::= SEQUENCE {
#     pathPosition     DeltaReferencePosition,
#     pathDeltaTime    PathDeltaTime OPTIONAL
# }
# ------------------------------------------------------------------------------

DeltaReferencePosition path_position

PathDeltaTime path_delta_time
bool path_delta_time_is_present


================================================================================
MSG: etsi_its_cam_ts_msgs/DeltaReferencePosition
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
#   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
#   -t
#   cam_ts
#   -o
#   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DF defines a geographical point position as a 3 dimensional offset position to a geographical reference point.
#  *
#  * It shall include the following components: 
#  *
#  * @field deltaLatitude: A delta latitude offset with regards to the latitude value of the reference position.
#  *
#  * @field deltaLongitude: A delta longitude offset with regards to the longitude value of the reference position.
#  *
#  * @field deltaAltitude: A delta altitude offset with regards to the altitude value of the reference position.
#  *
#  * @category: GeoReference information
#  * @revision:  V1.3.1
#  */
# DeltaReferencePosition ::= SEQUENCE {
#     deltaLatitude     DeltaLatitude,
#     deltaLongitude    DeltaLongitude,
#     deltaAltitude     DeltaAltitude
# }
# ------------------------------------------------------------------------------

DeltaLatitude delta_latitude

DeltaLongitude delta_longitude

DeltaAltitude delta_altitude


================================================================================
MSG: etsi_its_cam_ts_msgs/DeltaLatitude
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
#   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
#   -t
#   cam_ts
#   -o
#   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE represents an offset latitude with regards to a defined latitude value.
#  * It may be used to describe a geographical point with regards to a specific reference geographical position.
#  *
#  * The value shall be set to:
#  * - `n` (`n >= -131 071` and `n < 0`) for offset n x 10^-7 degree towards the south from the reference position,
#  * - `0` for no latitudinal offset,
#  * - `n` (`n > 0` and `n < 131 072`) for offset n x 10^-7 degree towards the north from the reference position,
#  * - `131 072` when the information is unavailable.
#  *
#  * @unit: 10^-7 degree
#  * @category: GeoReference information
#  * @revision: editorial update in V2.1.1
#  */
# DeltaLatitude ::= INTEGER {
#     unavailable (131072)
# } (-131071..131072)
# ------------------------------------------------------------------------------

int32 value
int32 MIN = -131071
int32 MAX = 131072
int32 UNAVAILABLE = 131072


================================================================================
MSG: etsi_its_cam_ts_msgs/DeltaLongitude
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
#   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
#   -t
#   cam_ts
#   -o
#   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE represents an offset longitude with regards to a defined longitude value.
#  * It may be used to describe a geographical point with regards to a specific reference geographical position.
#  *
#  * The value shall be set to:
#  * - `n` (`n >= -131 071` and `n < 0`) for offset n x 10^-7 degree towards the west from the reference position,
#  * - `0` for no longitudinal offset,
#  * - `n` (`n > 0` and `n < 131 072`) for offset n x 10^-7 degree towards the east from the reference position, 
#  * - `131 072` when the information is unavailable.
#  *
#  * @unit: 10^-7 degree
#  * @category: GeoReference information
#  * @revision: editorial update in V2.1.1
#  */
# DeltaLongitude ::= INTEGER {
#     unavailable (131072)
# } (-131071..131072)
# ------------------------------------------------------------------------------

int32 value
int32 MIN = -131071
int32 MAX = 131072
int32 UNAVAILABLE = 131072


================================================================================
MSG: etsi_its_cam_ts_msgs/DeltaAltitude
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
#   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
#   -t
#   cam_ts
#   -o
#   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE represents an offset altitude with regards to a defined altitude value.
#  * It may be used to describe a geographical point with regards to a specific reference geographical position.
#  *
#  * The value shall be set to:
#  * - `-12 700` for values equal to or lower than -127 metres,
#  * - `n` (`n > -12 700` and `n <= 0`) for altitude offset n x 0,01 metre below the reference position,
#  * - `0` for no altitudinal offset,
#  * - `n` (`n > 0` and `n < 12799`) for altitude offset n x 0,01 metre above the reference position,
#  * - `12 799` for values equal to or greater than 127,99 metres,
#  * - `12 800` when the information is unavailable.
#  *
#  * @unit: 0,01 metre
#  * @category: GeoReference information
#  * @revision: editorial update in V2.1.1
#  */
# DeltaAltitude ::= INTEGER {
#     negativeOutOfRange (-12700),
#     positiveOutOfRange (12799),
#     unavailable        (12800)
# } (-12700..12800)
# ------------------------------------------------------------------------------

int16 value
int16 MIN = -12700
int16 MAX = 12800
int16 NEGATIVE_OUT_OF_RANGE = -12700
int16 POSITIVE_OUT_OF_RANGE = 12799
int16 UNAVAILABLE = 12800


================================================================================
MSG: etsi_its_cam_ts_msgs/PathDeltaTime
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
#   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
#   -t
#   cam_ts
#   -o
#   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE represents the recorded or estimated travel time between a position and a predefined reference position. 
#  *
#  * @unit 0,01 second
#  * @category: Basic information
#  * @revision: V1.3.1
#  */
# PathDeltaTime ::= INTEGER (1..65535, ...) 
# ------------------------------------------------------------------------------

uint16 value
uint16 MIN = 1
uint16 MAX = 65535


================================================================================
MSG: etsi_its_cam_ts_msgs/SpecialVehicleContainer
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
#   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
#   -t
#   cam_ts
#   -o
#   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
# * This type represent the Special Vehicle Container.
# *
# * It shall include the following components:
# *
# * @field publicTransportContainer: If the vehicleRole component is set to publicTransport(1) this container shall be present.
# *
# * @field specialTransportContainer: If the vehicleRole component is set to specialTransport(2) this container shall be present.
# *
# * @field dangerousGoodsContainer: If the vehicleRole component is set to dangerousGoods(3) this container shall be present.
# *
# * @field roadWorksContainerBasic: If the vehicleRole component is set to roadWork(4) this container shall be present. 
# *
# * @field rescueContainer: If the vehicleRole component is set to rescue(5) this container shall be present. 
# *
# * @field emergencyContainer: If the vehicleRole component is set to emergency(6) this container shall be present.
# *
# * @field safetyCarContainer: If the vehicleRole component is set to safetyCar(7) this container shall be present. 
# */
# SpecialVehicleContainer ::= CHOICE {
# 	publicTransportContainer  PublicTransportContainer,
# 	specialTransportContainer SpecialTransportContainer,
# 	dangerousGoodsContainer   DangerousGoodsContainer,
# 	roadWorksContainerBasic   RoadWorksContainerBasic,
# 	rescueContainer           RescueContainer,
# 	emergencyContainer        EmergencyContainer,
# 	safetyCarContainer        SafetyCarContainer,
# 	...
# }
# ------------------------------------------------------------------------------

uint8 choice

PublicTransportContainer public_transport_container
uint8 CHOICE_PUBLIC_TRANSPORT_CONTAINER = 0

SpecialTransportContainer special_transport_container
uint8 CHOICE_SPECIAL_TRANSPORT_CONTAINER = 1

DangerousGoodsContainer dangerous_goods_container
uint8 CHOICE_DANGEROUS_GOODS_CONTAINER = 2

RoadWorksContainerBasic road_works_container_basic
uint8 CHOICE_ROAD_WORKS_CONTAINER_BASIC = 3

RescueContainer rescue_container
uint8 CHOICE_RESCUE_CONTAINER = 4

EmergencyContainer emergency_container
uint8 CHOICE_EMERGENCY_CONTAINER = 5

SafetyCarContainer safety_car_container
uint8 CHOICE_SAFETY_CAR_CONTAINER = 6


================================================================================
MSG: etsi_its_cam_ts_msgs/PublicTransportContainer
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
#   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
#   -t
#   cam_ts
#   -o
#   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
# * This type contains detaild information of the Public Transport Container.
# *
# * It shall include the following components:
# *
# * @field embarkationStatus: It indicates whether the passenger embarkation is currently ongoing. 
# *
# * @field ptActivation: an optional component used for controlling traffic lights, barriers, bollards, etc.
# */
# PublicTransportContainer ::= SEQUENCE {
# 	embarkationStatus EmbarkationStatus,
# 	ptActivation PtActivation OPTIONAL
# }
# ------------------------------------------------------------------------------

EmbarkationStatus embarkation_status

PtActivation pt_activation
bool pt_activation_is_present


================================================================================
MSG: etsi_its_cam_ts_msgs/EmbarkationStatus
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
#   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
#   -t
#   cam_ts
#   -o
#   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE indicates whether a vehicle (e.g. public transport vehicle, truck) is under the embarkation process.
#  * If that is the case, the value is *TRUE*, otherwise *FALSE*.
#  *
#  * @category: Vehicle information
#  * @revision: editorial update in V2.1.1
#  */
# EmbarkationStatus ::= BOOLEAN
# ------------------------------------------------------------------------------

bool value


================================================================================
MSG: etsi_its_cam_ts_msgs/PtActivation
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
#   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
#   -t
#   cam_ts
#   -o
#   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DF represents activation data for real-time systems designed for operations control, traffic light priorities, track switches, barriers, etc.
#  * using a range of activation devices equipped in public transport vehicles.
#  *
#  * The activation of the corresponding equipment is triggered by the approach or passage of a public transport
#  * vehicle at a certain point (e.g. a beacon).
#  *
#  * @field ptActivationType: type of activation. 
#  *
#  * @field ptActicationData: data of activation. 
#  *
#  * Today there are different payload variants defined for public transport activation-data. The R09.x is one of
#  * the industry standard used by public transport vehicles (e.g. buses, trams) in Europe (e.g. Germany Austria)
#  * for controlling traffic lights, barriers, bollards, etc. This DF shall include information like route, course,
#  * destination, priority, etc.
#  * 
#  * The R09.x content is defined in VDV recommendation 420 [7]. It includes following information:
#  * - Priority Request Information (pre-request, request, ready to start)
#  * - End of Prioritization procedure
#  * - Priority request direction
#  * - Public Transport line number
#  * - Priority of public transport
#  * - Route line identifier of the public transport
#  * - Route number identification
#  * - Destination of public transport vehicle
#  *
#  * Other countries may use different message sets defined by the local administration.
#  * @category: Vehicle information
#  * @revision: V1.3.1
#  */
# PtActivation ::= SEQUENCE {
#     ptActivationType    PtActivationType,
#     ptActivationData    PtActivationData
# }
# ------------------------------------------------------------------------------

PtActivationType pt_activation_type

PtActivationData pt_activation_data


================================================================================
MSG: etsi_its_cam_ts_msgs/PtActivationType
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
#   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
#   -t
#   cam_ts
#   -o
#   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE indicates a certain coding type of the PtActivationData data.
#  *
#  * The folowing value are specified:
#  * - 0 `undefinedCodingType`  : undefined coding type,
#  * - 1 `r09-16CodingType`     : coding of PtActivationData conform to VDV recommendation 420 [7],
#  * - 2 `vdv-50149CodingType`  : coding of PtActivationData based on VDV recommendation 420 [7].
#  * - 3 - 255                  : reserved for alternative and future use.
#  * 
#  * @category: Vehicle information 
#  * @revision: V1.3.1
#  */
# PtActivationType ::= INTEGER {
#     undefinedCodingType (0), 
#     r09-16CodingType    (1), 
#     vdv-50149CodingType (2)
# } (0..255)
# ------------------------------------------------------------------------------

uint8 value
uint8 MIN = 0
uint8 MAX = 255
uint8 UNDEFINED_CODING_TYPE = 0
uint8 R09_16_CODING_TYPE = 1
uint8 VDV_50149_CODING_TYPE = 2


================================================================================
MSG: etsi_its_cam_ts_msgs/PtActivationData
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
#   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
#   -t
#   cam_ts
#   -o
#   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE is used for various tasks in the public transportation environment, especially for controlling traffic
#  * signal systems to prioritize and speed up public transportation in urban area (e.g. intersection "_bottlenecks_").
#  * The traffic lights may be controlled by an approaching bus or tram automatically. This permits "_In Time_" activation
#  * of the green phase, will enable the individual traffic to clear a potential traffic jam in advance. Thereby the
#  * approaching bus or tram may pass an intersection with activated green light without slowing down the speed due to
#  * traffic congestion. Other usage of the DE is the provision of information like the public transport line number
#  * or the schedule delay of a public transport vehicle.
#  * 
#  * @category: Vehicle information
#  * @revision: V1.3.1
#  */
# PtActivationData ::= OCTET STRING (SIZE(1..20))
# ------------------------------------------------------------------------------

uint8[] value
uint8 MIN_SIZE = 1
uint8 MAX_SIZE = 20


================================================================================
MSG: etsi_its_cam_ts_msgs/SpecialTransportContainer
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
#   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
#   -t
#   cam_ts
#   -o
#   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
# * This type contains detaild information of the Special Transport Container.
# *
# * It shall include the following components:
# *
# * @field specialTransportType: which indicates whether the originating ITS-S is mounted on a special transport vehicle with heavy or oversized load
# * or both. It shall be present if the data is available in originating ITS-S.
# *
# * @field lightBarSirenInUse: indicates whether light-bar or a siren is in use by the vehicle originating the CAM.
# */
# SpecialTransportContainer ::= SEQUENCE {
# 	specialTransportType SpecialTransportType,
# 	lightBarSirenInUse LightBarSirenInUse
# }
# ------------------------------------------------------------------------------

SpecialTransportType special_transport_type

LightBarSirenInUse light_bar_siren_in_use


================================================================================
MSG: etsi_its_cam_ts_msgs/SpecialTransportType
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
#   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
#   -t
#   cam_ts
#   -o
#   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * The DE indicates if a vehicle is carrying goods in the special transport conditions.
#  *
#  * The corresponding bit shall be set to 1 under the following conditions:
#  * - 0 `heavyLoad`        - the vehicle is carrying goods with heavy load,
#  * - 1 `excessWidth`      - the vehicle is carrying goods in excess of width,
#  * - 2 `excessLength`     - the vehicle is carrying goods in excess of length,
#  * - 3 `excessHeight`     - the vehicle is carrying goods in excess of height.
#  *
#  * Otherwise, the corresponding bit shall be set to 0.
#  * @category Vehicle information
#  * @revision: Description revised in V2.1.1
#  */
# SpecialTransportType ::= BIT STRING {
#     heavyLoad    (0),
#     excessWidth  (1), 
#     excessLength (2), 
#     excessHeight (3)
# } (SIZE(4))
# ------------------------------------------------------------------------------

uint8[] value
uint8 bits_unused
uint8 SIZE_BITS = 4
uint8 BIT_INDEX_HEAVY_LOAD = 0
uint8 BIT_INDEX_EXCESS_WIDTH = 1
uint8 BIT_INDEX_EXCESS_LENGTH = 2
uint8 BIT_INDEX_EXCESS_HEIGHT = 3


================================================================================
MSG: etsi_its_cam_ts_msgs/LightBarSirenInUse
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
#   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
#   -t
#   cam_ts
#   -o
#   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE indicates the status of light bar and any sort of audible alarm system besides the horn.
#  * This includes various common sirens as well as backup up beepers and other slow speed manoeuvring alerts.
#  *
#  * The corresponding bit shall be set to 1 under the following conditions:
#  * - 0 - `lightBarActivated`      - when the light bar is activated,
#  * - 1 - `sirenActivated`         - when the siren is activated.
#  *
#  * Otherwise, it shall be set to 0.
#  *
#  * @category Vehicle information
#  * @revision: Editorial update in V2.1.1
#  */
# LightBarSirenInUse ::= BIT STRING {
#     lightBarActivated (0),
#     sirenActivated    (1)
# } (SIZE(2))
# ------------------------------------------------------------------------------

uint8[] value
uint8 bits_unused
uint8 SIZE_BITS = 2
uint8 BIT_INDEX_LIGHT_BAR_ACTIVATED = 0
uint8 BIT_INDEX_SIREN_ACTIVATED = 1


================================================================================
MSG: etsi_its_cam_ts_msgs/DangerousGoodsContainer
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
#   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
#   -t
#   cam_ts
#   -o
#   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
# * This type contains detaild information of the Dangerous Goods Container.
# *
# * It shall include the following components:
# *
# * @field dangerousGoodsBasic: identifies the type of the dangerous goods transported by the vehicle that originates the CAM. It shall be present if
# * the data is available in the originating ITS S.
# */
#  DangerousGoodsContainer ::= SEQUENCE {
#   dangerousGoodsBasic DangerousGoodsBasic
#  }
# ------------------------------------------------------------------------------

DangerousGoodsBasic dangerous_goods_basic


================================================================================
MSG: etsi_its_cam_ts_msgs/DangerousGoodsBasic
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
#   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
#   -t
#   cam_ts
#   -o
#   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE indicates the type of the dangerous goods being carried by a heavy vehicle.
#  * The value is assigned according to `class` and `division` definitions of dangerous goods as specified in part II,
#  * chapter 2.1.1.1 of European Agreement concerning the International Carriage of Dangerous Goods by Road [3].
#  * 
#  * 
#  * @category Vehicle information
#  * @revision: V1.3.1
#  */
# DangerousGoodsBasic::= ENUMERATED {
#     explosives1                                          (0),
#     explosives2                                          (1),
#     explosives3                                          (2),
#     explosives4                                          (3),
#     explosives5                                          (4),
#     explosives6                                          (5),
#     flammableGases                                       (6),
#     nonFlammableGases                                    (7),
#     toxicGases                                           (8),
#     flammableLiquids                                     (9),
#     flammableSolids                                      (10),
#     substancesLiableToSpontaneousCombustion              (11),
#     substancesEmittingFlammableGasesUponContactWithWater (12),
#     oxidizingSubstances                                  (13),
#     organicPeroxides                                     (14),
#     toxicSubstances                                      (15),
#     infectiousSubstances                                 (16),
#     radioactiveMaterial                                  (17),
#     corrosiveSubstances                                  (18),
#     miscellaneousDangerousSubstances                     (19)
# }
# ------------------------------------------------------------------------------

uint8 value
uint8 EXPLOSIVES1 = 0
uint8 EXPLOSIVES2 = 1
uint8 EXPLOSIVES3 = 2
uint8 EXPLOSIVES4 = 3
uint8 EXPLOSIVES5 = 4
uint8 EXPLOSIVES6 = 5
uint8 FLAMMABLE_GASES = 6
uint8 NON_FLAMMABLE_GASES = 7
uint8 TOXIC_GASES = 8
uint8 FLAMMABLE_LIQUIDS = 9
uint8 FLAMMABLE_SOLIDS = 10
uint8 SUBSTANCES_LIABLE_TO_SPONTANEOUS_COMBUSTION = 11
uint8 SUBSTANCES_EMITTING_FLAMMABLE_GASES_UPON_CONTACT_WITH_WATER = 12
uint8 OXIDIZING_SUBSTANCES = 13
uint8 ORGANIC_PEROXIDES = 14
uint8 TOXIC_SUBSTANCES = 15
uint8 INFECTIOUS_SUBSTANCES = 16
uint8 RADIOACTIVE_MATERIAL = 17
uint8 CORROSIVE_SUBSTANCES = 18
uint8 MISCELLANEOUS_DANGEROUS_SUBSTANCES = 19


================================================================================
MSG: etsi_its_cam_ts_msgs/RoadWorksContainerBasic
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
#   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
#   -t
#   cam_ts
#   -o
#   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
#  /**
# * This type contains detaild information of the Road Works Container Basic.
# *
# * It shall include the following components:
# *
# * @field roadworksSubCauseCode: The optional component, in case the originating ITS-S is mounted to a vehicle ITS-S participating to roadwork. It 
# * provides information on the type of roadwork that it is currently undertaking. This component shall be present if the data is available in 
# * originating ITS S.
# *
# * @field lightBarSirenInUse: it indicates whether light-bar or a siren is in use by the vehicle originating the CAM.
# *
# * @field closedLanes: an optional component which provides information about the opening/closure status of the lanes ahead. Lanes are counted from
# * the outside boarder of the road. If a lane is closed to traffic, the corresponding bit shall be set to 1.
# */
#  RoadWorksContainerBasic ::= SEQUENCE {
#   roadworksSubCauseCode RoadworksSubCauseCode OPTIONAL,
#   lightBarSirenInUse LightBarSirenInUse,
#   closedLanes ClosedLanes OPTIONAL
#  }
# ------------------------------------------------------------------------------

RoadworksSubCauseCode roadworks_sub_cause_code
bool roadworks_sub_cause_code_is_present

LightBarSirenInUse light_bar_siren_in_use

ClosedLanes closed_lanes
bool closed_lanes_is_present


================================================================================
MSG: etsi_its_cam_ts_msgs/RoadworksSubCauseCode
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
#   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
#   -t
#   cam_ts
#   -o
#   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE represents the value of the sub cause codes of the @ref CauseCode `roadworks`.
#  * 
# The value shall be set to:
#  * - 0 `unavailable`                 - in case further detailed information on roadworks is unavailable,
#  * - 1 `majorRoadworks`              - in case a major roadworks is ongoing,
#  * - 2 `roadMarkingWork`             - in case a road marking work is ongoing,
#  * - 3 `slowMovingRoadMaintenance`   - in case slow moving road maintenance work is ongoing,
#  * - 4 `shortTermStationaryRoadworks`- in case a short term stationary roadwork is ongoing,
#  * - 5 `streetCleaning`              - in case a vehicle street cleaning work is ongoing,
#  * - 6 `winterService`               - in case winter service work is ongoing.
#  * - 7-255                           - are reserved for future usage.
#  *
#  * @category: Traffic information
#  * @revision: V1.3.1
#  */
# RoadworksSubCauseCode ::= INTEGER {
#     unavailable                  (0), 
#     majorRoadworks               (1),
#     roadMarkingWork              (2), 
#     slowMovingRoadMaintenance    (3), 
#     shortTermStationaryRoadworks (4), 
#    streetCleaning                (5), 
#    winterService                 (6)
# } (0..255)
# ------------------------------------------------------------------------------

uint8 value
uint8 MIN = 0
uint8 MAX = 255
uint8 UNAVAILABLE = 0
uint8 MAJOR_ROADWORKS = 1
uint8 ROAD_MARKING_WORK = 2
uint8 SLOW_MOVING_ROAD_MAINTENANCE = 3
uint8 SHORT_TERM_STATIONARY_ROADWORKS = 4
uint8 STREET_CLEANING = 5
uint8 WINTER_SERVICE = 6


================================================================================
MSG: etsi_its_cam_ts_msgs/ClosedLanes
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
#   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
#   -t
#   cam_ts
#   -o
#   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DF indicates the opening/closure status of the lanes of a carriageway.
#  *
#  * It shall include the following components: 
#  * 
#  * @field innerhardShoulderStatus: this information is optional and shall be included if an inner hard shoulder is present and the information is known.
#  * It indicates the open/closing status of inner hard shoulder lanes. 
#  * 
#  * @field outerhardShoulderStatus: this information is optional and shall be included if an outer hard shoulder is present and the information is known.
#  * It indicates the open/closing status of outer hard shoulder lanes. 
#  * 
#  * @field drivingLaneStatus: this information is optional and shall be included if the information is known.
#  * It indicates the open/closing status of driving lanes. 
#  * For carriageways with more than 13 driving lanes, the drivingLaneStatus component shall not be present.
#  * 
#  * @category: Infrastructure information, Road topology information
#  * @revision: Description revised in V2.1.1
#  */
# ClosedLanes ::= SEQUENCE {
#     innerhardShoulderStatus    HardShoulderStatus OPTIONAL,
#     outerhardShoulderStatus    HardShoulderStatus OPTIONAL,
#     drivingLaneStatus          DrivingLaneStatus OPTIONAL,
#     ...
# }
# ------------------------------------------------------------------------------

HardShoulderStatus innerhard_shoulder_status
bool innerhard_shoulder_status_is_present

HardShoulderStatus outerhard_shoulder_status
bool outerhard_shoulder_status_is_present

DrivingLaneStatus driving_lane_status
bool driving_lane_status_is_present


================================================================================
MSG: etsi_its_cam_ts_msgs/HardShoulderStatus
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
#   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
#   -t
#   cam_ts
#   -o
#   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE indicates the current status of a hard shoulder: whether it is available for special usage
#  * (e.g. for stopping or for driving) or closed for all vehicles.
#  * 
#  * The value shall be set to:
#  * - 0 - `availableForStopping` - if the hard shoulder is available for stopping in e.g. emergency situations,
#  * - 1 - `closed`               - if the hard shoulder is closed and cannot be occupied in any case,
#  * - 2 - `availableForDriving`  - if the hard shoulder is available for regular driving.
#  *
#  * @category: Traffic information
#  * @revision: Description revised in V2.1.1
#  */
# HardShoulderStatus ::= ENUMERATED {
#     availableForStopping (0), 
#     closed               (1), 
#     availableForDriving  (2)
# }
# ------------------------------------------------------------------------------

uint8 value
uint8 AVAILABLE_FOR_STOPPING = 0
uint8 CLOSED = 1
uint8 AVAILABLE_FOR_DRIVING = 2


================================================================================
MSG: etsi_its_cam_ts_msgs/DrivingLaneStatus
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
#   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
#   -t
#   cam_ts
#   -o
#   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE indicates whether a driving lane is open to traffic.
#  * 
#  * A lane is counted from inside border of the road excluding the hard shoulder. The size of the bit string shall
#  * correspond to the total number of the driving lanes in the carriageway.
#  * 
#  * The numbering is matched to @ref LanePosition.
#  * The bit `0` is used to indicate the innermost lane, bit `1` is used to indicate the second lane from inside border.
#  * 
#  * If a lane is closed to traffic, the corresponding bit shall be set to `1`. Otherwise, it shall be set to `0`.
#  * 
#  * @note: hard shoulder status is not provided by this DE but in @ref HardShoulderStatus.
#  * 
#  * @category: Traffic information
#  * @revision: V1.3.1
#  */
# DrivingLaneStatus ::= BIT STRING (SIZE (1..13))
# ------------------------------------------------------------------------------

uint8[] value
uint8 bits_unused
uint8 MIN_SIZE_BITS = 1
uint8 MAX_SIZE_BITS = 13


================================================================================
MSG: etsi_its_cam_ts_msgs/RescueContainer
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
#   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
#   -t
#   cam_ts
#   -o
#   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
# * This type contains detaild information of the Rescue Container.
# *
# * It shall include the following components:
# *
# * @field lightBarSirenInUse: it indicates whether light-bar or a siren is in use by the vehicle originating the CAM.
# */
# RescueContainer ::= SEQUENCE {
# 	lightBarSirenInUse LightBarSirenInUse
# }
# ------------------------------------------------------------------------------

LightBarSirenInUse light_bar_siren_in_use


================================================================================
MSG: etsi_its_cam_ts_msgs/EmergencyContainer
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
#   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
#   -t
#   cam_ts
#   -o
#   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
# * This type contains detaild information of the Emergency Container.
# *
# * It shall include the following components:
# *
# * @field lightBarSirenInUse: it indicates whether light-bar or a siren is in use by the vehicle originating the CAM.
# *
# * @field incidentIndication: the optional incident related to the roadworks to provide additional information of the roadworks zone.
# *
# * @field emergencyPriority: the optional component represent right of way indicator of the vehicle ITS-S that originates the CAM PDU.
# */
# EmergencyContainer ::= SEQUENCE {
# 	lightBarSirenInUse LightBarSirenInUse,
# 	incidentIndication CauseCodeV2 OPTIONAL,
# 	emergencyPriority EmergencyPriority OPTIONAL
# }
# ------------------------------------------------------------------------------

LightBarSirenInUse light_bar_siren_in_use

CauseCodeV2 incident_indication
bool incident_indication_is_present

EmergencyPriority emergency_priority
bool emergency_priority_is_present


================================================================================
MSG: etsi_its_cam_ts_msgs/CauseCodeV2
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
#   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
#   -t
#   cam_ts
#   -o
#   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DF is an alternative representation of the cause code value of a traffic event. 
#  *
#  * It shall include the following components: 
#  *
#  * @field ccAndScc: the main cause of a detected event. Each entry is of a different type and represents the sub cause code.
# 
#  * The semantics of the entire DF are completely defined by the choice value which represents the cause code value. 
#  * The interpretation of the sub cause code value may provide additional information that is not strictly necessary to understand 
#  * the cause code itself, and is therefore optional.
#  *
#  * @category: Traffic information
#  * @revision: Created in V2.1.1, description amended in V2.2.1
#  */
# CauseCodeV2 ::= SEQUENCE {
#     ccAndScc    CauseCodeChoice,
#     ...
# }
# ------------------------------------------------------------------------------

CauseCodeChoice cc_and_scc


================================================================================
MSG: etsi_its_cam_ts_msgs/CauseCodeChoice
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
#   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
#   -t
#   cam_ts
#   -o
#   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DF is a representation of the cause code value and associated sub cause code value of a traffic event. 
#  *
#  * The following options are available:
#  * - 0                                                        - reserved for future use,
#  * - 1  - `trafficCondition1`                                 - in case the type of event is an abnormal traffic condition,
#  * - 2  - `accident2`                                         - in case the type of event is a road accident,
#  * - 3  - `roadworks3`                                        - in case the type of event is roadwork,
#  * - 4                                                        - reserved for future usage,
#  * - 5  - `impassability5`                                    - in case the  type of event is unmanaged road blocking, referring to any
#  *                                                              blocking of a road, partial or total, which has not been adequately secured and signposted,
#  * - 6  - `adverseWeatherCondition-Adhesion6`                 - in case the  type of event is low adhesion,
#  * - 7  - `aquaplaning7`                                      - danger of aquaplaning on the road,
#  * - 8                                                        - reserved for future usage,
#  * - 9  - `hazardousLocation-SurfaceCondition9`               - in case the type of event is abnormal road surface condition,
#  * - 10 - `hazardousLocation-ObstacleOnTheRoad10`             - in case the type of event is obstacle on the road,
#  * - 11 - `hazardousLocation-AnimalOnTheRoad11`               - in case the type of event is animal on the road,
#  * - 12 - `humanPresenceOnTheRoad`                            - in case the type of event is presence of human vulnerable road user on the road,
#  * - 13                                                       - reserved for future usage,
#  * - 14 - `wrongWayDriving14`                                 - in case the type of the event is vehicle driving in wrong way,
#  * - 15 - `rescueAndRecoveryWorkInProgress15`                 - in case the type of event is rescue and recovery work for accident or for a road hazard in progress,
#  * - 16                                                       - reserved for future usage,
#  * - 17 - `adverseWeatherCondition-ExtremeWeatherCondition17` - in case the type of event is extreme weather condition,
#  * - 18 - `adverseWeatherCondition-Visibility18`              - in case the type of event is low visibility,
#  * - 19 - `adverseWeatherCondition-Precipitation19`           - in case the type of event is precipitation,
#  * - 20 - `violence20`                                        - in case the the type of event is human violence on or near the road,
#  * - 21-25                                                    - reserved for future usage,
#  * - 26 - `slowVehicle26`                                     - in case the type of event is slow vehicle driving on the road,
#  * - 27 - `dangerousEndOfQueue27`                             - in case the type of event is dangerous end of vehicle queue,
#  * - 28 - `publicTransportVehicleApproaching                  - in case the type of event is a public transport vehicle approaching, with a priority defined by applicable traffic regulations,
#  * - 29-90                                                    - are reserved for future usage,
#  * - 91 - `vehicleBreakdown91`                                - in case the type of event is break down vehicle on the road,
#  * - 92 - `postCrash92`                                       - in case the type of event is a detected crash,
#  * - 93 - `humanProblem93`                                    - in case the type of event is human health problem in vehicles involved in traffic,
#  * - 94 - `stationaryVehicle94`                               - in case the type of event is stationary vehicle,
#  * - 95 - `emergencyVehicleApproaching95`                     - in case the type of event is an approaching vehicle operating on a mission for which the 
#                                                                 applicable traffic regulations provide it with defined priority rights in traffic. 
#  * - 96 - `hazardousLocation-DangerousCurve96`                - in case the type of event is dangerous curve,
#  * - 97 - `collisionRisk97`                                   - in case the type of event is a collision risk,
#  * - 98 - `signalViolation98`                                 - in case the type of event is signal violation,
#  * - 99 - `dangerousSituation99`                              - in case the type of event is dangerous situation in which autonomous safety system in vehicle 
#  *                                                              is activated,
#  * - 100 - `railwayLevelCrossing100`                          - in case the type of event is a railway level crossing. 
#  * - 101-255                                                  - are reserved for future usage.
#  *
#  * @note: this DF is defined for use as part of CauseCodeV2. It is recommended to use CauseCodeV2.
#  * @category: Traffic information
#  * @revision: Created in V2.1.1, the type of impassability5 changed to ImpassabilitySubCauseCode in V2.2.1, value 28 added in V2.2.1, definition of value 12 and 95 changed in V2.2.1
#  */
# CauseCodeChoice::= CHOICE {
#     reserved0                                          SubCauseCodeType,
#     trafficCondition1                                  TrafficConditionSubCauseCode,
#     accident2                                          AccidentSubCauseCode,
#     roadworks3                                         RoadworksSubCauseCode,
#     reserved4                                          SubCauseCodeType,
#     impassability5                                     ImpassabilitySubCauseCode,
#     adverseWeatherCondition-Adhesion6                  AdverseWeatherCondition-AdhesionSubCauseCode,
#     aquaplaning7                                       SubCauseCodeType,
#     reserved8                                          SubCauseCodeType,
#     hazardousLocation-SurfaceCondition9                HazardousLocation-SurfaceConditionSubCauseCode,
#     hazardousLocation-ObstacleOnTheRoad10              HazardousLocation-ObstacleOnTheRoadSubCauseCode,
#     hazardousLocation-AnimalOnTheRoad11                HazardousLocation-AnimalOnTheRoadSubCauseCode,
#     humanPresenceOnTheRoad12                           HumanPresenceOnTheRoadSubCauseCode,
#     reserved13                                         SubCauseCodeType,
#     wrongWayDriving14                                  WrongWayDrivingSubCauseCode,
#     rescueAndRecoveryWorkInProgress15                  RescueAndRecoveryWorkInProgressSubCauseCode,
#     reserved16                                         SubCauseCodeType,
#     adverseWeatherCondition-ExtremeWeatherCondition17  AdverseWeatherCondition-ExtremeWeatherConditionSubCauseCode,
#     adverseWeatherCondition-Visibility18               AdverseWeatherCondition-VisibilitySubCauseCode,
#     adverseWeatherCondition-Precipitation19            AdverseWeatherCondition-PrecipitationSubCauseCode,
#     violence20                                         SubCauseCodeType,
#     reserved21                                         SubCauseCodeType,
#     reserved22                                         SubCauseCodeType,
#     reserved23                                         SubCauseCodeType,
#     reserved24                                         SubCauseCodeType,
#     reserved25                                         SubCauseCodeType,
#     slowVehicle26                                      SlowVehicleSubCauseCode,
#     dangerousEndOfQueue27                              DangerousEndOfQueueSubCauseCode,
#     publicTransportVehicleApproaching28                SubCauseCodeType,
#     reserved29                                         SubCauseCodeType,
#     reserved30                                         SubCauseCodeType,
#     reserved31                                         SubCauseCodeType,
#     reserved32                                         SubCauseCodeType,
#     reserved33                                         SubCauseCodeType,
#     reserved34                                         SubCauseCodeType,
#     reserved35                                         SubCauseCodeType,
#     reserved36                                         SubCauseCodeType,
#     reserved37                                         SubCauseCodeType,
#     reserved38                                         SubCauseCodeType,
#     reserved39                                         SubCauseCodeType,
#     reserved40                                         SubCauseCodeType,
#     reserved41                                         SubCauseCodeType,
#     reserved42                                         SubCauseCodeType,
#     reserved43                                         SubCauseCodeType,
#     reserved44                                         SubCauseCodeType,
#     reserved45                                         SubCauseCodeType,
#     reserved46                                         SubCauseCodeType,
#     reserved47                                         SubCauseCodeType,
#     reserved48                                         SubCauseCodeType,
#     reserved49                                         SubCauseCodeType,
#     reserved50                                         SubCauseCodeType,
#     reserved51                                         SubCauseCodeType,
#     reserved52                                         SubCauseCodeType,
#     reserved53                                         SubCauseCodeType,
#     reserved54                                         SubCauseCodeType,
#     reserved55                                         SubCauseCodeType,
#     reserved56                                         SubCauseCodeType,
#     reserved57                                         SubCauseCodeType,
#     reserved58                                         SubCauseCodeType,   
#     reserved59                                         SubCauseCodeType, 
#     reserved60                                         SubCauseCodeType,
#     reserved61                                         SubCauseCodeType,
#     reserved62                                         SubCauseCodeType,
#     reserved63                                         SubCauseCodeType,
#     reserved64                                         SubCauseCodeType,
#     reserved65                                         SubCauseCodeType,
#     reserved66                                         SubCauseCodeType,    
#     reserved67                                         SubCauseCodeType,
#     reserved68                                         SubCauseCodeType,
#     reserved69                                         SubCauseCodeType,
#     reserved70                                         SubCauseCodeType,
#     reserved71                                         SubCauseCodeType,
#     reserved72                                         SubCauseCodeType,
#     reserved73                                         SubCauseCodeType,
#     reserved74                                         SubCauseCodeType,
#     reserved75                                         SubCauseCodeType,
#     reserved76                                         SubCauseCodeType,
#     reserved77                                         SubCauseCodeType,
#     reserved78                                         SubCauseCodeType,
#     reserved79                                         SubCauseCodeType,
#     reserved80                                         SubCauseCodeType,
#     reserved81                                         SubCauseCodeType,
#     reserved82                                         SubCauseCodeType,
#     reserved83                                         SubCauseCodeType,
#     reserved84                                         SubCauseCodeType,
#     reserved85                                         SubCauseCodeType,
#     reserved86                                         SubCauseCodeType,
#     reserved87                                         SubCauseCodeType,
#     reserved88                                         SubCauseCodeType,
#     reserved89                                         SubCauseCodeType,
#     reserved90                                         SubCauseCodeType,
#     vehicleBreakdown91                                 VehicleBreakdownSubCauseCode,
#     postCrash92                                        PostCrashSubCauseCode,
#     humanProblem93                                     HumanProblemSubCauseCode,
#     stationaryVehicle94                                StationaryVehicleSubCauseCode,
#     emergencyVehicleApproaching95                      EmergencyVehicleApproachingSubCauseCode,
#     hazardousLocation-DangerousCurve96                 HazardousLocation-DangerousCurveSubCauseCode,
#     collisionRisk97                                    CollisionRiskSubCauseCode,
#     signalViolation98                                  SignalViolationSubCauseCode,
#     dangerousSituation99                               DangerousSituationSubCauseCode,
#     railwayLevelCrossing100                            RailwayLevelCrossingSubCauseCode,
#     reserved101                                        SubCauseCodeType,
#     reserved102                                        SubCauseCodeType,
#     reserved103                                        SubCauseCodeType,
#     reserved104                                        SubCauseCodeType,
#     reserved105                                        SubCauseCodeType,
#     reserved106                                        SubCauseCodeType,
#     reserved107                                        SubCauseCodeType,
#     reserved108                                        SubCauseCodeType,
#     reserved109                                        SubCauseCodeType,
#     reserved110                                        SubCauseCodeType,
#     reserved111                                        SubCauseCodeType,
#     reserved112                                        SubCauseCodeType,
#     reserved113                                        SubCauseCodeType,
#     reserved114                                        SubCauseCodeType,
#     reserved115                                        SubCauseCodeType,
#     reserved116                                        SubCauseCodeType,
#     reserved117                                        SubCauseCodeType,
#     reserved118                                        SubCauseCodeType,
#     reserved119                                        SubCauseCodeType,
#     reserved120                                        SubCauseCodeType,
#     reserved121                                        SubCauseCodeType,
#     reserved122                                        SubCauseCodeType,
#     reserved123                                        SubCauseCodeType,
#     reserved124                                        SubCauseCodeType,
#     reserved125                                        SubCauseCodeType,
#     reserved126                                        SubCauseCodeType,
#     reserved127                                        SubCauseCodeType,
#     reserved128                                        SubCauseCodeType
#   }
# ------------------------------------------------------------------------------

uint8 choice

SubCauseCodeType reserved0
uint8 CHOICE_RESERVED0 = 0

TrafficConditionSubCauseCode traffic_condition1
uint8 CHOICE_TRAFFIC_CONDITION1 = 1

AccidentSubCauseCode accident2
uint8 CHOICE_ACCIDENT2 = 2

RoadworksSubCauseCode roadworks3
uint8 CHOICE_ROADWORKS3 = 3

SubCauseCodeType reserved4
uint8 CHOICE_RESERVED4 = 4

ImpassabilitySubCauseCode impassability5
uint8 CHOICE_IMPASSABILITY5 = 5

AdverseWeatherConditionAdhesionSubCauseCode adverse_weather_condition_adhesion6
uint8 CHOICE_ADVERSE_WEATHER_CONDITION_ADHESION6 = 6

SubCauseCodeType aquaplaning7
uint8 CHOICE_AQUAPLANING7 = 7

SubCauseCodeType reserved8
uint8 CHOICE_RESERVED8 = 8

HazardousLocationSurfaceConditionSubCauseCode hazardous_location_surface_condition9
uint8 CHOICE_HAZARDOUS_LOCATION_SURFACE_CONDITION9 = 9

HazardousLocationObstacleOnTheRoadSubCauseCode hazardous_location_obstacle_on_the_road10
uint8 CHOICE_HAZARDOUS_LOCATION_OBSTACLE_ON_THE_ROAD10 = 10

HazardousLocationAnimalOnTheRoadSubCauseCode hazardous_location_animal_on_the_road11
uint8 CHOICE_HAZARDOUS_LOCATION_ANIMAL_ON_THE_ROAD11 = 11

HumanPresenceOnTheRoadSubCauseCode human_presence_on_the_road12
uint8 CHOICE_HUMAN_PRESENCE_ON_THE_ROAD12 = 12

SubCauseCodeType reserved13
uint8 CHOICE_RESERVED13 = 13

WrongWayDrivingSubCauseCode wrong_way_driving14
uint8 CHOICE_WRONG_WAY_DRIVING14 = 14

RescueAndRecoveryWorkInProgressSubCauseCode rescue_and_recovery_work_in_progress15
uint8 CHOICE_RESCUE_AND_RECOVERY_WORK_IN_PROGRESS15 = 15

SubCauseCodeType reserved16
uint8 CHOICE_RESERVED16 = 16

AdverseWeatherConditionExtremeWeatherConditionSubCauseCode adverse_weather_condition_extreme_weather_condition17
uint8 CHOICE_ADVERSE_WEATHER_CONDITION_EXTREME_WEATHER_CONDITION17 = 17

AdverseWeatherConditionVisibilitySubCauseCode adverse_weather_condition_visibility18
uint8 CHOICE_ADVERSE_WEATHER_CONDITION_VISIBILITY18 = 18

AdverseWeatherConditionPrecipitationSubCauseCode adverse_weather_condition_precipitation19
uint8 CHOICE_ADVERSE_WEATHER_CONDITION_PRECIPITATION19 = 19

SubCauseCodeType violence20
uint8 CHOICE_VIOLENCE20 = 20

SubCauseCodeType reserved21
uint8 CHOICE_RESERVED21 = 21

SubCauseCodeType reserved22
uint8 CHOICE_RESERVED22 = 22

SubCauseCodeType reserved23
uint8 CHOICE_RESERVED23 = 23

SubCauseCodeType reserved24
uint8 CHOICE_RESERVED24 = 24

SubCauseCodeType reserved25
uint8 CHOICE_RESERVED25 = 25

SlowVehicleSubCauseCode slow_vehicle26
uint8 CHOICE_SLOW_VEHICLE26 = 26

DangerousEndOfQueueSubCauseCode dangerous_end_of_queue27
uint8 CHOICE_DANGEROUS_END_OF_QUEUE27 = 27

SubCauseCodeType public_transport_vehicle_approaching28
uint8 CHOICE_PUBLIC_TRANSPORT_VEHICLE_APPROACHING28 = 28

SubCauseCodeType reserved29
uint8 CHOICE_RESERVED29 = 29

SubCauseCodeType reserved30
uint8 CHOICE_RESERVED30 = 30

SubCauseCodeType reserved31
uint8 CHOICE_RESERVED31 = 31

SubCauseCodeType reserved32
uint8 CHOICE_RESERVED32 = 32

SubCauseCodeType reserved33
uint8 CHOICE_RESERVED33 = 33

SubCauseCodeType reserved34
uint8 CHOICE_RESERVED34 = 34

SubCauseCodeType reserved35
uint8 CHOICE_RESERVED35 = 35

SubCauseCodeType reserved36
uint8 CHOICE_RESERVED36 = 36

SubCauseCodeType reserved37
uint8 CHOICE_RESERVED37 = 37

SubCauseCodeType reserved38
uint8 CHOICE_RESERVED38 = 38

SubCauseCodeType reserved39
uint8 CHOICE_RESERVED39 = 39

SubCauseCodeType reserved40
uint8 CHOICE_RESERVED40 = 40

SubCauseCodeType reserved41
uint8 CHOICE_RESERVED41 = 41

SubCauseCodeType reserved42
uint8 CHOICE_RESERVED42 = 42

SubCauseCodeType reserved43
uint8 CHOICE_RESERVED43 = 43

SubCauseCodeType reserved44
uint8 CHOICE_RESERVED44 = 44

SubCauseCodeType reserved45
uint8 CHOICE_RESERVED45 = 45

SubCauseCodeType reserved46
uint8 CHOICE_RESERVED46 = 46

SubCauseCodeType reserved47
uint8 CHOICE_RESERVED47 = 47

SubCauseCodeType reserved48
uint8 CHOICE_RESERVED48 = 48

SubCauseCodeType reserved49
uint8 CHOICE_RESERVED49 = 49

SubCauseCodeType reserved50
uint8 CHOICE_RESERVED50 = 50

SubCauseCodeType reserved51
uint8 CHOICE_RESERVED51 = 51

SubCauseCodeType reserved52
uint8 CHOICE_RESERVED52 = 52

SubCauseCodeType reserved53
uint8 CHOICE_RESERVED53 = 53

SubCauseCodeType reserved54
uint8 CHOICE_RESERVED54 = 54

SubCauseCodeType reserved55
uint8 CHOICE_RESERVED55 = 55

SubCauseCodeType reserved56
uint8 CHOICE_RESERVED56 = 56

SubCauseCodeType reserved57
uint8 CHOICE_RESERVED57 = 57

SubCauseCodeType reserved58
uint8 CHOICE_RESERVED58 = 58

SubCauseCodeType reserved59
uint8 CHOICE_RESERVED59 = 59

SubCauseCodeType reserved60
uint8 CHOICE_RESERVED60 = 60

SubCauseCodeType reserved61
uint8 CHOICE_RESERVED61 = 61

SubCauseCodeType reserved62
uint8 CHOICE_RESERVED62 = 62

SubCauseCodeType reserved63
uint8 CHOICE_RESERVED63 = 63

SubCauseCodeType reserved64
uint8 CHOICE_RESERVED64 = 64

SubCauseCodeType reserved65
uint8 CHOICE_RESERVED65 = 65

SubCauseCodeType reserved66
uint8 CHOICE_RESERVED66 = 66

SubCauseCodeType reserved67
uint8 CHOICE_RESERVED67 = 67

SubCauseCodeType reserved68
uint8 CHOICE_RESERVED68 = 68

SubCauseCodeType reserved69
uint8 CHOICE_RESERVED69 = 69

SubCauseCodeType reserved70
uint8 CHOICE_RESERVED70 = 70

SubCauseCodeType reserved71
uint8 CHOICE_RESERVED71 = 71

SubCauseCodeType reserved72
uint8 CHOICE_RESERVED72 = 72

SubCauseCodeType reserved73
uint8 CHOICE_RESERVED73 = 73

SubCauseCodeType reserved74
uint8 CHOICE_RESERVED74 = 74

SubCauseCodeType reserved75
uint8 CHOICE_RESERVED75 = 75

SubCauseCodeType reserved76
uint8 CHOICE_RESERVED76 = 76

SubCauseCodeType reserved77
uint8 CHOICE_RESERVED77 = 77

SubCauseCodeType reserved78
uint8 CHOICE_RESERVED78 = 78

SubCauseCodeType reserved79
uint8 CHOICE_RESERVED79 = 79

SubCauseCodeType reserved80
uint8 CHOICE_RESERVED80 = 80

SubCauseCodeType reserved81
uint8 CHOICE_RESERVED81 = 81

SubCauseCodeType reserved82
uint8 CHOICE_RESERVED82 = 82

SubCauseCodeType reserved83
uint8 CHOICE_RESERVED83 = 83

SubCauseCodeType reserved84
uint8 CHOICE_RESERVED84 = 84

SubCauseCodeType reserved85
uint8 CHOICE_RESERVED85 = 85

SubCauseCodeType reserved86
uint8 CHOICE_RESERVED86 = 86

SubCauseCodeType reserved87
uint8 CHOICE_RESERVED87 = 87

SubCauseCodeType reserved88
uint8 CHOICE_RESERVED88 = 88

SubCauseCodeType reserved89
uint8 CHOICE_RESERVED89 = 89

SubCauseCodeType reserved90
uint8 CHOICE_RESERVED90 = 90

VehicleBreakdownSubCauseCode vehicle_breakdown91
uint8 CHOICE_VEHICLE_BREAKDOWN91 = 91

PostCrashSubCauseCode post_crash92
uint8 CHOICE_POST_CRASH92 = 92

HumanProblemSubCauseCode human_problem93
uint8 CHOICE_HUMAN_PROBLEM93 = 93

StationaryVehicleSubCauseCode stationary_vehicle94
uint8 CHOICE_STATIONARY_VEHICLE94 = 94

EmergencyVehicleApproachingSubCauseCode emergency_vehicle_approaching95
uint8 CHOICE_EMERGENCY_VEHICLE_APPROACHING95 = 95

HazardousLocationDangerousCurveSubCauseCode hazardous_location_dangerous_curve96
uint8 CHOICE_HAZARDOUS_LOCATION_DANGEROUS_CURVE96 = 96

CollisionRiskSubCauseCode collision_risk97
uint8 CHOICE_COLLISION_RISK97 = 97

SignalViolationSubCauseCode signal_violation98
uint8 CHOICE_SIGNAL_VIOLATION98 = 98

DangerousSituationSubCauseCode dangerous_situation99
uint8 CHOICE_DANGEROUS_SITUATION99 = 99

RailwayLevelCrossingSubCauseCode railway_level_crossing100
uint8 CHOICE_RAILWAY_LEVEL_CROSSING100 = 100

SubCauseCodeType reserved101
uint8 CHOICE_RESERVED101 = 101

SubCauseCodeType reserved102
uint8 CHOICE_RESERVED102 = 102

SubCauseCodeType reserved103
uint8 CHOICE_RESERVED103 = 103

SubCauseCodeType reserved104
uint8 CHOICE_RESERVED104 = 104

SubCauseCodeType reserved105
uint8 CHOICE_RESERVED105 = 105

SubCauseCodeType reserved106
uint8 CHOICE_RESERVED106 = 106

SubCauseCodeType reserved107
uint8 CHOICE_RESERVED107 = 107

SubCauseCodeType reserved108
uint8 CHOICE_RESERVED108 = 108

SubCauseCodeType reserved109
uint8 CHOICE_RESERVED109 = 109

SubCauseCodeType reserved110
uint8 CHOICE_RESERVED110 = 110

SubCauseCodeType reserved111
uint8 CHOICE_RESERVED111 = 111

SubCauseCodeType reserved112
uint8 CHOICE_RESERVED112 = 112

SubCauseCodeType reserved113
uint8 CHOICE_RESERVED113 = 113

SubCauseCodeType reserved114
uint8 CHOICE_RESERVED114 = 114

SubCauseCodeType reserved115
uint8 CHOICE_RESERVED115 = 115

SubCauseCodeType reserved116
uint8 CHOICE_RESERVED116 = 116

SubCauseCodeType reserved117
uint8 CHOICE_RESERVED117 = 117

SubCauseCodeType reserved118
uint8 CHOICE_RESERVED118 = 118

SubCauseCodeType reserved119
uint8 CHOICE_RESERVED119 = 119

SubCauseCodeType reserved120
uint8 CHOICE_RESERVED120 = 120

SubCauseCodeType reserved121
uint8 CHOICE_RESERVED121 = 121

SubCauseCodeType reserved122
uint8 CHOICE_RESERVED122 = 122

SubCauseCodeType reserved123
uint8 CHOICE_RESERVED123 = 123

SubCauseCodeType reserved124
uint8 CHOICE_RESERVED124 = 124

SubCauseCodeType reserved125
uint8 CHOICE_RESERVED125 = 125

SubCauseCodeType reserved126
uint8 CHOICE_RESERVED126 = 126

SubCauseCodeType reserved127
uint8 CHOICE_RESERVED127 = 127

SubCauseCodeType reserved128
uint8 CHOICE_RESERVED128 = 128


================================================================================
MSG: etsi_its_cam_ts_msgs/SubCauseCodeType
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
#   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
#   -t
#   cam_ts
#   -o
#   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE indicates the generic sub cause of a detected event.
#  * 
#  * @note: The sub cause code value assignment varies based on value of @ref CauseCode.
#  *
#  * @category: Traffic information
#  * @revision: Description revised in V2.1.1 (this is  the generic sub cause type)
#  */
# SubCauseCodeType ::= INTEGER (0..255)
# ------------------------------------------------------------------------------

uint8 value
uint8 MIN = 0
uint8 MAX = 255


================================================================================
MSG: etsi_its_cam_ts_msgs/TrafficConditionSubCauseCode
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
#   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
#   -t
#   cam_ts
#   -o
#   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE represents the value of the sub cause codes of the @ref CauseCode `trafficCondition`. 
#  * 
#  * The value shall be set to:
#  * - 0 `unavailable`                  - in case further detailed information on the traffic condition is unavailable,
#  * - 1 `increasedVolumeOfTraffic`     - in case the type of traffic condition is increased traffic volume,
#  * - 2 `trafficJamSlowlyIncreasing`   - in case the type of traffic condition is a traffic jam which volume is increasing slowly,
#  * - 3 `trafficJamIncreasing`         - in case the type of traffic condition is a traffic jam which volume is increasing,
#  * - 4 `trafficJamStronglyIncreasing` - in case the type of traffic condition is a traffic jam which volume is strongly increasing,
#  * - 5 `trafficJam`         `         - in case the type of traffic condition is a traffic jam and no further detailed information about its volume is available,
#  * - 6 `trafficJamSlightlyDecreasing` - in case the type of traffic condition is a traffic jam which volume is decreasing slowly,
#  * - 7 `trafficJamDecreasing`         - in case the type of traffic condition is a traffic jam which volume is decreasing,
#  * - 8 `trafficJamStronglyDecreasing` - in case the type of traffic condition is a traffic jam which volume is decreasing rapidly,
#  * - 9 `trafficJamStable`             - in case the traffic condition is a traffic jam with stable volume,
#  * - 10-255: reserved for future usage.
#  *
#  * @category: Traffic information
#  * @revision: V1.3.1, definition of value 0 and 1 changed in V2.2.1, name and definition of value 5 changed in V2.2.1, value 9 added in V2.2.1
#  */
# TrafficConditionSubCauseCode ::= INTEGER {
#     unavailable                  (0),
#     increasedVolumeOfTraffic     (1),
#     trafficJamSlowlyIncreasing   (2),
#     trafficJamIncreasing         (3),
#     trafficJamStronglyIncreasing (4),
#     trafficJam                   (5),
#     trafficJamSlightlyDecreasing (6),
#     trafficJamDecreasing         (7),
#     trafficJamStronglyDecreasing (8),
#     trafficJamStable             (9)
# } (0..255)
# ------------------------------------------------------------------------------

uint8 value
uint8 MIN = 0
uint8 MAX = 255
uint8 UNAVAILABLE = 0
uint8 INCREASED_VOLUME_OF_TRAFFIC = 1
uint8 TRAFFIC_JAM_SLOWLY_INCREASING = 2
uint8 TRAFFIC_JAM_INCREASING = 3
uint8 TRAFFIC_JAM_STRONGLY_INCREASING = 4
uint8 TRAFFIC_JAM = 5
uint8 TRAFFIC_JAM_SLIGHTLY_DECREASING = 6
uint8 TRAFFIC_JAM_DECREASING = 7
uint8 TRAFFIC_JAM_STRONGLY_DECREASING = 8
uint8 TRAFFIC_JAM_STABLE = 9


================================================================================
MSG: etsi_its_cam_ts_msgs/AccidentSubCauseCode
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
#   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
#   -t
#   cam_ts
#   -o
#   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE represents the value of the sub cause code of the @ref CauseCode `accident`.
#  *
#  * The value shall be set to:
#  * - 0 - `unavailable`                        - in case the information on the sub cause of the accident is unavailable,
#  * - 1 - `multiVehicleAccident`               - in case more than two vehicles are involved in accident,
#  * - 2 - `heavyAccident`                      - in case the airbag of the vehicle involved in the accident is triggered, 
#  *                                              the accident requires important rescue and/or recovery work,
#  * - 3 - `accidentInvolvingLorry`             - in case the accident involves a lorry,
#  * - 4 - `accidentInvolvingBus`               - in case the accident involves a bus,
#  * - 5 - `accidentInvolvingHazardousMaterials`- in case the accident involves hazardous material,
#  * - 6 - `accidentOnOppositeLane`             - in case the accident happens on opposite lanes,
#  * - 7 - `unsecuredAccident`                  - in case the accident is not secured,
#  * - 8 - `assistanceRequested`                - in case rescue and assistance are requested,
#  * - 9-255                                    - reserved for future usage. 
#  *
#  * @category: Traffic information
#  * @revision: V1.3.1
#  */
# AccidentSubCauseCode ::= INTEGER {
#     unavailable                         (0),
#     multiVehicleAccident                (1),
#     heavyAccident                       (2),
#     accidentInvolvingLorry              (3),
#     accidentInvolvingBus                (4),
#     accidentInvolvingHazardousMaterials (5),
#     accidentOnOppositeLane              (6),
#     unsecuredAccident                   (7),
#     assistanceRequested                 (8)
# } (0..255)
# ------------------------------------------------------------------------------

uint8 value
uint8 MIN = 0
uint8 MAX = 255
uint8 UNAVAILABLE = 0
uint8 MULTI_VEHICLE_ACCIDENT = 1
uint8 HEAVY_ACCIDENT = 2
uint8 ACCIDENT_INVOLVING_LORRY = 3
uint8 ACCIDENT_INVOLVING_BUS = 4
uint8 ACCIDENT_INVOLVING_HAZARDOUS_MATERIALS = 5
uint8 ACCIDENT_ON_OPPOSITE_LANE = 6
uint8 UNSECURED_ACCIDENT = 7
uint8 ASSISTANCE_REQUESTED = 8


================================================================================
MSG: etsi_its_cam_ts_msgs/ImpassabilitySubCauseCode
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
#   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
#   -t
#   cam_ts
#   -o
#   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE represents the value of the sub cause codes of the @ref CauseCode `impassability`
#  * 
#  * The value shall be set to:
#  * - 0 `unavailable`              - in case further detailed information about the unmanaged road blockage is unavailable,
#  * - 1 `flooding          `       - in case the road is affected by flooding,
#  * - 2 `dangerOfAvalanches`       - in case the road is at risk of being affected or blocked by avalanches,
#  * - 3 `blastingOfAvalanches`     - in case there is an active blasting of avalanches on or near the road,
#  * - 4 `landslips`                - in case the road is affected by landslips,
#  * - 5 `chemicalSpillage`         - in case the road is affected by chemical spillage,
#  * - 6 `winterClosure`            - in case the road is impassable due to a winter closure.
#  * - 7 `sinkhole`                 - in case the road is impassable due to large holes in the road surface.
#  * - 8 `earthquakeDamage`         - in case the road is obstructed or partially obstructed because of damage caused by an earthquake.
#  * - 9 `fallenTrees`              - in case the road is obstructed or partially obstructed by one or more fallen trees. 
#  * - 10 `rockfalls`               - in case the road is obstructed or partially obstructed due to fallen rocks.
#  * - 11 `sewerOverflow`           - in case the road is obstructed or partially obstructed by overflows from one or more sewers. 
#  * - 12 `stormDamage`             - in case the road is obstructed or partially obstructed by debris caused by strong winds.
#  * - 13 `subsidence`              - in case the road surface has sunken or collapsed in places.
#  * - 14 `burstPipe`               - in case the road surface has sunken or collapsed in places due to burst pipes.
#  * - 15 `burstWaterMain`          - in case the road is obstructed due to local flooding and/or subsidence. 
#  * - 16 `fallenPowerCables`       - in case the road is obstructed or partly obstructed by one or more fallen power cables.
#  * - 17 `snowDrifts`              - in case the road is obstructed or partially obstructed by snow drifting in progress or patches of deep snow due to earlier drifting.
#  * - 15-255                       - are reserved for future usage.
#  *
#  * @category: Traffic information
#  * @revision: Created in V2.2.1
# */
# ImpassabilitySubCauseCode ::= INTEGER {
#     unavailable               (0), 
#     flooding                  (1),
#     dangerOfAvalanches        (2), 
#     blastingOfAvalanches      (3), 
#     landslips                 (4), 
#     chemicalSpillage          (5),
#     winterClosure             (6),
#     sinkhole                  (7),
#     earthquakeDamage          (8),
#     fallenTrees               (9),
#     rockfalls                 (10),
#     sewerOverflow             (11),
#     stormDamage               (12),
#     subsidence                (13),
#     burstPipe                 (14),
#     burstWaterMain            (15),
#     fallenPowerCables         (16),
#     snowDrifts                (17)
# } (0..255)
# ------------------------------------------------------------------------------

uint8 value
uint8 MIN = 0
uint8 MAX = 255
uint8 UNAVAILABLE = 0
uint8 FLOODING = 1
uint8 DANGER_OF_AVALANCHES = 2
uint8 BLASTING_OF_AVALANCHES = 3
uint8 LANDSLIPS = 4
uint8 CHEMICAL_SPILLAGE = 5
uint8 WINTER_CLOSURE = 6
uint8 SINKHOLE = 7
uint8 EARTHQUAKE_DAMAGE = 8
uint8 FALLEN_TREES = 9
uint8 ROCKFALLS = 10
uint8 SEWER_OVERFLOW = 11
uint8 STORM_DAMAGE = 12
uint8 SUBSIDENCE = 13
uint8 BURST_PIPE = 14
uint8 BURST_WATER_MAIN = 15
uint8 FALLEN_POWER_CABLES = 16
uint8 SNOW_DRIFTS = 17


================================================================================
MSG: etsi_its_cam_ts_msgs/AdverseWeatherConditionAdhesionSubCauseCode
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
#   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
#   -t
#   cam_ts
#   -o
#   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE represents the value of the sub cause code of the @ref CauseCode `adverseWeatherCondition-Adhesion`. 
#  * 
#  * The value shall be set to:
#  * - 0 - `unavailable`     - in case information on the cause of the low road adhesion is unavailable,
#  * - 1 - `heavyFrostOnRoad`- in case the low road adhesion is due to heavy frost on the road,
#  * - 2 - `fuelOnRoad`      - in case the low road adhesion is due to fuel on the road,
#  * - 3 - `mudOnRoad`       - in case the low road adhesion is due to mud on the road,
#  * - 4 - `snowOnRoad`      - in case the low road adhesion is due to snow on the road,
#  * - 5 - `iceOnRoad`       - in case the low road adhesion is due to ice on the road,
#  * - 6 - `blackIceOnRoad`  - in case the low road adhesion is due to black ice on the road,
#  * - 7 - `oilOnRoad`       - in case the low road adhesion is due to oil on the road,
#  * - 8 - `looseChippings`  - in case the low road adhesion is due to loose gravel or stone fragments detached from a road surface or from a hazard,
#  * - 9 - `instantBlackIce` - in case the low road adhesion is due to instant black ice on the road surface,
#  * - 10 - `roadsSalted`    - when the low road adhesion is due to salted road,
#  * - 11-255                - are reserved for future usage.
#  *
#  * @category: Traffic information
#  * @revision: V1.3.1
#  */
# AdverseWeatherCondition-AdhesionSubCauseCode ::= INTEGER {
#     unavailable      (0),
#     heavyFrostOnRoad (1),
#     fuelOnRoad       (2),
#     mudOnRoad        (3),
#     snowOnRoad       (4),
#     iceOnRoad        (5),
#     blackIceOnRoad   (6),
#     oilOnRoad        (7),
#     looseChippings   (8),
#     instantBlackIce  (9),
#     roadsSalted      (10)
# } (0..255)
# ------------------------------------------------------------------------------

uint8 value
uint8 MIN = 0
uint8 MAX = 255
uint8 UNAVAILABLE = 0
uint8 HEAVY_FROST_ON_ROAD = 1
uint8 FUEL_ON_ROAD = 2
uint8 MUD_ON_ROAD = 3
uint8 SNOW_ON_ROAD = 4
uint8 ICE_ON_ROAD = 5
uint8 BLACK_ICE_ON_ROAD = 6
uint8 OIL_ON_ROAD = 7
uint8 LOOSE_CHIPPINGS = 8
uint8 INSTANT_BLACK_ICE = 9
uint8 ROADS_SALTED = 10


================================================================================
MSG: etsi_its_cam_ts_msgs/HazardousLocationSurfaceConditionSubCauseCode
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
#   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
#   -t
#   cam_ts
#   -o
#   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE represents the value of the sub cause code of the @ref CauseCode `hazardousLocation-SurfaceCondition`. 
#  * 
# The value shall be set to:
#  * - 0  - `unavailable`     - in case further detailed information on the road surface condition is unavailable,
#  * - 1  - `rockfalls`       - in case rock falls are detected on the road surface,
#  * - 2  - `earthquakeDamage`- in case the road surface is damaged by earthquake,
#  * - 3  - `sewerCollapse`   - in case of sewer collapse on the road surface,
#  * - 4  - `subsidence`      - in case road surface is damaged by subsidence,
#  * - 5  - `snowDrifts`      - in case road surface is damaged due to snow drift,
#  * - 6  - `stormDamage`     - in case road surface is damaged by strong storm,
#  * - 7  - `burstPipe`       - in case road surface is damaged due to pipe burst,
#  * - 8  - `volcanoEruption` - in case road surface is damaged due to volcano eruption,
#  * - 9  - `fallingIce`      - in case road surface damage is due to falling ice,
#  * - 10 - `fire`            - in case there is fire on or near to the road surface.
#  * - 11-255                 - are reserved for future usage.
#  *
#  * @category: Traffic information
#  * @revision: V1.3.1
#  */
# HazardousLocation-SurfaceConditionSubCauseCode ::= INTEGER {
#     unavailable      (0), 
#     rockfalls        (1), 
#     earthquakeDamage (2), 
#     sewerCollapse    (3), 
#     subsidence       (4), 
#     snowDrifts       (5), 
#     stormDamage      (6), 
#     burstPipe        (7), 
#     volcanoEruption  (8), 
#     fallingIce       (9), 
#     fire             (10)
# } (0..255)
# ------------------------------------------------------------------------------

uint8 value
uint8 MIN = 0
uint8 MAX = 255
uint8 UNAVAILABLE = 0
uint8 ROCKFALLS = 1
uint8 EARTHQUAKE_DAMAGE = 2
uint8 SEWER_COLLAPSE = 3
uint8 SUBSIDENCE = 4
uint8 SNOW_DRIFTS = 5
uint8 STORM_DAMAGE = 6
uint8 BURST_PIPE = 7
uint8 VOLCANO_ERUPTION = 8
uint8 FALLING_ICE = 9
uint8 FIRE = 10


================================================================================
MSG: etsi_its_cam_ts_msgs/HazardousLocationObstacleOnTheRoadSubCauseCode
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
#   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
#   -t
#   cam_ts
#   -o
#   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE represents the value of the sub cause code of the @ref CauseCode `hazardousLocation-ObstacleOnTheRoad`. 
#  * 
#  * The value shall be set to:
#  * - 0 - `unavailable`    - in case further detailed information on the detected obstacle is unavailable,
#  * - 1 - `shedLoad`       - in case detected obstacle is large amount of obstacles (shedload),
#  * - 2 - `partsOfVehicles`- in case detected obstacles are parts of vehicles,
#  * - 3 - `partsOfTyres`   - in case the detected obstacles are parts of tyres,
#  * - 4 - `bigObjects`     - in case the detected obstacles are big objects,
#  * - 5 - `fallenTrees`    - in case the detected obstacles are fallen trees,
#  * - 6 - `hubCaps`        - in case the detected obstacles are hub caps,
#  * - 7 - `waitingVehicles`- in case the detected obstacles are waiting vehicles.
#  * - 8-255                - are reserved for future usage.
#  *
#  * @category: Traffic information
#  * @revision: V1.3.1
#  */
# HazardousLocation-ObstacleOnTheRoadSubCauseCode ::= INTEGER {
#     unavailable     (0), 
#     shedLoad        (1), 
#     partsOfVehicles (2), 
#     partsOfTyres    (3), 
#     bigObjects      (4), 
#     fallenTrees     (5), 
#     hubCaps         (6), 
#     waitingVehicles (7)
# } (0..255)
# ------------------------------------------------------------------------------

uint8 value
uint8 MIN = 0
uint8 MAX = 255
uint8 UNAVAILABLE = 0
uint8 SHED_LOAD = 1
uint8 PARTS_OF_VEHICLES = 2
uint8 PARTS_OF_TYRES = 3
uint8 BIG_OBJECTS = 4
uint8 FALLEN_TREES = 5
uint8 HUB_CAPS = 6
uint8 WAITING_VEHICLES = 7


================================================================================
MSG: etsi_its_cam_ts_msgs/HazardousLocationAnimalOnTheRoadSubCauseCode
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
#   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
#   -t
#   cam_ts
#   -o
#   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE represents the value of the sub cause code of the @ref CauseCode `hazardousLocation-AnimalOnTheRoad`.
#  * 
#  * The value shall be set to:
#  * - 0 - `unavailable`          - in case further detailed information on the animal(s) on the road is unavailable,
#  * - 1 - `wildAnimals`          - in case wild animals of unknown size are present on the road,
#  * - 2 - `herdOfAnimals`        - in case a herd of animals is present on the road,
#  * - 3 - `smallAnimals`         - in case small size animals of unknown type are present on the road,
#  * - 4 - `largeAnimals`         - in case large size animals of unknown type are present on the road,
#  * - 5 - `wildAnimalsSmall`     - in case small size wild animal(s) are present on the road,
#  * - 6 - `wildAnimalsLarge`     - in case large size wild animal(s) are present on the road,
#  * - 7 - `domesticAnimals`      - in case domestic animal(s) of unknown size are detected on the road,
#  * - 8 - `domesticAnimalsSmall` - in case small size domestic animal(s) are present on the road,
#  * - 9 - `domesticAnimalsLarge` - in case large size domestic animal(s) are present on the road.
#  * - 10-255                     - are reserved for future usage.
#  *
#  * @category: Traffic information
#  * @revision: V1.3.1, named values 5 to 9 added in V2.2.1 
#  */
# HazardousLocation-AnimalOnTheRoadSubCauseCode ::= INTEGER {
#     unavailable           (0), 
#     wildAnimals           (1), 
#     herdOfAnimals         (2), 
#     smallAnimals          (3), 
#     largeAnimals          (4),
#     wildAnimalsSmall      (5),
#     wildAnimalsLarge      (6),
#     domesticAnimals       (7),
#     domesticAnimalsSmall  (8),
#     domesticAnimalsLarge  (9)
# } (0..255)
# ------------------------------------------------------------------------------

uint8 value
uint8 MIN = 0
uint8 MAX = 255
uint8 UNAVAILABLE = 0
uint8 WILD_ANIMALS = 1
uint8 HERD_OF_ANIMALS = 2
uint8 SMALL_ANIMALS = 3
uint8 LARGE_ANIMALS = 4
uint8 WILD_ANIMALS_SMALL = 5
uint8 WILD_ANIMALS_LARGE = 6
uint8 DOMESTIC_ANIMALS = 7
uint8 DOMESTIC_ANIMALS_SMALL = 8
uint8 DOMESTIC_ANIMALS_LARGE = 9


================================================================================
MSG: etsi_its_cam_ts_msgs/HumanPresenceOnTheRoadSubCauseCode
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
#   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
#   -t
#   cam_ts
#   -o
#   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE represents the value of the sub cause code of the @ref CauseCode `humanPresenceOnTheRoad`.
#  * 
#  * The value shall be set to:
#  * - 0 - `unavailable`                    - in case further detailed information abou the human presence on the road is unavailable,
#  * - 1 - `childrenOnRoadway`              - in case children are present on the road,
#  * - 2 - `cyclistOnRoadway`               - in case cyclist(s) are present on the road,
#  * - 3 - `motorcyclistOnRoadway`          - in case motorcyclist(s) are present on the road,
#  * - 4 - `pedestrian`                     - in case pedestrian(s) of any type are present on the road,
#  * - 5 - `ordinary-pedestrian`            - in case pedestrian(s) to which no more-specific profile applies are present on the road,
#  * - 6 - `road-worker`                    - in case pedestrian(s) with the role of a road worker applies are present on the road,
#  * - 7 - `first-responder`                - in case pedestrian(s) with the role of a first responder applies are present on the road,  
#  * - 8 - `lightVruVehicle                 - in case light vru vehicle(s) of any type are present on the road,
#  * - 9 - `bicyclist `                     - in case cycle(s) and their bicyclist(s) are present on the road,
#  * - 10 - `wheelchair-user`               - in case wheelchair(s) and their user(s) are present on the road,
#  * - 11 - `horse-and-rider`               - in case horse(s) and rider(s) are present on the road,
#  * - 12 - `rollerskater`                  - in case rolleskater(s) and skater(s) are present on the road,
#  * - 13 - `e-scooter`                     - in case e-scooter(s) and rider(s) are present on the road,
#  * - 14 - `personal-transporter`          - in case personal-transporter(s) and rider(s) are present on the road,
#  * - 15 - `pedelec`                       - in case pedelec(s) and rider(s) are present on the road,
#  * - 16 - `speed-pedelec`                 - in case speed-pedelec(s) and rider(s) are present on the road,
#  * - 17 - `ptw`                           - in case powered-two-wheeler(s) of any type are present on the road,
#  * - 18 - `moped`                         - in case moped(s) and rider(s) are present on the road,
#  * - 19 - `motorcycle`                    - in case motorcycle(s) and rider(s) are present on the road,
#  * - 20 - `motorcycle-and-sidecar-right`  - in case motorcycle(s) with sidecar(s) on the right and rider are present on the road,
#  * - 21 - `motorcycle-and-sidecar-left`   - in case motorcycle(s) with sidecar(s) on the left and rider are present on the road.
#  * - 22-255                               - are reserved for future usage.
#  *
#  * @category: Traffic information
#  * @revision: editorial revision in V2.1.1, named values 4-21 added in V2.2.1
#  */
# HumanPresenceOnTheRoadSubCauseCode ::= INTEGER {
#     unavailable                  (0), 
#     childrenOnRoadway            (1), 
#     cyclistOnRoadway             (2), 
#     motorcyclistOnRoadway        (3),
#     pedestrian                   (4),
#     ordinary-pedestrian          (5),
#     road-worker                  (6),
#     first-responder              (7),
#     lightVruVehicle              (8), 
#     bicyclist                    (9), 
#     wheelchair-user              (10), 
#     horse-and-rider              (11), 
#     rollerskater                 (12), 
#     e-scooter                    (13), 
#     personal-transporter         (14),
#     pedelec                      (15), 
#     speed-pedelec                (16),
#     ptw                          (17), 
#     moped                        (18), 
#     motorcycle                   (19), 
#     motorcycle-and-sidecar-right (20), 
#     motorcycle-and-sidecar-left  (21)
# } (0..255)
# ------------------------------------------------------------------------------

uint8 value
uint8 MIN = 0
uint8 MAX = 255
uint8 UNAVAILABLE = 0
uint8 CHILDREN_ON_ROADWAY = 1
uint8 CYCLIST_ON_ROADWAY = 2
uint8 MOTORCYCLIST_ON_ROADWAY = 3
uint8 PEDESTRIAN = 4
uint8 ORDINARY_PEDESTRIAN = 5
uint8 ROAD_WORKER = 6
uint8 FIRST_RESPONDER = 7
uint8 LIGHT_VRU_VEHICLE = 8
uint8 BICYCLIST = 9
uint8 WHEELCHAIR_USER = 10
uint8 HORSE_AND_RIDER = 11
uint8 ROLLERSKATER = 12
uint8 E_SCOOTER = 13
uint8 PERSONAL_TRANSPORTER = 14
uint8 PEDELEC = 15
uint8 SPEED_PEDELEC = 16
uint8 PTW = 17
uint8 MOPED = 18
uint8 MOTORCYCLE = 19
uint8 MOTORCYCLE_AND_SIDECAR_RIGHT = 20
uint8 MOTORCYCLE_AND_SIDECAR_LEFT = 21


================================================================================
MSG: etsi_its_cam_ts_msgs/WrongWayDrivingSubCauseCode
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
#   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
#   -t
#   cam_ts
#   -o
#   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE represents the sub cause codes of the @ref CauseCode `wrongWayDriving` .
#  * 
#  * The value shall be set to:
#  * - 0 `unavailable`    - in case further detailed information on wrong way driving event is unavailable,
#  * - 1 `wrongLane`      - in case vehicle is driving on a lane for which it has no authorization to use,
#  * - 2 `wrongDirection` - in case vehicle is driving in a direction that it is not allowed,
#  * - 3-255              - reserved for future usage.
#  * 
#  * @category: Traffic information
#  * @revision: V1.3.1
#  */
# WrongWayDrivingSubCauseCode ::= INTEGER {
#     unavailable    (0), 
#     wrongLane      (1), 
#     wrongDirection (2)
# } (0..255)
# ------------------------------------------------------------------------------

uint8 value
uint8 MIN = 0
uint8 MAX = 255
uint8 UNAVAILABLE = 0
uint8 WRONG_LANE = 1
uint8 WRONG_DIRECTION = 2


================================================================================
MSG: etsi_its_cam_ts_msgs/RescueAndRecoveryWorkInProgressSubCauseCode
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
#   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
#   -t
#   cam_ts
#   -o
#   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE represents the value of the sub cause codes of the @ref CauseCode `rescueAndRecoveryWorkInProgress` 
#  * 
#  * The value shall be set to:
#  * - 0 `unavailable`              - in case further detailed information on rescue and recovery work is unavailable,
#  * - 1 `emergencyVehicles`        - in case rescue and/or safeguarding work is ongoing by emergency vehicles, i.e. by vehicles that have the absolute right of way,
#  * - 2 `rescueHelicopterLanding`  - in case rescue helicopter is landing,
#  * - 3 `policeActivityOngoing`    - in case police activity is ongoing (only to be used if a more specific sub cause than (1) is needed),
#  * - 4 `medicalEmergencyOngoing`  - in case medical emergency recovery is ongoing (only to be used if a more specific sub cause than (1) is needed),
#  * - 5 `childAbductionInProgress` - in case a child kidnapping alarm is activated and rescue work is ongoing (only to be used if a more specific sub cause than (1) is needed),
#  * - 6 `prioritizedVehicle`       - in case rescue and/or safeguarding work is ongoing by prioritized vehicles, i.e. by vehicles that have priority but not the absolute right of way,
#  * - 7 `rescueAndRecoveryVehicle` - in case technical rescue work is ongoing by rescue and recovery vehicles.
#  * - 8-255: reserved for future usage.
# 
#  *
#  * @category: Traffic information
#  * @revision: V1.3.1, named values 6 and 7 added in V2.2.1
#  */
# RescueAndRecoveryWorkInProgressSubCauseCode ::= INTEGER {
#    unavailable              (0), 
#    emergencyVehicles        (1), 
#    rescueHelicopterLanding  (2), 
#    policeActivityOngoing    (3), 
#    medicalEmergencyOngoing  (4), 
#    childAbductionInProgress (5),
#    prioritizedVehicle       (6),
#    rescueAndRecoveryVehicle (7)
# } (0..255)
# ------------------------------------------------------------------------------

uint8 value
uint8 MIN = 0
uint8 MAX = 255
uint8 UNAVAILABLE = 0
uint8 EMERGENCY_VEHICLES = 1
uint8 RESCUE_HELICOPTER_LANDING = 2
uint8 POLICE_ACTIVITY_ONGOING = 3
uint8 MEDICAL_EMERGENCY_ONGOING = 4
uint8 CHILD_ABDUCTION_IN_PROGRESS = 5
uint8 PRIORITIZED_VEHICLE = 6
uint8 RESCUE_AND_RECOVERY_VEHICLE = 7


================================================================================
MSG: etsi_its_cam_ts_msgs/AdverseWeatherConditionExtremeWeatherConditionSubCauseCode
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
#   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
#   -t
#   cam_ts
#   -o
#   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE represents the value of the sub cause codes of the @ref CauseCode `adverseWeatherCondition-ExtremeWeatherCondition`.
#  *
#  * The value shall be set to:
#  * - 0 - `unavailable` - in case information on the type of extreme weather condition is unavailable,
#  * - 1 - `strongWinds` - in case the type of extreme weather condition is strong wind,
#  * - 2 - `damagingHail`- in case the type of extreme weather condition is damaging hail,
#  * - 3 - `hurricane`   - in case the type of extreme weather condition is hurricane,
#  * - 4 - `thunderstorm`- in case the type of extreme weather condition is thunderstorm,
#  * - 5 - `tornado`     - in case the type of extreme weather condition is tornado,
#  * - 6 - `blizzard`    - in case the type of extreme weather condition is blizzard.
#  * - 7-255             - are reserved for future usage.
#  *
#  * @category: Traffic information
#  * @revision: V1.3.1
#  */
# AdverseWeatherCondition-ExtremeWeatherConditionSubCauseCode ::= INTEGER {
#     unavailable  (0),
#     strongWinds  (1),
#     damagingHail (2),
#     hurricane    (3),
#     thunderstorm (4),
#     tornado      (5),
#     blizzard     (6)
# } (0..255)
# ------------------------------------------------------------------------------

uint8 value
uint8 MIN = 0
uint8 MAX = 255
uint8 UNAVAILABLE = 0
uint8 STRONG_WINDS = 1
uint8 DAMAGING_HAIL = 2
uint8 HURRICANE = 3
uint8 THUNDERSTORM = 4
uint8 TORNADO = 5
uint8 BLIZZARD = 6


================================================================================
MSG: etsi_its_cam_ts_msgs/AdverseWeatherConditionVisibilitySubCauseCode
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
#   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
#   -t
#   cam_ts
#   -o
#   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE represents the value of the sub cause codes of the @ref CauseCode `adverseWeatherCondition-Visibility`.
#  *
#  * The value shall be set to:
#  * - 0 - `unavailable`    - in case information on the cause of low visibility is unavailable,
#  * - 1 - `fog`            - in case the cause of low visibility is fog,
#  * - 2 - `smoke`          - in case the cause of low visibility is smoke,
#  * - 3 - `heavySnowfall`  - in case the cause of low visibility is heavy snow fall,
#  * - 4 - `heavyRain`      - in case the cause of low visibility is heavy rain,
#  * - 5 - `heavyHail`      - in case the cause of low visibility is heavy hail,
#  * - 6 - `lowSunGlare`    - in case the cause of low visibility is sun glare,
#  * - 7 - `sandstorms`     - in case the cause of low visibility is sand storm,
#  * - 8 - `swarmsOfInsects`- in case the cause of low visibility is swarm of insects.
#  * - 9-255                - are reserved for future usage
#  *
#  * @category: Traffic information
#  * @revision: V1.3.1
#  */
# AdverseWeatherCondition-VisibilitySubCauseCode ::= INTEGER {
#     unavailable     (0),
#     fog             (1),
#     smoke           (2),
#     heavySnowfall   (3),
#     heavyRain       (4),
#     heavyHail       (5),
#     lowSunGlare     (6),
#     sandstorms      (7),
#     swarmsOfInsects (8)
# } (0..255)
# ------------------------------------------------------------------------------

uint8 value
uint8 MIN = 0
uint8 MAX = 255
uint8 UNAVAILABLE = 0
uint8 FOG = 1
uint8 SMOKE = 2
uint8 HEAVY_SNOWFALL = 3
uint8 HEAVY_RAIN = 4
uint8 HEAVY_HAIL = 5
uint8 LOW_SUN_GLARE = 6
uint8 SANDSTORMS = 7
uint8 SWARMS_OF_INSECTS = 8


================================================================================
MSG: etsi_its_cam_ts_msgs/AdverseWeatherConditionPrecipitationSubCauseCode
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
#   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
#   -t
#   cam_ts
#   -o
#   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE represents the value of the sub cause codes of the @ref CauseCode `adverseWeatherCondition-Precipitation`. 
#  *
#  * The value shall be set to:
#  * - 0 - `unavailable`   - in case information on the type of precipitation is unavailable,
#  * - 1 - `heavyRain`     - in case the type of precipitation is heavy rain,
#  * - 2 - `heavySnowfall` - in case the type of precipitation is heavy snow fall,
#  * - 3 - `softHail`      - in case the type of precipitation is soft hail.
#  * - 4-255               - are reserved for future usage
#  *
#  * @category: Traffic information
#  * @revision: V1.3.1
#  */
# AdverseWeatherCondition-PrecipitationSubCauseCode ::= INTEGER {
#     unavailable   (0),
#     heavyRain     (1),
#     heavySnowfall (2),
#     softHail      (3)
# } (0..255)
# ------------------------------------------------------------------------------

uint8 value
uint8 MIN = 0
uint8 MAX = 255
uint8 UNAVAILABLE = 0
uint8 HEAVY_RAIN = 1
uint8 HEAVY_SNOWFALL = 2
uint8 SOFT_HAIL = 3


================================================================================
MSG: etsi_its_cam_ts_msgs/SlowVehicleSubCauseCode
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
#   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
#   -t
#   cam_ts
#   -o
#   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE represents the sub cause codes of the @ref CauseCode "slowVehicle".
#  * 
#  * The value shall be set to:
#  * - 0 `unavailable`                    - in case further detailed information on slow vehicle driving event is
#  *                                        unavailable,
#  * - 1 `maintenanceVehicle`             - in case of a slow driving maintenance vehicle on the road,
#  * - 2 `vehiclesSlowingToLookAtAccident`- in case vehicle is temporally slowing down to look at accident, spot, etc.,
#  * - 3 `abnormalLoad`                   - in case an abnormal loaded vehicle is driving slowly on the road,
#  * - 4 `abnormalWideLoad`               - in case an abnormal wide load vehicle is driving slowly on the road,
#  * - 5 `convoy`                         - in case of slow driving convoy on the road,
#  * - 6 `snowplough`                     - in case of slow driving snow plough on the road,
#  * - 7 `deicing`                        - in case of slow driving de-icing vehicle on the road,
#  * - 8 `saltingVehicles`                - in case of slow driving salting vehicle on the road.
#  * - 9-255                              - are reserved for future usage.
#  * 
#  * @category: Traffic information
#  * @revision: V1.3.1
#  */
# SlowVehicleSubCauseCode ::= INTEGER {
#     unavailable                     (0), 
#     maintenanceVehicle              (1), 
#     vehiclesSlowingToLookAtAccident (2), 
#     abnormalLoad                    (3), 
#     abnormalWideLoad                (4), 
#     convoy                          (5), 
#     snowplough                      (6), 
#     deicing                         (7), 
#     saltingVehicles                 (8)
# } (0..255)
# ------------------------------------------------------------------------------

uint8 value
uint8 MIN = 0
uint8 MAX = 255
uint8 UNAVAILABLE = 0
uint8 MAINTENANCE_VEHICLE = 1
uint8 VEHICLES_SLOWING_TO_LOOK_AT_ACCIDENT = 2
uint8 ABNORMAL_LOAD = 3
uint8 ABNORMAL_WIDE_LOAD = 4
uint8 CONVOY = 5
uint8 SNOWPLOUGH = 6
uint8 DEICING = 7
uint8 SALTING_VEHICLES = 8


================================================================================
MSG: etsi_its_cam_ts_msgs/DangerousEndOfQueueSubCauseCode
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
#   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
#   -t
#   cam_ts
#   -o
#   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE represents the value of the sub cause codes of the @ref CauseCode `dangerousEndOfQueue`. 
#  * 
#  * The value shall be set to:
#  * - 0 - `unavailable`     - in case information on the type of dangerous queue is unavailable,
#  * - 1 - `suddenEndOfQueue`- in case a sudden end of queue is detected, e.g. due to accident or obstacle,
#  * - 2 - `queueOverHill`   - in case the dangerous end of queue is detected on the road hill,
#  * - 3 - `queueAroundBend` - in case the dangerous end of queue is detected around the road bend,
#  * - 4 - `queueInTunnel`   - in case queue is detected in tunnel,
#  * - 5-255                 - reserved for future usage.
#  *
#  * @category: Traffic information
#  * @revision: V1.3.1
#  */
# DangerousEndOfQueueSubCauseCode ::= INTEGER {
#     unavailable      (0), 
#     suddenEndOfQueue (1), 
#     queueOverHill    (2), 
#     queueAroundBend  (3), 
#     queueInTunnel    (4)
# } (0..255)
# ------------------------------------------------------------------------------

uint8 value
uint8 MIN = 0
uint8 MAX = 255
uint8 UNAVAILABLE = 0
uint8 SUDDEN_END_OF_QUEUE = 1
uint8 QUEUE_OVER_HILL = 2
uint8 QUEUE_AROUND_BEND = 3
uint8 QUEUE_IN_TUNNEL = 4


================================================================================
MSG: etsi_its_cam_ts_msgs/VehicleBreakdownSubCauseCode
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
#   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
#   -t
#   cam_ts
#   -o
#   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE represents the value of the sub cause codes of the @ref CauseCode `vehicleBreakdown`. 
#  * 
#  * The value shall be set to:
#  * - 0 `unavailable`         - in case further detailed information on cause of vehicle break down is unavailable,
#  * - 1 `lackOfFuel`          - in case vehicle break down is due to lack of fuel,
#  * - 2 `lackOfBatteryPower`  - in case vehicle break down is caused by lack of battery power,
#  * - 3 `engineProblem`       - in case vehicle break down is caused by an engine problem,
#  * - 4 `transmissionProblem` - in case vehicle break down is caused by transmission problem,
#  * - 5 `engineCoolingProblem`- in case vehicle break down is caused by an engine cooling problem,
#  * - 6 `brakingSystemProblem`- in case vehicle break down is caused by a braking system problem,
#  * - 7 `steeringProblem`     - in case vehicle break down is caused by a steering problem,
#  * - 8 `tyrePuncture`        - in case vehicle break down is caused by tyre puncture,
#  * - 9 `tyrePressureProblem` - in case low tyre pressure in detected,
#  * - 10 `vehicleOnFire`      - in case the vehicle is on fire.
#  * - 11-255                  - are reserved for future usage.
#  *
#  * @category: Traffic information
# 
#  */
# VehicleBreakdownSubCauseCode ::= INTEGER {
#     unavailable          (0), 
#     lackOfFuel           (1), 
#     lackOfBatteryPower   (2), 
#     engineProblem        (3), 
#     transmissionProblem  (4), 
#     engineCoolingProblem (5), 
#     brakingSystemProblem (6), 
#     steeringProblem      (7), 
#     tyrePuncture         (8), 
#     tyrePressureProblem  (9), 
#     vehicleOnFire        (10)
# } (0..255)
# ------------------------------------------------------------------------------

uint8 value
uint8 MIN = 0
uint8 MAX = 255
uint8 UNAVAILABLE = 0
uint8 LACK_OF_FUEL = 1
uint8 LACK_OF_BATTERY_POWER = 2
uint8 ENGINE_PROBLEM = 3
uint8 TRANSMISSION_PROBLEM = 4
uint8 ENGINE_COOLING_PROBLEM = 5
uint8 BRAKING_SYSTEM_PROBLEM = 6
uint8 STEERING_PROBLEM = 7
uint8 TYRE_PUNCTURE = 8
uint8 TYRE_PRESSURE_PROBLEM = 9
uint8 VEHICLE_ON_FIRE = 10


================================================================================
MSG: etsi_its_cam_ts_msgs/PostCrashSubCauseCode
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
#   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
#   -t
#   cam_ts
#   -o
#   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE represents the value of the sub cause codes of the @ref CauseCode `postCrash` .
#  * 
#  * The value shall be set to:
#  * - 0 `unavailable`                                               - in case further detailed information on post crash event is unavailable,
#  * - 1 `accidentWithoutECallTriggered`                             - in case no eCall has been triggered for an accident,
#  * - 2 `accidentWithECallManuallyTriggered`                        - in case eCall has been manually triggered and transmitted to eCall back end,
#  * - 3 `accidentWithECallAutomaticallyTriggered`                   - in case eCall has been automatically triggered and transmitted to eCall back end,
#  * - 4 `accidentWithECallTriggeredWithoutAccessToCellularNetwork`  - in case eCall has been triggered but cellular network is not accessible from triggering vehicle.
#  * - 5-255                                                         - are reserved for future usage.
#  *
#  * @category: Traffic information
#  * @revision: V1.3.1
#  */
# PostCrashSubCauseCode ::= INTEGER {
#     unavailable                                              (0), 
#     accidentWithoutECallTriggered                            (1), 
#     accidentWithECallManuallyTriggered                       (2), 
#     accidentWithECallAutomaticallyTriggered                  (3), 
#     accidentWithECallTriggeredWithoutAccessToCellularNetwork (4)
# } (0..255)
# ------------------------------------------------------------------------------

uint8 value
uint8 MIN = 0
uint8 MAX = 255
uint8 UNAVAILABLE = 0
uint8 ACCIDENT_WITHOUT_E_CALL_TRIGGERED = 1
uint8 ACCIDENT_WITH_E_CALL_MANUALLY_TRIGGERED = 2
uint8 ACCIDENT_WITH_E_CALL_AUTOMATICALLY_TRIGGERED = 3
uint8 ACCIDENT_WITH_E_CALL_TRIGGERED_WITHOUT_ACCESS_TO_CELLULAR_NETWORK = 4


================================================================================
MSG: etsi_its_cam_ts_msgs/HumanProblemSubCauseCode
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
#   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
#   -t
#   cam_ts
#   -o
#   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE represents the value of the sub cause codes of the @ref CauseCode "humanProblem".
#  * 
#  * The value shall be set to:
#  * - 0 - `unavailable`    - in case further detailed information on human health problem is unavailable,
#  * - 1 - `glycemiaProblem`- in case human problem is due to glycaemia problem,
#  * - 2 - `heartProblem`   - in case human problem is due to heart problem.
#  * - 3-255                - reserved for future usage.
#  *
#  * @category: Traffic information
#  * @revision: V1.3.1
#  */
# HumanProblemSubCauseCode ::= INTEGER {
#     unavailable     (0), 
#     glycemiaProblem (1), 
#     heartProblem    (2)
# } (0..255)
# ------------------------------------------------------------------------------

uint8 value
uint8 MIN = 0
uint8 MAX = 255
uint8 UNAVAILABLE = 0
uint8 GLYCEMIA_PROBLEM = 1
uint8 HEART_PROBLEM = 2


================================================================================
MSG: etsi_its_cam_ts_msgs/StationaryVehicleSubCauseCode
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
#   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
#   -t
#   cam_ts
#   -o
#   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE provides the value of the sub cause codes of the @ref CauseCode "stationaryVehicle". 
#  * 
#  * The value shall be set to:
#  * - 0 `unavailable`           - in case further detailed information on stationary vehicle is unavailable,
#  * - 1 `humanProblem`          - in case stationary vehicle is due to health problem of driver or passenger,
#  * - 2 `vehicleBreakdown`      - in case stationary vehicle is due to vehicle break down,
#  * - 3 `postCrash`             - in case stationary vehicle is caused by collision,
#  * - 4 `publicTransportStop`   - in case public transport vehicle is stationary at bus stop,
#  * - 5 `carryingDangerousGoods`- in case the stationary vehicle is carrying dangerous goods,
#  * - 6 `vehicleOnFire`         - in case of vehicle on fire.
#  * - 7-255 reserved for future usage.
#  *
#  * @category: Traffic information
#  * @revision: V1.3.1
#  */
# StationaryVehicleSubCauseCode ::= INTEGER {
#     unavailable            (0), 
#     humanProblem           (1), 
#     vehicleBreakdown       (2), 
#     postCrash              (3), 
#     publicTransportStop    (4), 
#     carryingDangerousGoods (5), 
#     vehicleOnFire          (6)
# } (0..255)
# ------------------------------------------------------------------------------

uint8 value
uint8 MIN = 0
uint8 MAX = 255
uint8 UNAVAILABLE = 0
uint8 HUMAN_PROBLEM = 1
uint8 VEHICLE_BREAKDOWN = 2
uint8 POST_CRASH = 3
uint8 PUBLIC_TRANSPORT_STOP = 4
uint8 CARRYING_DANGEROUS_GOODS = 5
uint8 VEHICLE_ON_FIRE = 6


================================================================================
MSG: etsi_its_cam_ts_msgs/EmergencyVehicleApproachingSubCauseCode
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
#   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
#   -t
#   cam_ts
#   -o
#   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE represents the value of the sub cause codes of the @ref CauseCode "emergencyVehicleApproaching". 
#  * 
#  * The value shall be set to:
#  * - 0 - `unavailable`                   - in case further detailed information on the emergency vehicle approaching event 
#  *                                         is unavailable,
#  * - 1 - `emergencyVehicleApproaching`   - in case an operating emergency vehicle is approaching,
#  * - 2 - `prioritizedVehicleApproaching` - in case a prioritized vehicle is approaching,
#  * - 3-255                               - reserved for future usage.
#  *
#  * @category: Traffic information
#  * @revision: V1.3.1
#  */
# EmergencyVehicleApproachingSubCauseCode ::= INTEGER {
#     unavailable                   (0), 
#     emergencyVehicleApproaching   (1), 
#     prioritizedVehicleApproaching (2)
# } (0..255)
# ------------------------------------------------------------------------------

uint8 value
uint8 MIN = 0
uint8 MAX = 255
uint8 UNAVAILABLE = 0
uint8 EMERGENCY_VEHICLE_APPROACHING = 1
uint8 PRIORITIZED_VEHICLE_APPROACHING = 2


================================================================================
MSG: etsi_its_cam_ts_msgs/HazardousLocationDangerousCurveSubCauseCode
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
#   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
#   -t
#   cam_ts
#   -o
#   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE represents the sub cause code of the @ref CauseCode  `hazardousLocation-DangerousCurve`.
#  * 
#  * The value shall be set to:
#  * - 0 - `unavailable`                                        - in case further detailed information on the dangerous curve is unavailable,
#  * - 1 - `dangerousLeftTurnCurve`                             - in case the dangerous curve is a left turn curve,
#  * - 2 - `dangerousRightTurnCurve`                            - in case the dangerous curve is a right turn curve,
#  * - 3 - `multipleCurvesStartingWithUnknownTurningDirection`  - in case of multiple curves for which the starting curve turning direction is not known,
#  * - 4 - `multipleCurvesStartingWithLeftTurn`                 - in case of multiple curves starting with a left turn curve,
#  * - 5 - `multipleCurvesStartingWithRightTurn`                - in case of multiple curves starting with a right turn curve.
#  * - 6-255                                                    - are reserved for future usage.
#  * 
#  * The definition of whether a curve is dangerous may vary according to region and according to vehicle types/mass
#  * and vehicle speed driving on the curve. This definition is out of scope of the present document.
#  *
#  * @category: Traffic information
#  * @revision: V1.3.1
#  */
# HazardousLocation-DangerousCurveSubCauseCode ::= INTEGER {
#     unavailable                                       (0), 
#     dangerousLeftTurnCurve                            (1), 
#     dangerousRightTurnCurve                           (2), 
#     multipleCurvesStartingWithUnknownTurningDirection (3), 
#     multipleCurvesStartingWithLeftTurn                (4), 
#     multipleCurvesStartingWithRightTurn               (5)
# } (0..255)
# ------------------------------------------------------------------------------

uint8 value
uint8 MIN = 0
uint8 MAX = 255
uint8 UNAVAILABLE = 0
uint8 DANGEROUS_LEFT_TURN_CURVE = 1
uint8 DANGEROUS_RIGHT_TURN_CURVE = 2
uint8 MULTIPLE_CURVES_STARTING_WITH_UNKNOWN_TURNING_DIRECTION = 3
uint8 MULTIPLE_CURVES_STARTING_WITH_LEFT_TURN = 4
uint8 MULTIPLE_CURVES_STARTING_WITH_RIGHT_TURN = 5


================================================================================
MSG: etsi_its_cam_ts_msgs/CollisionRiskSubCauseCode
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
#   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
#   -t
#   cam_ts
#   -o
#   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE represents the sub cause codes of the @ref CauseCode `collisionRisk`.
#  * 
#  * The value shall be set to:
#  * - 0 - `unavailable`                    - in case information on the type of collision risk is unavailable,
#  * - 1 - `longitudinalCollisionRisk`      - in case the type of detected collision risk is longitudinal collision risk, 
#  *                                          e.g. forward collision or face to face collision,
#  * - 2 - `crossingCollisionRisk`          - in case the type of detected collision risk is crossing collision risk,
#  * - 3 - `lateralCollisionRisk`           - in case the type of detected collision risk is lateral collision risk,
#  * - 4 - `vulnerableRoadUser`             - in case the type of detected collision risk involves vulnerable road users
#  *                                          e.g. pedestrians or bicycles.
#  * - 5 - `collisionRiskWithPedestrian`    - in case the type of detected collision risk involves at least one pedestrian, 
#  * - 6 - `collisionRiskWithCyclist`       - in case the type of detected collision risk involves at least one cyclist (and no pedestrians),
#  * - 7 - `collisionRiskWithMotorVehicle`  - in case the type of detected collision risk involves at least one motor vehicle (and no pedestrians or cyclists),
#  * - 8-255                                - are reserved for future usage.
#  *
#  * @category: Traffic information
#  * @revision: V1.3.1, values 5-7 assigned in V2.2.1
#  */
# CollisionRiskSubCauseCode ::= INTEGER {
#     unavailable                   (0), 
#     longitudinalCollisionRisk     (1), 
#     crossingCollisionRisk         (2), 
#     lateralCollisionRisk          (3), 
#     vulnerableRoadUser            (4),
#     collisionRiskWithPedestrian   (5), 
#     collisionRiskWithCyclist      (6), 
#     collisionRiskWithMotorVehicle (7) 
# }(0..255)
# ------------------------------------------------------------------------------

uint8 value
uint8 MIN = 0
uint8 MAX = 255
uint8 UNAVAILABLE = 0
uint8 LONGITUDINAL_COLLISION_RISK = 1
uint8 CROSSING_COLLISION_RISK = 2
uint8 LATERAL_COLLISION_RISK = 3
uint8 VULNERABLE_ROAD_USER = 4
uint8 COLLISION_RISK_WITH_PEDESTRIAN = 5
uint8 COLLISION_RISK_WITH_CYCLIST = 6
uint8 COLLISION_RISK_WITH_MOTOR_VEHICLE = 7


================================================================================
MSG: etsi_its_cam_ts_msgs/SignalViolationSubCauseCode
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
#   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
#   -t
#   cam_ts
#   -o
#   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE represents the value of the sub cause codes of the @ref CauseCode `signalViolation`.
#  * 
#  * The value shall be set to:
#  * - 0 `unavailable`               - in case further detailed information on signal violation event is unavailable,
#  * - 1 `stopSignViolation`         - in case a stop sign violation is detected,
#  * - 2 `trafficLightViolation`     - in case a traffic light violation is detected,
#  * - 3 `turningRegulationViolation`- in case a turning regulation violation is detected.
#  * - 4-255                         - are reserved for future usage.
#  *
#  * @category: Traffic information
#  * @revision: V1.3.1
#  */
# SignalViolationSubCauseCode ::= INTEGER {
#     unavailable                (0), 
#     stopSignViolation          (1), 
#     trafficLightViolation      (2), 
#     turningRegulationViolation (3)
# } (0..255)
# ------------------------------------------------------------------------------

uint8 value
uint8 MIN = 0
uint8 MAX = 255
uint8 UNAVAILABLE = 0
uint8 STOP_SIGN_VIOLATION = 1
uint8 TRAFFIC_LIGHT_VIOLATION = 2
uint8 TURNING_REGULATION_VIOLATION = 3


================================================================================
MSG: etsi_its_cam_ts_msgs/DangerousSituationSubCauseCode
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
#   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
#   -t
#   cam_ts
#   -o
#   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE represents the value of the sub cause codes of the @ref CauseCode `dangerousSituation` 
#  * 
#  * The value shall be set to:
#  * - 0 - `unavailable`                      - in case information on the type of dangerous situation is unavailable,
#  * - 1 - `emergencyElectronicBrakeEngaged`  - in case emergency electronic brake is engaged,
#  * - 2 - `preCrashSystemEngaged`            - in case pre-crash system is engaged,
#  * - 3 - `espEngaged`                       - in case Electronic Stability Program (ESP) system is engaged,
#  * - 4 - `absEngaged`                       - in case Anti-lock Braking System (ABS) is engaged,
#  * - 5 - `aebEngaged`                       - in case Autonomous Emergency Braking (AEB) system is engaged,
#  * - 6 - `brakeWarningEngaged`              - in case brake warning is engaged,
#  * - 7 - `collisionRiskWarningEngaged`      - in case collision risk warning is engaged,
#  * - 8-255                                  - reserved for future usage.
#  *
#  * @category: Traffic information
#  * @revision: V1.3.1
#  */
# DangerousSituationSubCauseCode ::= INTEGER {
#     unavailable                     (0), 
#     emergencyElectronicBrakeEngaged (1), 
#     preCrashSystemEngaged           (2), 
#     espEngaged                      (3), 
#     absEngaged                      (4), 
#     ebEngaged                       (5), 
#     brakeWarningEngaged             (6), 
#     collisionRiskWarningEngaged     (7)
# } (0..255)
# ------------------------------------------------------------------------------

uint8 value
uint8 MIN = 0
uint8 MAX = 255
uint8 UNAVAILABLE = 0
uint8 EMERGENCY_ELECTRONIC_BRAKE_ENGAGED = 1
uint8 PRE_CRASH_SYSTEM_ENGAGED = 2
uint8 ESP_ENGAGED = 3
uint8 ABS_ENGAGED = 4
uint8 EB_ENGAGED = 5
uint8 BRAKE_WARNING_ENGAGED = 6
uint8 COLLISION_RISK_WARNING_ENGAGED = 7


================================================================================
MSG: etsi_its_cam_ts_msgs/RailwayLevelCrossingSubCauseCode
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
#   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
#   -t
#   cam_ts
#   -o
#   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE represents the value of the sub cause codes of the @ref CauseCode `railwayLevelCrossing` .
#  * 
#  * The value shall be set to:
#  * - 0 `unavailable`                   - in case no further detailed information on the railway level crossing status is available,
#  * - 1 `doNotCrossAbnormalSituation`   - in case when something wrong is detected by equation or sensors of the railway level crossing, 
#                                          including level crossing is closed for too long (e.g. more than 10 minutes long ; default value),
#  * - 2 `closed`                        - in case the crossing is closed (barriers down),
#  * - 3 `unguarded`                     - in case the level crossing is unguarded (i.e a Saint Andrew cross level crossing without detection of train),
#  * - 4 `nominal`                       - in case the barriers are up and lights are off.
#  * - 5-255: reserved for future usage.
#  *
#  * @category: Traffic information
#  * @revision: V1.3.1
#  */
# RailwayLevelCrossingSubCauseCode ::= INTEGER {
#     unavailable                 (0), 
#     doNotCrossAbnormalSituation (1), 
#     closed                      (2), 
#     unguarded                   (3), 
#     nominal                     (4)
# } (0..255)
# ------------------------------------------------------------------------------

uint8 value
uint8 MIN = 0
uint8 MAX = 255
uint8 UNAVAILABLE = 0
uint8 DO_NOT_CROSS_ABNORMAL_SITUATION = 1
uint8 CLOSED = 2
uint8 UNGUARDED = 3
uint8 NOMINAL = 4


================================================================================
MSG: etsi_its_cam_ts_msgs/EmergencyPriority
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
#   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
#   -t
#   cam_ts
#   -o
#   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE indicates the right of priority requested or assumed by an operating emergency vehicle.
#  * The right-of-priority bit shall be set to `1` if the corresponding right is requested.
#  * 
#  * The corresponding bit shall be set to 1 under the following conditions:
#  * - 0 - `requestForRightOfWay`                  - when the vehicle is requesting/assuming the right of way,
#  * - 1 - `requestForFreeCrossingAtATrafficLight` - when the vehicle is requesting/assuming the right to pass at a (red) traffic light.
#  *
#  * @category: Traffic information
#  * @revision: description revised in V2.1.1
#  */
# EmergencyPriority ::= BIT STRING {
#     requestForRightOfWay                  (0), 
#     requestForFreeCrossingAtATrafficLight (1)
# } (SIZE(2))
# ------------------------------------------------------------------------------

uint8[] value
uint8 bits_unused
uint8 SIZE_BITS = 2
uint8 BIT_INDEX_REQUEST_FOR_RIGHT_OF_WAY = 0
uint8 BIT_INDEX_REQUEST_FOR_FREE_CROSSING_AT_A_TRAFFIC_LIGHT = 1


================================================================================
MSG: etsi_its_cam_ts_msgs/SafetyCarContainer
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
#   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
#   -t
#   cam_ts
#   -o
#   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
# * This type contains detaild information of the Safety Car Container.
# *
# * It shall include the following components:
# *
# * @field lightBarSirenInUse: it indicates whether light-bar or a siren is in use by the vehicle originating the CAM.
# *
# * @field incidentIndication: the optional incident related to the roadworks to provide additional information of the roadworks zone.
# *
# * @field trafficRule: an optional rule indicates whether vehicles are allowed to overtake a safety car that is originating this CAM.
# *
# * @field speedLimit: an optional speed indicates whether a speed limit is applied to vehicles following the safety car. 
# */
# SafetyCarContainer ::= SEQUENCE {
# 	lightBarSirenInUse LightBarSirenInUse,
# 	incidentIndication CauseCodeV2 OPTIONAL,
# 	trafficRule TrafficRule OPTIONAL,
# 	speedLimit SpeedLimit OPTIONAL
# }
# ------------------------------------------------------------------------------

LightBarSirenInUse light_bar_siren_in_use

CauseCodeV2 incident_indication
bool incident_indication_is_present

TrafficRule traffic_rule
bool traffic_rule_is_present

SpeedLimit speed_limit
bool speed_limit_is_present


================================================================================
MSG: etsi_its_cam_ts_msgs/TrafficRule
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
#   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
#   -t
#   cam_ts
#   -o
#   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE indicates traffic rules that apply to vehicles at a certain position.
#  *
#  * The value shall be set to:
#  * - `0` - if overtaking is prohibited for all vehicles,
#  * - `1` - if overtaking is prohibited for trucks,
#  * - `2` - if vehicles should pass to the right lane,
#  * - `3` - if vehicles should pass to the left lane.
#  * - `4` - if vehicles should pass to the left or right lane.
#  *
#  * @category: Infrastructure information, Traffic information
#  * @revision: Editorial update in V2.1.1
#  */
# TrafficRule ::= ENUMERATED {
#     noPassing          (0), 
#     noPassingForTrucks (1), 
#     passToRight        (2), 
#     passToLeft         (3), 
#     ...,
#     passToLeftOrRight   (4)
# }
# ------------------------------------------------------------------------------

uint8 value
uint8 NO_PASSING = 0
uint8 NO_PASSING_FOR_TRUCKS = 1
uint8 PASS_TO_RIGHT = 2
uint8 PASS_TO_LEFT = 3
uint8 PASS_TO_LEFT_OR_RIGHT = 4


================================================================================
MSG: etsi_its_cam_ts_msgs/SpeedLimit
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
#   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
#   -t
#   cam_ts
#   -o
#   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE represents a speed limitation applied to a geographical position, a road section or a geographical region.
#  * 
#  * @unit: km/h
#  * @category: Infrastructure information, Traffic information
#  * @revision: V1.3.1
#  */
# SpeedLimit ::= INTEGER (1..255)
# ------------------------------------------------------------------------------

uint8 value
uint8 MIN = 1
uint8 MAX = 255

"""
  __slots__ = ['basic_container','high_frequency_container','low_frequency_container','low_frequency_container_is_present','special_vehicle_container','special_vehicle_container_is_present']
  _slot_types = ['etsi_its_cam_ts_msgs/BasicContainer','etsi_its_cam_ts_msgs/HighFrequencyContainer','etsi_its_cam_ts_msgs/LowFrequencyContainer','bool','etsi_its_cam_ts_msgs/SpecialVehicleContainer','bool']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       basic_container,high_frequency_container,low_frequency_container,low_frequency_container_is_present,special_vehicle_container,special_vehicle_container_is_present

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(CamParameters, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.basic_container is None:
        self.basic_container = etsi_its_cam_ts_msgs.msg.BasicContainer()
      if self.high_frequency_container is None:
        self.high_frequency_container = etsi_its_cam_ts_msgs.msg.HighFrequencyContainer()
      if self.low_frequency_container is None:
        self.low_frequency_container = etsi_its_cam_ts_msgs.msg.LowFrequencyContainer()
      if self.low_frequency_container_is_present is None:
        self.low_frequency_container_is_present = False
      if self.special_vehicle_container is None:
        self.special_vehicle_container = etsi_its_cam_ts_msgs.msg.SpecialVehicleContainer()
      if self.special_vehicle_container_is_present is None:
        self.special_vehicle_container_is_present = False
    else:
      self.basic_container = etsi_its_cam_ts_msgs.msg.BasicContainer()
      self.high_frequency_container = etsi_its_cam_ts_msgs.msg.HighFrequencyContainer()
      self.low_frequency_container = etsi_its_cam_ts_msgs.msg.LowFrequencyContainer()
      self.low_frequency_container_is_present = False
      self.special_vehicle_container = etsi_its_cam_ts_msgs.msg.SpecialVehicleContainer()
      self.special_vehicle_container_is_present = False

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_B2i3Hi2BHBH2BH2BhBh2BhB().pack(_x.basic_container.station_type.value, _x.basic_container.reference_position.latitude.value, _x.basic_container.reference_position.longitude.value, _x.basic_container.reference_position.position_confidence_ellipse.semi_major_axis_length.value, _x.basic_container.reference_position.position_confidence_ellipse.semi_minor_axis_length.value, _x.basic_container.reference_position.position_confidence_ellipse.semi_major_axis_orientation.value, _x.basic_container.reference_position.altitude.altitude_value.value, _x.basic_container.reference_position.altitude.altitude_confidence.value, _x.high_frequency_container.choice, _x.high_frequency_container.basic_vehicle_container_high_frequency.heading.heading_value.value, _x.high_frequency_container.basic_vehicle_container_high_frequency.heading.heading_confidence.value, _x.high_frequency_container.basic_vehicle_container_high_frequency.speed.speed_value.value, _x.high_frequency_container.basic_vehicle_container_high_frequency.speed.speed_confidence.value, _x.high_frequency_container.basic_vehicle_container_high_frequency.drive_direction.value, _x.high_frequency_container.basic_vehicle_container_high_frequency.vehicle_length.vehicle_length_value.value, _x.high_frequency_container.basic_vehicle_container_high_frequency.vehicle_length.vehicle_length_confidence_indication.value, _x.high_frequency_container.basic_vehicle_container_high_frequency.vehicle_width.value, _x.high_frequency_container.basic_vehicle_container_high_frequency.longitudinal_acceleration.value.value, _x.high_frequency_container.basic_vehicle_container_high_frequency.longitudinal_acceleration.confidence.value, _x.high_frequency_container.basic_vehicle_container_high_frequency.curvature.curvature_value.value, _x.high_frequency_container.basic_vehicle_container_high_frequency.curvature.curvature_confidence.value, _x.high_frequency_container.basic_vehicle_container_high_frequency.curvature_calculation_mode.value, _x.high_frequency_container.basic_vehicle_container_high_frequency.yaw_rate.yaw_rate_value.value, _x.high_frequency_container.basic_vehicle_container_high_frequency.yaw_rate.yaw_rate_confidence.value))
      _x = self.high_frequency_container.basic_vehicle_container_high_frequency.acceleration_control.value
      length = len(_x)
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
      else:
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_2BbBh2Bh2Bh4B2iI2B().pack(_x.high_frequency_container.basic_vehicle_container_high_frequency.acceleration_control.bits_unused, _x.high_frequency_container.basic_vehicle_container_high_frequency.acceleration_control_is_present, _x.high_frequency_container.basic_vehicle_container_high_frequency.lane_position.value, _x.high_frequency_container.basic_vehicle_container_high_frequency.lane_position_is_present, _x.high_frequency_container.basic_vehicle_container_high_frequency.steering_wheel_angle.steering_wheel_angle_value.value, _x.high_frequency_container.basic_vehicle_container_high_frequency.steering_wheel_angle.steering_wheel_angle_confidence.value, _x.high_frequency_container.basic_vehicle_container_high_frequency.steering_wheel_angle_is_present, _x.high_frequency_container.basic_vehicle_container_high_frequency.lateral_acceleration.value.value, _x.high_frequency_container.basic_vehicle_container_high_frequency.lateral_acceleration.confidence.value, _x.high_frequency_container.basic_vehicle_container_high_frequency.lateral_acceleration_is_present, _x.high_frequency_container.basic_vehicle_container_high_frequency.vertical_acceleration.value.value, _x.high_frequency_container.basic_vehicle_container_high_frequency.vertical_acceleration.confidence.value, _x.high_frequency_container.basic_vehicle_container_high_frequency.vertical_acceleration_is_present, _x.high_frequency_container.basic_vehicle_container_high_frequency.performance_class.value, _x.high_frequency_container.basic_vehicle_container_high_frequency.performance_class_is_present, _x.high_frequency_container.basic_vehicle_container_high_frequency.cen_dsrc_tolling_zone.protected_zone_latitude.value, _x.high_frequency_container.basic_vehicle_container_high_frequency.cen_dsrc_tolling_zone.protected_zone_longitude.value, _x.high_frequency_container.basic_vehicle_container_high_frequency.cen_dsrc_tolling_zone.cen_dsrc_tolling_zone_id.value, _x.high_frequency_container.basic_vehicle_container_high_frequency.cen_dsrc_tolling_zone.cen_dsrc_tolling_zone_id_is_present, _x.high_frequency_container.basic_vehicle_container_high_frequency.cen_dsrc_tolling_zone_is_present))
      length = len(self.high_frequency_container.rsu_container_high_frequency.protected_communication_zones_rsu.array)
      buff.write(_struct_I.pack(length))
      for val1 in self.high_frequency_container.rsu_container_high_frequency.protected_communication_zones_rsu.array:
        _v1 = val1.protected_zone_type
        _x = _v1.value
        buff.write(_get_struct_B().pack(_x))
        _v2 = val1.expiry_time
        _x = _v2.value
        buff.write(_get_struct_Q().pack(_x))
        _x = val1.expiry_time_is_present
        buff.write(_get_struct_B().pack(_x))
        _v3 = val1.protected_zone_latitude
        _x = _v3.value
        buff.write(_get_struct_i().pack(_x))
        _v4 = val1.protected_zone_longitude
        _x = _v4.value
        buff.write(_get_struct_i().pack(_x))
        _v5 = val1.protected_zone_radius
        _x = _v5.value
        buff.write(_get_struct_B().pack(_x))
        _x = val1.protected_zone_radius_is_present
        buff.write(_get_struct_B().pack(_x))
        _v6 = val1.protected_zone_id
        _x = _v6.value
        buff.write(_get_struct_I().pack(_x))
        _x = val1.protected_zone_id_is_present
        buff.write(_get_struct_B().pack(_x))
      _x = self
      buff.write(_get_struct_3B().pack(_x.high_frequency_container.rsu_container_high_frequency.protected_communication_zones_rsu_is_present, _x.low_frequency_container.choice, _x.low_frequency_container.basic_vehicle_container_low_frequency.vehicle_role.value))
      _x = self.low_frequency_container.basic_vehicle_container_low_frequency.exterior_lights.value
      length = len(_x)
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
      else:
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.low_frequency_container.basic_vehicle_container_low_frequency.exterior_lights.bits_unused
      buff.write(_get_struct_B().pack(_x))
      length = len(self.low_frequency_container.basic_vehicle_container_low_frequency.path_history.array)
      buff.write(_struct_I.pack(length))
      for val1 in self.low_frequency_container.basic_vehicle_container_low_frequency.path_history.array:
        _v7 = val1.path_position
        _v8 = _v7.delta_latitude
        _x = _v8.value
        buff.write(_get_struct_i().pack(_x))
        _v9 = _v7.delta_longitude
        _x = _v9.value
        buff.write(_get_struct_i().pack(_x))
        _v10 = _v7.delta_altitude
        _x = _v10.value
        buff.write(_get_struct_h().pack(_x))
        _v11 = val1.path_delta_time
        _x = _v11.value
        buff.write(_get_struct_H().pack(_x))
        _x = val1.path_delta_time_is_present
        buff.write(_get_struct_B().pack(_x))
      _x = self
      buff.write(_get_struct_4B().pack(_x.low_frequency_container_is_present, _x.special_vehicle_container.choice, _x.special_vehicle_container.public_transport_container.embarkation_status.value, _x.special_vehicle_container.public_transport_container.pt_activation.pt_activation_type.value))
      _x = self.special_vehicle_container.public_transport_container.pt_activation.pt_activation_data.value
      length = len(_x)
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
      else:
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.special_vehicle_container.public_transport_container.pt_activation_is_present
      buff.write(_get_struct_B().pack(_x))
      _x = self.special_vehicle_container.special_transport_container.special_transport_type.value
      length = len(_x)
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
      else:
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.special_vehicle_container.special_transport_container.special_transport_type.bits_unused
      buff.write(_get_struct_B().pack(_x))
      _x = self.special_vehicle_container.special_transport_container.light_bar_siren_in_use.value
      length = len(_x)
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
      else:
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_4B().pack(_x.special_vehicle_container.special_transport_container.light_bar_siren_in_use.bits_unused, _x.special_vehicle_container.dangerous_goods_container.dangerous_goods_basic.value, _x.special_vehicle_container.road_works_container_basic.roadworks_sub_cause_code.value, _x.special_vehicle_container.road_works_container_basic.roadworks_sub_cause_code_is_present))
      _x = self.special_vehicle_container.road_works_container_basic.light_bar_siren_in_use.value
      length = len(_x)
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
      else:
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_5B().pack(_x.special_vehicle_container.road_works_container_basic.light_bar_siren_in_use.bits_unused, _x.special_vehicle_container.road_works_container_basic.closed_lanes.innerhard_shoulder_status.value, _x.special_vehicle_container.road_works_container_basic.closed_lanes.innerhard_shoulder_status_is_present, _x.special_vehicle_container.road_works_container_basic.closed_lanes.outerhard_shoulder_status.value, _x.special_vehicle_container.road_works_container_basic.closed_lanes.outerhard_shoulder_status_is_present))
      _x = self.special_vehicle_container.road_works_container_basic.closed_lanes.driving_lane_status.value
      length = len(_x)
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
      else:
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_3B().pack(_x.special_vehicle_container.road_works_container_basic.closed_lanes.driving_lane_status.bits_unused, _x.special_vehicle_container.road_works_container_basic.closed_lanes.driving_lane_status_is_present, _x.special_vehicle_container.road_works_container_basic.closed_lanes_is_present))
      _x = self.special_vehicle_container.rescue_container.light_bar_siren_in_use.value
      length = len(_x)
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
      else:
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.special_vehicle_container.rescue_container.light_bar_siren_in_use.bits_unused
      buff.write(_get_struct_B().pack(_x))
      _x = self.special_vehicle_container.emergency_container.light_bar_siren_in_use.value
      length = len(_x)
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
      else:
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_132B().pack(_x.special_vehicle_container.emergency_container.light_bar_siren_in_use.bits_unused, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.choice, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved0.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.traffic_condition1.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.accident2.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.roadworks3.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved4.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.impassability5.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.adverse_weather_condition_adhesion6.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.aquaplaning7.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved8.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.hazardous_location_surface_condition9.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.hazardous_location_obstacle_on_the_road10.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.hazardous_location_animal_on_the_road11.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.human_presence_on_the_road12.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved13.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.wrong_way_driving14.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.rescue_and_recovery_work_in_progress15.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved16.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.adverse_weather_condition_extreme_weather_condition17.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.adverse_weather_condition_visibility18.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.adverse_weather_condition_precipitation19.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.violence20.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved21.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved22.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved23.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved24.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved25.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.slow_vehicle26.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.dangerous_end_of_queue27.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.public_transport_vehicle_approaching28.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved29.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved30.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved31.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved32.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved33.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved34.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved35.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved36.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved37.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved38.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved39.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved40.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved41.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved42.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved43.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved44.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved45.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved46.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved47.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved48.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved49.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved50.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved51.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved52.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved53.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved54.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved55.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved56.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved57.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved58.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved59.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved60.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved61.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved62.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved63.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved64.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved65.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved66.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved67.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved68.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved69.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved70.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved71.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved72.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved73.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved74.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved75.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved76.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved77.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved78.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved79.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved80.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved81.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved82.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved83.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved84.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved85.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved86.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved87.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved88.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved89.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved90.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.vehicle_breakdown91.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.post_crash92.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.human_problem93.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.stationary_vehicle94.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.emergency_vehicle_approaching95.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.hazardous_location_dangerous_curve96.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.collision_risk97.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.signal_violation98.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.dangerous_situation99.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.railway_level_crossing100.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved101.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved102.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved103.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved104.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved105.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved106.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved107.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved108.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved109.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved110.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved111.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved112.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved113.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved114.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved115.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved116.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved117.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved118.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved119.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved120.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved121.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved122.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved123.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved124.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved125.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved126.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved127.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved128.value, _x.special_vehicle_container.emergency_container.incident_indication_is_present))
      _x = self.special_vehicle_container.emergency_container.emergency_priority.value
      length = len(_x)
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
      else:
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_2B().pack(_x.special_vehicle_container.emergency_container.emergency_priority.bits_unused, _x.special_vehicle_container.emergency_container.emergency_priority_is_present))
      _x = self.special_vehicle_container.safety_car_container.light_bar_siren_in_use.value
      length = len(_x)
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
      else:
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_137B().pack(_x.special_vehicle_container.safety_car_container.light_bar_siren_in_use.bits_unused, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.choice, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved0.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.traffic_condition1.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.accident2.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.roadworks3.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved4.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.impassability5.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.adverse_weather_condition_adhesion6.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.aquaplaning7.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved8.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.hazardous_location_surface_condition9.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.hazardous_location_obstacle_on_the_road10.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.hazardous_location_animal_on_the_road11.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.human_presence_on_the_road12.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved13.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.wrong_way_driving14.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.rescue_and_recovery_work_in_progress15.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved16.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.adverse_weather_condition_extreme_weather_condition17.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.adverse_weather_condition_visibility18.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.adverse_weather_condition_precipitation19.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.violence20.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved21.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved22.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved23.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved24.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved25.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.slow_vehicle26.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.dangerous_end_of_queue27.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.public_transport_vehicle_approaching28.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved29.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved30.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved31.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved32.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved33.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved34.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved35.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved36.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved37.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved38.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved39.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved40.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved41.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved42.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved43.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved44.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved45.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved46.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved47.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved48.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved49.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved50.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved51.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved52.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved53.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved54.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved55.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved56.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved57.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved58.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved59.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved60.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved61.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved62.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved63.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved64.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved65.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved66.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved67.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved68.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved69.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved70.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved71.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved72.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved73.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved74.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved75.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved76.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved77.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved78.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved79.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved80.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved81.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved82.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved83.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved84.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved85.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved86.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved87.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved88.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved89.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved90.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.vehicle_breakdown91.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.post_crash92.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.human_problem93.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.stationary_vehicle94.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.emergency_vehicle_approaching95.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.hazardous_location_dangerous_curve96.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.collision_risk97.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.signal_violation98.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.dangerous_situation99.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.railway_level_crossing100.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved101.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved102.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved103.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved104.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved105.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved106.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved107.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved108.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved109.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved110.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved111.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved112.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved113.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved114.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved115.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved116.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved117.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved118.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved119.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved120.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved121.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved122.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved123.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved124.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved125.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved126.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved127.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved128.value, _x.special_vehicle_container.safety_car_container.incident_indication_is_present, _x.special_vehicle_container.safety_car_container.traffic_rule.value, _x.special_vehicle_container.safety_car_container.traffic_rule_is_present, _x.special_vehicle_container.safety_car_container.speed_limit.value, _x.special_vehicle_container.safety_car_container.speed_limit_is_present, _x.special_vehicle_container_is_present))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.basic_container is None:
        self.basic_container = etsi_its_cam_ts_msgs.msg.BasicContainer()
      if self.high_frequency_container is None:
        self.high_frequency_container = etsi_its_cam_ts_msgs.msg.HighFrequencyContainer()
      if self.low_frequency_container is None:
        self.low_frequency_container = etsi_its_cam_ts_msgs.msg.LowFrequencyContainer()
      if self.special_vehicle_container is None:
        self.special_vehicle_container = etsi_its_cam_ts_msgs.msg.SpecialVehicleContainer()
      end = 0
      _x = self
      start = end
      end += 42
      (_x.basic_container.station_type.value, _x.basic_container.reference_position.latitude.value, _x.basic_container.reference_position.longitude.value, _x.basic_container.reference_position.position_confidence_ellipse.semi_major_axis_length.value, _x.basic_container.reference_position.position_confidence_ellipse.semi_minor_axis_length.value, _x.basic_container.reference_position.position_confidence_ellipse.semi_major_axis_orientation.value, _x.basic_container.reference_position.altitude.altitude_value.value, _x.basic_container.reference_position.altitude.altitude_confidence.value, _x.high_frequency_container.choice, _x.high_frequency_container.basic_vehicle_container_high_frequency.heading.heading_value.value, _x.high_frequency_container.basic_vehicle_container_high_frequency.heading.heading_confidence.value, _x.high_frequency_container.basic_vehicle_container_high_frequency.speed.speed_value.value, _x.high_frequency_container.basic_vehicle_container_high_frequency.speed.speed_confidence.value, _x.high_frequency_container.basic_vehicle_container_high_frequency.drive_direction.value, _x.high_frequency_container.basic_vehicle_container_high_frequency.vehicle_length.vehicle_length_value.value, _x.high_frequency_container.basic_vehicle_container_high_frequency.vehicle_length.vehicle_length_confidence_indication.value, _x.high_frequency_container.basic_vehicle_container_high_frequency.vehicle_width.value, _x.high_frequency_container.basic_vehicle_container_high_frequency.longitudinal_acceleration.value.value, _x.high_frequency_container.basic_vehicle_container_high_frequency.longitudinal_acceleration.confidence.value, _x.high_frequency_container.basic_vehicle_container_high_frequency.curvature.curvature_value.value, _x.high_frequency_container.basic_vehicle_container_high_frequency.curvature.curvature_confidence.value, _x.high_frequency_container.basic_vehicle_container_high_frequency.curvature_calculation_mode.value, _x.high_frequency_container.basic_vehicle_container_high_frequency.yaw_rate.yaw_rate_value.value, _x.high_frequency_container.basic_vehicle_container_high_frequency.yaw_rate.yaw_rate_confidence.value,) = _get_struct_B2i3Hi2BHBH2BH2BhBh2BhB().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.high_frequency_container.basic_vehicle_container_high_frequency.acceleration_control.value = str[start:end]
      _x = self
      start = end
      end += 32
      (_x.high_frequency_container.basic_vehicle_container_high_frequency.acceleration_control.bits_unused, _x.high_frequency_container.basic_vehicle_container_high_frequency.acceleration_control_is_present, _x.high_frequency_container.basic_vehicle_container_high_frequency.lane_position.value, _x.high_frequency_container.basic_vehicle_container_high_frequency.lane_position_is_present, _x.high_frequency_container.basic_vehicle_container_high_frequency.steering_wheel_angle.steering_wheel_angle_value.value, _x.high_frequency_container.basic_vehicle_container_high_frequency.steering_wheel_angle.steering_wheel_angle_confidence.value, _x.high_frequency_container.basic_vehicle_container_high_frequency.steering_wheel_angle_is_present, _x.high_frequency_container.basic_vehicle_container_high_frequency.lateral_acceleration.value.value, _x.high_frequency_container.basic_vehicle_container_high_frequency.lateral_acceleration.confidence.value, _x.high_frequency_container.basic_vehicle_container_high_frequency.lateral_acceleration_is_present, _x.high_frequency_container.basic_vehicle_container_high_frequency.vertical_acceleration.value.value, _x.high_frequency_container.basic_vehicle_container_high_frequency.vertical_acceleration.confidence.value, _x.high_frequency_container.basic_vehicle_container_high_frequency.vertical_acceleration_is_present, _x.high_frequency_container.basic_vehicle_container_high_frequency.performance_class.value, _x.high_frequency_container.basic_vehicle_container_high_frequency.performance_class_is_present, _x.high_frequency_container.basic_vehicle_container_high_frequency.cen_dsrc_tolling_zone.protected_zone_latitude.value, _x.high_frequency_container.basic_vehicle_container_high_frequency.cen_dsrc_tolling_zone.protected_zone_longitude.value, _x.high_frequency_container.basic_vehicle_container_high_frequency.cen_dsrc_tolling_zone.cen_dsrc_tolling_zone_id.value, _x.high_frequency_container.basic_vehicle_container_high_frequency.cen_dsrc_tolling_zone.cen_dsrc_tolling_zone_id_is_present, _x.high_frequency_container.basic_vehicle_container_high_frequency.cen_dsrc_tolling_zone_is_present,) = _get_struct_2BbBh2Bh2Bh4B2iI2B().unpack(str[start:end])
      self.high_frequency_container.basic_vehicle_container_high_frequency.acceleration_control_is_present = bool(self.high_frequency_container.basic_vehicle_container_high_frequency.acceleration_control_is_present)
      self.high_frequency_container.basic_vehicle_container_high_frequency.lane_position_is_present = bool(self.high_frequency_container.basic_vehicle_container_high_frequency.lane_position_is_present)
      self.high_frequency_container.basic_vehicle_container_high_frequency.steering_wheel_angle_is_present = bool(self.high_frequency_container.basic_vehicle_container_high_frequency.steering_wheel_angle_is_present)
      self.high_frequency_container.basic_vehicle_container_high_frequency.lateral_acceleration_is_present = bool(self.high_frequency_container.basic_vehicle_container_high_frequency.lateral_acceleration_is_present)
      self.high_frequency_container.basic_vehicle_container_high_frequency.vertical_acceleration_is_present = bool(self.high_frequency_container.basic_vehicle_container_high_frequency.vertical_acceleration_is_present)
      self.high_frequency_container.basic_vehicle_container_high_frequency.performance_class_is_present = bool(self.high_frequency_container.basic_vehicle_container_high_frequency.performance_class_is_present)
      self.high_frequency_container.basic_vehicle_container_high_frequency.cen_dsrc_tolling_zone.cen_dsrc_tolling_zone_id_is_present = bool(self.high_frequency_container.basic_vehicle_container_high_frequency.cen_dsrc_tolling_zone.cen_dsrc_tolling_zone_id_is_present)
      self.high_frequency_container.basic_vehicle_container_high_frequency.cen_dsrc_tolling_zone_is_present = bool(self.high_frequency_container.basic_vehicle_container_high_frequency.cen_dsrc_tolling_zone_is_present)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.high_frequency_container.rsu_container_high_frequency.protected_communication_zones_rsu.array = []
      for i in range(0, length):
        val1 = etsi_its_cam_ts_msgs.msg.ProtectedCommunicationZone()
        _v12 = val1.protected_zone_type
        start = end
        end += 1
        (_v12.value,) = _get_struct_B().unpack(str[start:end])
        _v13 = val1.expiry_time
        start = end
        end += 8
        (_v13.value,) = _get_struct_Q().unpack(str[start:end])
        start = end
        end += 1
        (val1.expiry_time_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.expiry_time_is_present = bool(val1.expiry_time_is_present)
        _v14 = val1.protected_zone_latitude
        start = end
        end += 4
        (_v14.value,) = _get_struct_i().unpack(str[start:end])
        _v15 = val1.protected_zone_longitude
        start = end
        end += 4
        (_v15.value,) = _get_struct_i().unpack(str[start:end])
        _v16 = val1.protected_zone_radius
        start = end
        end += 1
        (_v16.value,) = _get_struct_B().unpack(str[start:end])
        start = end
        end += 1
        (val1.protected_zone_radius_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.protected_zone_radius_is_present = bool(val1.protected_zone_radius_is_present)
        _v17 = val1.protected_zone_id
        start = end
        end += 4
        (_v17.value,) = _get_struct_I().unpack(str[start:end])
        start = end
        end += 1
        (val1.protected_zone_id_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.protected_zone_id_is_present = bool(val1.protected_zone_id_is_present)
        self.high_frequency_container.rsu_container_high_frequency.protected_communication_zones_rsu.array.append(val1)
      _x = self
      start = end
      end += 3
      (_x.high_frequency_container.rsu_container_high_frequency.protected_communication_zones_rsu_is_present, _x.low_frequency_container.choice, _x.low_frequency_container.basic_vehicle_container_low_frequency.vehicle_role.value,) = _get_struct_3B().unpack(str[start:end])
      self.high_frequency_container.rsu_container_high_frequency.protected_communication_zones_rsu_is_present = bool(self.high_frequency_container.rsu_container_high_frequency.protected_communication_zones_rsu_is_present)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.low_frequency_container.basic_vehicle_container_low_frequency.exterior_lights.value = str[start:end]
      start = end
      end += 1
      (self.low_frequency_container.basic_vehicle_container_low_frequency.exterior_lights.bits_unused,) = _get_struct_B().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.low_frequency_container.basic_vehicle_container_low_frequency.path_history.array = []
      for i in range(0, length):
        val1 = etsi_its_cam_ts_msgs.msg.PathPoint()
        _v18 = val1.path_position
        _v19 = _v18.delta_latitude
        start = end
        end += 4
        (_v19.value,) = _get_struct_i().unpack(str[start:end])
        _v20 = _v18.delta_longitude
        start = end
        end += 4
        (_v20.value,) = _get_struct_i().unpack(str[start:end])
        _v21 = _v18.delta_altitude
        start = end
        end += 2
        (_v21.value,) = _get_struct_h().unpack(str[start:end])
        _v22 = val1.path_delta_time
        start = end
        end += 2
        (_v22.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (val1.path_delta_time_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.path_delta_time_is_present = bool(val1.path_delta_time_is_present)
        self.low_frequency_container.basic_vehicle_container_low_frequency.path_history.array.append(val1)
      _x = self
      start = end
      end += 4
      (_x.low_frequency_container_is_present, _x.special_vehicle_container.choice, _x.special_vehicle_container.public_transport_container.embarkation_status.value, _x.special_vehicle_container.public_transport_container.pt_activation.pt_activation_type.value,) = _get_struct_4B().unpack(str[start:end])
      self.low_frequency_container_is_present = bool(self.low_frequency_container_is_present)
      self.special_vehicle_container.public_transport_container.embarkation_status.value = bool(self.special_vehicle_container.public_transport_container.embarkation_status.value)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.special_vehicle_container.public_transport_container.pt_activation.pt_activation_data.value = str[start:end]
      start = end
      end += 1
      (self.special_vehicle_container.public_transport_container.pt_activation_is_present,) = _get_struct_B().unpack(str[start:end])
      self.special_vehicle_container.public_transport_container.pt_activation_is_present = bool(self.special_vehicle_container.public_transport_container.pt_activation_is_present)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.special_vehicle_container.special_transport_container.special_transport_type.value = str[start:end]
      start = end
      end += 1
      (self.special_vehicle_container.special_transport_container.special_transport_type.bits_unused,) = _get_struct_B().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.special_vehicle_container.special_transport_container.light_bar_siren_in_use.value = str[start:end]
      _x = self
      start = end
      end += 4
      (_x.special_vehicle_container.special_transport_container.light_bar_siren_in_use.bits_unused, _x.special_vehicle_container.dangerous_goods_container.dangerous_goods_basic.value, _x.special_vehicle_container.road_works_container_basic.roadworks_sub_cause_code.value, _x.special_vehicle_container.road_works_container_basic.roadworks_sub_cause_code_is_present,) = _get_struct_4B().unpack(str[start:end])
      self.special_vehicle_container.road_works_container_basic.roadworks_sub_cause_code_is_present = bool(self.special_vehicle_container.road_works_container_basic.roadworks_sub_cause_code_is_present)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.special_vehicle_container.road_works_container_basic.light_bar_siren_in_use.value = str[start:end]
      _x = self
      start = end
      end += 5
      (_x.special_vehicle_container.road_works_container_basic.light_bar_siren_in_use.bits_unused, _x.special_vehicle_container.road_works_container_basic.closed_lanes.innerhard_shoulder_status.value, _x.special_vehicle_container.road_works_container_basic.closed_lanes.innerhard_shoulder_status_is_present, _x.special_vehicle_container.road_works_container_basic.closed_lanes.outerhard_shoulder_status.value, _x.special_vehicle_container.road_works_container_basic.closed_lanes.outerhard_shoulder_status_is_present,) = _get_struct_5B().unpack(str[start:end])
      self.special_vehicle_container.road_works_container_basic.closed_lanes.innerhard_shoulder_status_is_present = bool(self.special_vehicle_container.road_works_container_basic.closed_lanes.innerhard_shoulder_status_is_present)
      self.special_vehicle_container.road_works_container_basic.closed_lanes.outerhard_shoulder_status_is_present = bool(self.special_vehicle_container.road_works_container_basic.closed_lanes.outerhard_shoulder_status_is_present)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.special_vehicle_container.road_works_container_basic.closed_lanes.driving_lane_status.value = str[start:end]
      _x = self
      start = end
      end += 3
      (_x.special_vehicle_container.road_works_container_basic.closed_lanes.driving_lane_status.bits_unused, _x.special_vehicle_container.road_works_container_basic.closed_lanes.driving_lane_status_is_present, _x.special_vehicle_container.road_works_container_basic.closed_lanes_is_present,) = _get_struct_3B().unpack(str[start:end])
      self.special_vehicle_container.road_works_container_basic.closed_lanes.driving_lane_status_is_present = bool(self.special_vehicle_container.road_works_container_basic.closed_lanes.driving_lane_status_is_present)
      self.special_vehicle_container.road_works_container_basic.closed_lanes_is_present = bool(self.special_vehicle_container.road_works_container_basic.closed_lanes_is_present)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.special_vehicle_container.rescue_container.light_bar_siren_in_use.value = str[start:end]
      start = end
      end += 1
      (self.special_vehicle_container.rescue_container.light_bar_siren_in_use.bits_unused,) = _get_struct_B().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.special_vehicle_container.emergency_container.light_bar_siren_in_use.value = str[start:end]
      _x = self
      start = end
      end += 132
      (_x.special_vehicle_container.emergency_container.light_bar_siren_in_use.bits_unused, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.choice, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved0.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.traffic_condition1.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.accident2.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.roadworks3.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved4.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.impassability5.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.adverse_weather_condition_adhesion6.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.aquaplaning7.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved8.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.hazardous_location_surface_condition9.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.hazardous_location_obstacle_on_the_road10.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.hazardous_location_animal_on_the_road11.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.human_presence_on_the_road12.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved13.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.wrong_way_driving14.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.rescue_and_recovery_work_in_progress15.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved16.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.adverse_weather_condition_extreme_weather_condition17.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.adverse_weather_condition_visibility18.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.adverse_weather_condition_precipitation19.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.violence20.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved21.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved22.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved23.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved24.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved25.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.slow_vehicle26.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.dangerous_end_of_queue27.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.public_transport_vehicle_approaching28.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved29.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved30.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved31.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved32.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved33.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved34.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved35.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved36.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved37.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved38.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved39.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved40.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved41.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved42.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved43.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved44.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved45.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved46.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved47.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved48.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved49.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved50.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved51.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved52.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved53.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved54.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved55.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved56.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved57.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved58.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved59.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved60.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved61.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved62.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved63.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved64.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved65.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved66.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved67.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved68.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved69.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved70.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved71.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved72.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved73.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved74.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved75.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved76.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved77.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved78.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved79.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved80.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved81.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved82.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved83.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved84.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved85.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved86.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved87.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved88.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved89.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved90.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.vehicle_breakdown91.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.post_crash92.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.human_problem93.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.stationary_vehicle94.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.emergency_vehicle_approaching95.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.hazardous_location_dangerous_curve96.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.collision_risk97.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.signal_violation98.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.dangerous_situation99.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.railway_level_crossing100.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved101.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved102.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved103.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved104.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved105.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved106.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved107.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved108.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved109.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved110.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved111.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved112.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved113.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved114.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved115.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved116.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved117.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved118.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved119.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved120.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved121.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved122.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved123.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved124.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved125.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved126.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved127.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved128.value, _x.special_vehicle_container.emergency_container.incident_indication_is_present,) = _get_struct_132B().unpack(str[start:end])
      self.special_vehicle_container.emergency_container.incident_indication_is_present = bool(self.special_vehicle_container.emergency_container.incident_indication_is_present)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.special_vehicle_container.emergency_container.emergency_priority.value = str[start:end]
      _x = self
      start = end
      end += 2
      (_x.special_vehicle_container.emergency_container.emergency_priority.bits_unused, _x.special_vehicle_container.emergency_container.emergency_priority_is_present,) = _get_struct_2B().unpack(str[start:end])
      self.special_vehicle_container.emergency_container.emergency_priority_is_present = bool(self.special_vehicle_container.emergency_container.emergency_priority_is_present)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.special_vehicle_container.safety_car_container.light_bar_siren_in_use.value = str[start:end]
      _x = self
      start = end
      end += 137
      (_x.special_vehicle_container.safety_car_container.light_bar_siren_in_use.bits_unused, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.choice, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved0.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.traffic_condition1.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.accident2.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.roadworks3.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved4.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.impassability5.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.adverse_weather_condition_adhesion6.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.aquaplaning7.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved8.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.hazardous_location_surface_condition9.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.hazardous_location_obstacle_on_the_road10.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.hazardous_location_animal_on_the_road11.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.human_presence_on_the_road12.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved13.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.wrong_way_driving14.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.rescue_and_recovery_work_in_progress15.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved16.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.adverse_weather_condition_extreme_weather_condition17.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.adverse_weather_condition_visibility18.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.adverse_weather_condition_precipitation19.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.violence20.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved21.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved22.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved23.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved24.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved25.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.slow_vehicle26.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.dangerous_end_of_queue27.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.public_transport_vehicle_approaching28.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved29.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved30.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved31.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved32.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved33.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved34.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved35.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved36.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved37.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved38.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved39.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved40.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved41.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved42.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved43.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved44.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved45.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved46.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved47.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved48.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved49.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved50.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved51.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved52.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved53.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved54.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved55.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved56.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved57.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved58.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved59.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved60.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved61.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved62.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved63.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved64.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved65.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved66.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved67.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved68.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved69.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved70.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved71.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved72.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved73.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved74.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved75.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved76.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved77.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved78.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved79.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved80.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved81.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved82.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved83.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved84.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved85.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved86.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved87.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved88.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved89.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved90.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.vehicle_breakdown91.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.post_crash92.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.human_problem93.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.stationary_vehicle94.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.emergency_vehicle_approaching95.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.hazardous_location_dangerous_curve96.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.collision_risk97.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.signal_violation98.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.dangerous_situation99.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.railway_level_crossing100.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved101.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved102.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved103.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved104.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved105.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved106.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved107.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved108.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved109.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved110.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved111.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved112.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved113.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved114.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved115.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved116.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved117.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved118.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved119.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved120.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved121.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved122.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved123.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved124.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved125.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved126.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved127.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved128.value, _x.special_vehicle_container.safety_car_container.incident_indication_is_present, _x.special_vehicle_container.safety_car_container.traffic_rule.value, _x.special_vehicle_container.safety_car_container.traffic_rule_is_present, _x.special_vehicle_container.safety_car_container.speed_limit.value, _x.special_vehicle_container.safety_car_container.speed_limit_is_present, _x.special_vehicle_container_is_present,) = _get_struct_137B().unpack(str[start:end])
      self.special_vehicle_container.safety_car_container.incident_indication_is_present = bool(self.special_vehicle_container.safety_car_container.incident_indication_is_present)
      self.special_vehicle_container.safety_car_container.traffic_rule_is_present = bool(self.special_vehicle_container.safety_car_container.traffic_rule_is_present)
      self.special_vehicle_container.safety_car_container.speed_limit_is_present = bool(self.special_vehicle_container.safety_car_container.speed_limit_is_present)
      self.special_vehicle_container_is_present = bool(self.special_vehicle_container_is_present)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_B2i3Hi2BHBH2BH2BhBh2BhB().pack(_x.basic_container.station_type.value, _x.basic_container.reference_position.latitude.value, _x.basic_container.reference_position.longitude.value, _x.basic_container.reference_position.position_confidence_ellipse.semi_major_axis_length.value, _x.basic_container.reference_position.position_confidence_ellipse.semi_minor_axis_length.value, _x.basic_container.reference_position.position_confidence_ellipse.semi_major_axis_orientation.value, _x.basic_container.reference_position.altitude.altitude_value.value, _x.basic_container.reference_position.altitude.altitude_confidence.value, _x.high_frequency_container.choice, _x.high_frequency_container.basic_vehicle_container_high_frequency.heading.heading_value.value, _x.high_frequency_container.basic_vehicle_container_high_frequency.heading.heading_confidence.value, _x.high_frequency_container.basic_vehicle_container_high_frequency.speed.speed_value.value, _x.high_frequency_container.basic_vehicle_container_high_frequency.speed.speed_confidence.value, _x.high_frequency_container.basic_vehicle_container_high_frequency.drive_direction.value, _x.high_frequency_container.basic_vehicle_container_high_frequency.vehicle_length.vehicle_length_value.value, _x.high_frequency_container.basic_vehicle_container_high_frequency.vehicle_length.vehicle_length_confidence_indication.value, _x.high_frequency_container.basic_vehicle_container_high_frequency.vehicle_width.value, _x.high_frequency_container.basic_vehicle_container_high_frequency.longitudinal_acceleration.value.value, _x.high_frequency_container.basic_vehicle_container_high_frequency.longitudinal_acceleration.confidence.value, _x.high_frequency_container.basic_vehicle_container_high_frequency.curvature.curvature_value.value, _x.high_frequency_container.basic_vehicle_container_high_frequency.curvature.curvature_confidence.value, _x.high_frequency_container.basic_vehicle_container_high_frequency.curvature_calculation_mode.value, _x.high_frequency_container.basic_vehicle_container_high_frequency.yaw_rate.yaw_rate_value.value, _x.high_frequency_container.basic_vehicle_container_high_frequency.yaw_rate.yaw_rate_confidence.value))
      _x = self.high_frequency_container.basic_vehicle_container_high_frequency.acceleration_control.value
      length = len(_x)
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
      else:
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_2BbBh2Bh2Bh4B2iI2B().pack(_x.high_frequency_container.basic_vehicle_container_high_frequency.acceleration_control.bits_unused, _x.high_frequency_container.basic_vehicle_container_high_frequency.acceleration_control_is_present, _x.high_frequency_container.basic_vehicle_container_high_frequency.lane_position.value, _x.high_frequency_container.basic_vehicle_container_high_frequency.lane_position_is_present, _x.high_frequency_container.basic_vehicle_container_high_frequency.steering_wheel_angle.steering_wheel_angle_value.value, _x.high_frequency_container.basic_vehicle_container_high_frequency.steering_wheel_angle.steering_wheel_angle_confidence.value, _x.high_frequency_container.basic_vehicle_container_high_frequency.steering_wheel_angle_is_present, _x.high_frequency_container.basic_vehicle_container_high_frequency.lateral_acceleration.value.value, _x.high_frequency_container.basic_vehicle_container_high_frequency.lateral_acceleration.confidence.value, _x.high_frequency_container.basic_vehicle_container_high_frequency.lateral_acceleration_is_present, _x.high_frequency_container.basic_vehicle_container_high_frequency.vertical_acceleration.value.value, _x.high_frequency_container.basic_vehicle_container_high_frequency.vertical_acceleration.confidence.value, _x.high_frequency_container.basic_vehicle_container_high_frequency.vertical_acceleration_is_present, _x.high_frequency_container.basic_vehicle_container_high_frequency.performance_class.value, _x.high_frequency_container.basic_vehicle_container_high_frequency.performance_class_is_present, _x.high_frequency_container.basic_vehicle_container_high_frequency.cen_dsrc_tolling_zone.protected_zone_latitude.value, _x.high_frequency_container.basic_vehicle_container_high_frequency.cen_dsrc_tolling_zone.protected_zone_longitude.value, _x.high_frequency_container.basic_vehicle_container_high_frequency.cen_dsrc_tolling_zone.cen_dsrc_tolling_zone_id.value, _x.high_frequency_container.basic_vehicle_container_high_frequency.cen_dsrc_tolling_zone.cen_dsrc_tolling_zone_id_is_present, _x.high_frequency_container.basic_vehicle_container_high_frequency.cen_dsrc_tolling_zone_is_present))
      length = len(self.high_frequency_container.rsu_container_high_frequency.protected_communication_zones_rsu.array)
      buff.write(_struct_I.pack(length))
      for val1 in self.high_frequency_container.rsu_container_high_frequency.protected_communication_zones_rsu.array:
        _v23 = val1.protected_zone_type
        _x = _v23.value
        buff.write(_get_struct_B().pack(_x))
        _v24 = val1.expiry_time
        _x = _v24.value
        buff.write(_get_struct_Q().pack(_x))
        _x = val1.expiry_time_is_present
        buff.write(_get_struct_B().pack(_x))
        _v25 = val1.protected_zone_latitude
        _x = _v25.value
        buff.write(_get_struct_i().pack(_x))
        _v26 = val1.protected_zone_longitude
        _x = _v26.value
        buff.write(_get_struct_i().pack(_x))
        _v27 = val1.protected_zone_radius
        _x = _v27.value
        buff.write(_get_struct_B().pack(_x))
        _x = val1.protected_zone_radius_is_present
        buff.write(_get_struct_B().pack(_x))
        _v28 = val1.protected_zone_id
        _x = _v28.value
        buff.write(_get_struct_I().pack(_x))
        _x = val1.protected_zone_id_is_present
        buff.write(_get_struct_B().pack(_x))
      _x = self
      buff.write(_get_struct_3B().pack(_x.high_frequency_container.rsu_container_high_frequency.protected_communication_zones_rsu_is_present, _x.low_frequency_container.choice, _x.low_frequency_container.basic_vehicle_container_low_frequency.vehicle_role.value))
      _x = self.low_frequency_container.basic_vehicle_container_low_frequency.exterior_lights.value
      length = len(_x)
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
      else:
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.low_frequency_container.basic_vehicle_container_low_frequency.exterior_lights.bits_unused
      buff.write(_get_struct_B().pack(_x))
      length = len(self.low_frequency_container.basic_vehicle_container_low_frequency.path_history.array)
      buff.write(_struct_I.pack(length))
      for val1 in self.low_frequency_container.basic_vehicle_container_low_frequency.path_history.array:
        _v29 = val1.path_position
        _v30 = _v29.delta_latitude
        _x = _v30.value
        buff.write(_get_struct_i().pack(_x))
        _v31 = _v29.delta_longitude
        _x = _v31.value
        buff.write(_get_struct_i().pack(_x))
        _v32 = _v29.delta_altitude
        _x = _v32.value
        buff.write(_get_struct_h().pack(_x))
        _v33 = val1.path_delta_time
        _x = _v33.value
        buff.write(_get_struct_H().pack(_x))
        _x = val1.path_delta_time_is_present
        buff.write(_get_struct_B().pack(_x))
      _x = self
      buff.write(_get_struct_4B().pack(_x.low_frequency_container_is_present, _x.special_vehicle_container.choice, _x.special_vehicle_container.public_transport_container.embarkation_status.value, _x.special_vehicle_container.public_transport_container.pt_activation.pt_activation_type.value))
      _x = self.special_vehicle_container.public_transport_container.pt_activation.pt_activation_data.value
      length = len(_x)
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
      else:
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.special_vehicle_container.public_transport_container.pt_activation_is_present
      buff.write(_get_struct_B().pack(_x))
      _x = self.special_vehicle_container.special_transport_container.special_transport_type.value
      length = len(_x)
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
      else:
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.special_vehicle_container.special_transport_container.special_transport_type.bits_unused
      buff.write(_get_struct_B().pack(_x))
      _x = self.special_vehicle_container.special_transport_container.light_bar_siren_in_use.value
      length = len(_x)
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
      else:
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_4B().pack(_x.special_vehicle_container.special_transport_container.light_bar_siren_in_use.bits_unused, _x.special_vehicle_container.dangerous_goods_container.dangerous_goods_basic.value, _x.special_vehicle_container.road_works_container_basic.roadworks_sub_cause_code.value, _x.special_vehicle_container.road_works_container_basic.roadworks_sub_cause_code_is_present))
      _x = self.special_vehicle_container.road_works_container_basic.light_bar_siren_in_use.value
      length = len(_x)
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
      else:
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_5B().pack(_x.special_vehicle_container.road_works_container_basic.light_bar_siren_in_use.bits_unused, _x.special_vehicle_container.road_works_container_basic.closed_lanes.innerhard_shoulder_status.value, _x.special_vehicle_container.road_works_container_basic.closed_lanes.innerhard_shoulder_status_is_present, _x.special_vehicle_container.road_works_container_basic.closed_lanes.outerhard_shoulder_status.value, _x.special_vehicle_container.road_works_container_basic.closed_lanes.outerhard_shoulder_status_is_present))
      _x = self.special_vehicle_container.road_works_container_basic.closed_lanes.driving_lane_status.value
      length = len(_x)
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
      else:
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_3B().pack(_x.special_vehicle_container.road_works_container_basic.closed_lanes.driving_lane_status.bits_unused, _x.special_vehicle_container.road_works_container_basic.closed_lanes.driving_lane_status_is_present, _x.special_vehicle_container.road_works_container_basic.closed_lanes_is_present))
      _x = self.special_vehicle_container.rescue_container.light_bar_siren_in_use.value
      length = len(_x)
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
      else:
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.special_vehicle_container.rescue_container.light_bar_siren_in_use.bits_unused
      buff.write(_get_struct_B().pack(_x))
      _x = self.special_vehicle_container.emergency_container.light_bar_siren_in_use.value
      length = len(_x)
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
      else:
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_132B().pack(_x.special_vehicle_container.emergency_container.light_bar_siren_in_use.bits_unused, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.choice, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved0.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.traffic_condition1.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.accident2.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.roadworks3.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved4.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.impassability5.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.adverse_weather_condition_adhesion6.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.aquaplaning7.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved8.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.hazardous_location_surface_condition9.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.hazardous_location_obstacle_on_the_road10.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.hazardous_location_animal_on_the_road11.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.human_presence_on_the_road12.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved13.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.wrong_way_driving14.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.rescue_and_recovery_work_in_progress15.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved16.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.adverse_weather_condition_extreme_weather_condition17.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.adverse_weather_condition_visibility18.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.adverse_weather_condition_precipitation19.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.violence20.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved21.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved22.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved23.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved24.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved25.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.slow_vehicle26.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.dangerous_end_of_queue27.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.public_transport_vehicle_approaching28.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved29.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved30.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved31.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved32.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved33.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved34.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved35.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved36.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved37.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved38.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved39.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved40.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved41.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved42.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved43.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved44.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved45.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved46.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved47.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved48.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved49.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved50.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved51.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved52.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved53.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved54.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved55.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved56.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved57.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved58.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved59.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved60.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved61.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved62.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved63.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved64.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved65.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved66.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved67.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved68.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved69.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved70.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved71.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved72.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved73.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved74.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved75.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved76.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved77.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved78.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved79.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved80.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved81.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved82.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved83.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved84.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved85.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved86.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved87.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved88.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved89.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved90.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.vehicle_breakdown91.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.post_crash92.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.human_problem93.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.stationary_vehicle94.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.emergency_vehicle_approaching95.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.hazardous_location_dangerous_curve96.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.collision_risk97.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.signal_violation98.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.dangerous_situation99.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.railway_level_crossing100.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved101.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved102.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved103.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved104.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved105.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved106.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved107.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved108.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved109.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved110.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved111.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved112.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved113.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved114.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved115.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved116.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved117.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved118.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved119.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved120.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved121.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved122.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved123.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved124.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved125.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved126.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved127.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved128.value, _x.special_vehicle_container.emergency_container.incident_indication_is_present))
      _x = self.special_vehicle_container.emergency_container.emergency_priority.value
      length = len(_x)
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
      else:
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_2B().pack(_x.special_vehicle_container.emergency_container.emergency_priority.bits_unused, _x.special_vehicle_container.emergency_container.emergency_priority_is_present))
      _x = self.special_vehicle_container.safety_car_container.light_bar_siren_in_use.value
      length = len(_x)
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
      else:
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_137B().pack(_x.special_vehicle_container.safety_car_container.light_bar_siren_in_use.bits_unused, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.choice, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved0.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.traffic_condition1.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.accident2.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.roadworks3.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved4.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.impassability5.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.adverse_weather_condition_adhesion6.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.aquaplaning7.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved8.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.hazardous_location_surface_condition9.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.hazardous_location_obstacle_on_the_road10.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.hazardous_location_animal_on_the_road11.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.human_presence_on_the_road12.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved13.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.wrong_way_driving14.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.rescue_and_recovery_work_in_progress15.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved16.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.adverse_weather_condition_extreme_weather_condition17.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.adverse_weather_condition_visibility18.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.adverse_weather_condition_precipitation19.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.violence20.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved21.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved22.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved23.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved24.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved25.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.slow_vehicle26.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.dangerous_end_of_queue27.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.public_transport_vehicle_approaching28.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved29.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved30.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved31.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved32.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved33.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved34.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved35.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved36.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved37.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved38.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved39.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved40.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved41.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved42.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved43.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved44.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved45.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved46.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved47.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved48.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved49.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved50.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved51.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved52.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved53.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved54.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved55.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved56.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved57.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved58.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved59.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved60.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved61.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved62.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved63.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved64.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved65.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved66.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved67.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved68.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved69.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved70.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved71.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved72.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved73.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved74.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved75.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved76.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved77.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved78.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved79.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved80.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved81.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved82.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved83.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved84.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved85.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved86.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved87.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved88.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved89.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved90.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.vehicle_breakdown91.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.post_crash92.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.human_problem93.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.stationary_vehicle94.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.emergency_vehicle_approaching95.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.hazardous_location_dangerous_curve96.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.collision_risk97.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.signal_violation98.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.dangerous_situation99.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.railway_level_crossing100.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved101.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved102.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved103.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved104.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved105.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved106.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved107.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved108.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved109.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved110.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved111.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved112.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved113.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved114.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved115.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved116.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved117.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved118.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved119.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved120.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved121.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved122.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved123.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved124.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved125.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved126.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved127.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved128.value, _x.special_vehicle_container.safety_car_container.incident_indication_is_present, _x.special_vehicle_container.safety_car_container.traffic_rule.value, _x.special_vehicle_container.safety_car_container.traffic_rule_is_present, _x.special_vehicle_container.safety_car_container.speed_limit.value, _x.special_vehicle_container.safety_car_container.speed_limit_is_present, _x.special_vehicle_container_is_present))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.basic_container is None:
        self.basic_container = etsi_its_cam_ts_msgs.msg.BasicContainer()
      if self.high_frequency_container is None:
        self.high_frequency_container = etsi_its_cam_ts_msgs.msg.HighFrequencyContainer()
      if self.low_frequency_container is None:
        self.low_frequency_container = etsi_its_cam_ts_msgs.msg.LowFrequencyContainer()
      if self.special_vehicle_container is None:
        self.special_vehicle_container = etsi_its_cam_ts_msgs.msg.SpecialVehicleContainer()
      end = 0
      _x = self
      start = end
      end += 42
      (_x.basic_container.station_type.value, _x.basic_container.reference_position.latitude.value, _x.basic_container.reference_position.longitude.value, _x.basic_container.reference_position.position_confidence_ellipse.semi_major_axis_length.value, _x.basic_container.reference_position.position_confidence_ellipse.semi_minor_axis_length.value, _x.basic_container.reference_position.position_confidence_ellipse.semi_major_axis_orientation.value, _x.basic_container.reference_position.altitude.altitude_value.value, _x.basic_container.reference_position.altitude.altitude_confidence.value, _x.high_frequency_container.choice, _x.high_frequency_container.basic_vehicle_container_high_frequency.heading.heading_value.value, _x.high_frequency_container.basic_vehicle_container_high_frequency.heading.heading_confidence.value, _x.high_frequency_container.basic_vehicle_container_high_frequency.speed.speed_value.value, _x.high_frequency_container.basic_vehicle_container_high_frequency.speed.speed_confidence.value, _x.high_frequency_container.basic_vehicle_container_high_frequency.drive_direction.value, _x.high_frequency_container.basic_vehicle_container_high_frequency.vehicle_length.vehicle_length_value.value, _x.high_frequency_container.basic_vehicle_container_high_frequency.vehicle_length.vehicle_length_confidence_indication.value, _x.high_frequency_container.basic_vehicle_container_high_frequency.vehicle_width.value, _x.high_frequency_container.basic_vehicle_container_high_frequency.longitudinal_acceleration.value.value, _x.high_frequency_container.basic_vehicle_container_high_frequency.longitudinal_acceleration.confidence.value, _x.high_frequency_container.basic_vehicle_container_high_frequency.curvature.curvature_value.value, _x.high_frequency_container.basic_vehicle_container_high_frequency.curvature.curvature_confidence.value, _x.high_frequency_container.basic_vehicle_container_high_frequency.curvature_calculation_mode.value, _x.high_frequency_container.basic_vehicle_container_high_frequency.yaw_rate.yaw_rate_value.value, _x.high_frequency_container.basic_vehicle_container_high_frequency.yaw_rate.yaw_rate_confidence.value,) = _get_struct_B2i3Hi2BHBH2BH2BhBh2BhB().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.high_frequency_container.basic_vehicle_container_high_frequency.acceleration_control.value = str[start:end]
      _x = self
      start = end
      end += 32
      (_x.high_frequency_container.basic_vehicle_container_high_frequency.acceleration_control.bits_unused, _x.high_frequency_container.basic_vehicle_container_high_frequency.acceleration_control_is_present, _x.high_frequency_container.basic_vehicle_container_high_frequency.lane_position.value, _x.high_frequency_container.basic_vehicle_container_high_frequency.lane_position_is_present, _x.high_frequency_container.basic_vehicle_container_high_frequency.steering_wheel_angle.steering_wheel_angle_value.value, _x.high_frequency_container.basic_vehicle_container_high_frequency.steering_wheel_angle.steering_wheel_angle_confidence.value, _x.high_frequency_container.basic_vehicle_container_high_frequency.steering_wheel_angle_is_present, _x.high_frequency_container.basic_vehicle_container_high_frequency.lateral_acceleration.value.value, _x.high_frequency_container.basic_vehicle_container_high_frequency.lateral_acceleration.confidence.value, _x.high_frequency_container.basic_vehicle_container_high_frequency.lateral_acceleration_is_present, _x.high_frequency_container.basic_vehicle_container_high_frequency.vertical_acceleration.value.value, _x.high_frequency_container.basic_vehicle_container_high_frequency.vertical_acceleration.confidence.value, _x.high_frequency_container.basic_vehicle_container_high_frequency.vertical_acceleration_is_present, _x.high_frequency_container.basic_vehicle_container_high_frequency.performance_class.value, _x.high_frequency_container.basic_vehicle_container_high_frequency.performance_class_is_present, _x.high_frequency_container.basic_vehicle_container_high_frequency.cen_dsrc_tolling_zone.protected_zone_latitude.value, _x.high_frequency_container.basic_vehicle_container_high_frequency.cen_dsrc_tolling_zone.protected_zone_longitude.value, _x.high_frequency_container.basic_vehicle_container_high_frequency.cen_dsrc_tolling_zone.cen_dsrc_tolling_zone_id.value, _x.high_frequency_container.basic_vehicle_container_high_frequency.cen_dsrc_tolling_zone.cen_dsrc_tolling_zone_id_is_present, _x.high_frequency_container.basic_vehicle_container_high_frequency.cen_dsrc_tolling_zone_is_present,) = _get_struct_2BbBh2Bh2Bh4B2iI2B().unpack(str[start:end])
      self.high_frequency_container.basic_vehicle_container_high_frequency.acceleration_control_is_present = bool(self.high_frequency_container.basic_vehicle_container_high_frequency.acceleration_control_is_present)
      self.high_frequency_container.basic_vehicle_container_high_frequency.lane_position_is_present = bool(self.high_frequency_container.basic_vehicle_container_high_frequency.lane_position_is_present)
      self.high_frequency_container.basic_vehicle_container_high_frequency.steering_wheel_angle_is_present = bool(self.high_frequency_container.basic_vehicle_container_high_frequency.steering_wheel_angle_is_present)
      self.high_frequency_container.basic_vehicle_container_high_frequency.lateral_acceleration_is_present = bool(self.high_frequency_container.basic_vehicle_container_high_frequency.lateral_acceleration_is_present)
      self.high_frequency_container.basic_vehicle_container_high_frequency.vertical_acceleration_is_present = bool(self.high_frequency_container.basic_vehicle_container_high_frequency.vertical_acceleration_is_present)
      self.high_frequency_container.basic_vehicle_container_high_frequency.performance_class_is_present = bool(self.high_frequency_container.basic_vehicle_container_high_frequency.performance_class_is_present)
      self.high_frequency_container.basic_vehicle_container_high_frequency.cen_dsrc_tolling_zone.cen_dsrc_tolling_zone_id_is_present = bool(self.high_frequency_container.basic_vehicle_container_high_frequency.cen_dsrc_tolling_zone.cen_dsrc_tolling_zone_id_is_present)
      self.high_frequency_container.basic_vehicle_container_high_frequency.cen_dsrc_tolling_zone_is_present = bool(self.high_frequency_container.basic_vehicle_container_high_frequency.cen_dsrc_tolling_zone_is_present)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.high_frequency_container.rsu_container_high_frequency.protected_communication_zones_rsu.array = []
      for i in range(0, length):
        val1 = etsi_its_cam_ts_msgs.msg.ProtectedCommunicationZone()
        _v34 = val1.protected_zone_type
        start = end
        end += 1
        (_v34.value,) = _get_struct_B().unpack(str[start:end])
        _v35 = val1.expiry_time
        start = end
        end += 8
        (_v35.value,) = _get_struct_Q().unpack(str[start:end])
        start = end
        end += 1
        (val1.expiry_time_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.expiry_time_is_present = bool(val1.expiry_time_is_present)
        _v36 = val1.protected_zone_latitude
        start = end
        end += 4
        (_v36.value,) = _get_struct_i().unpack(str[start:end])
        _v37 = val1.protected_zone_longitude
        start = end
        end += 4
        (_v37.value,) = _get_struct_i().unpack(str[start:end])
        _v38 = val1.protected_zone_radius
        start = end
        end += 1
        (_v38.value,) = _get_struct_B().unpack(str[start:end])
        start = end
        end += 1
        (val1.protected_zone_radius_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.protected_zone_radius_is_present = bool(val1.protected_zone_radius_is_present)
        _v39 = val1.protected_zone_id
        start = end
        end += 4
        (_v39.value,) = _get_struct_I().unpack(str[start:end])
        start = end
        end += 1
        (val1.protected_zone_id_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.protected_zone_id_is_present = bool(val1.protected_zone_id_is_present)
        self.high_frequency_container.rsu_container_high_frequency.protected_communication_zones_rsu.array.append(val1)
      _x = self
      start = end
      end += 3
      (_x.high_frequency_container.rsu_container_high_frequency.protected_communication_zones_rsu_is_present, _x.low_frequency_container.choice, _x.low_frequency_container.basic_vehicle_container_low_frequency.vehicle_role.value,) = _get_struct_3B().unpack(str[start:end])
      self.high_frequency_container.rsu_container_high_frequency.protected_communication_zones_rsu_is_present = bool(self.high_frequency_container.rsu_container_high_frequency.protected_communication_zones_rsu_is_present)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.low_frequency_container.basic_vehicle_container_low_frequency.exterior_lights.value = str[start:end]
      start = end
      end += 1
      (self.low_frequency_container.basic_vehicle_container_low_frequency.exterior_lights.bits_unused,) = _get_struct_B().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.low_frequency_container.basic_vehicle_container_low_frequency.path_history.array = []
      for i in range(0, length):
        val1 = etsi_its_cam_ts_msgs.msg.PathPoint()
        _v40 = val1.path_position
        _v41 = _v40.delta_latitude
        start = end
        end += 4
        (_v41.value,) = _get_struct_i().unpack(str[start:end])
        _v42 = _v40.delta_longitude
        start = end
        end += 4
        (_v42.value,) = _get_struct_i().unpack(str[start:end])
        _v43 = _v40.delta_altitude
        start = end
        end += 2
        (_v43.value,) = _get_struct_h().unpack(str[start:end])
        _v44 = val1.path_delta_time
        start = end
        end += 2
        (_v44.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (val1.path_delta_time_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.path_delta_time_is_present = bool(val1.path_delta_time_is_present)
        self.low_frequency_container.basic_vehicle_container_low_frequency.path_history.array.append(val1)
      _x = self
      start = end
      end += 4
      (_x.low_frequency_container_is_present, _x.special_vehicle_container.choice, _x.special_vehicle_container.public_transport_container.embarkation_status.value, _x.special_vehicle_container.public_transport_container.pt_activation.pt_activation_type.value,) = _get_struct_4B().unpack(str[start:end])
      self.low_frequency_container_is_present = bool(self.low_frequency_container_is_present)
      self.special_vehicle_container.public_transport_container.embarkation_status.value = bool(self.special_vehicle_container.public_transport_container.embarkation_status.value)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.special_vehicle_container.public_transport_container.pt_activation.pt_activation_data.value = str[start:end]
      start = end
      end += 1
      (self.special_vehicle_container.public_transport_container.pt_activation_is_present,) = _get_struct_B().unpack(str[start:end])
      self.special_vehicle_container.public_transport_container.pt_activation_is_present = bool(self.special_vehicle_container.public_transport_container.pt_activation_is_present)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.special_vehicle_container.special_transport_container.special_transport_type.value = str[start:end]
      start = end
      end += 1
      (self.special_vehicle_container.special_transport_container.special_transport_type.bits_unused,) = _get_struct_B().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.special_vehicle_container.special_transport_container.light_bar_siren_in_use.value = str[start:end]
      _x = self
      start = end
      end += 4
      (_x.special_vehicle_container.special_transport_container.light_bar_siren_in_use.bits_unused, _x.special_vehicle_container.dangerous_goods_container.dangerous_goods_basic.value, _x.special_vehicle_container.road_works_container_basic.roadworks_sub_cause_code.value, _x.special_vehicle_container.road_works_container_basic.roadworks_sub_cause_code_is_present,) = _get_struct_4B().unpack(str[start:end])
      self.special_vehicle_container.road_works_container_basic.roadworks_sub_cause_code_is_present = bool(self.special_vehicle_container.road_works_container_basic.roadworks_sub_cause_code_is_present)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.special_vehicle_container.road_works_container_basic.light_bar_siren_in_use.value = str[start:end]
      _x = self
      start = end
      end += 5
      (_x.special_vehicle_container.road_works_container_basic.light_bar_siren_in_use.bits_unused, _x.special_vehicle_container.road_works_container_basic.closed_lanes.innerhard_shoulder_status.value, _x.special_vehicle_container.road_works_container_basic.closed_lanes.innerhard_shoulder_status_is_present, _x.special_vehicle_container.road_works_container_basic.closed_lanes.outerhard_shoulder_status.value, _x.special_vehicle_container.road_works_container_basic.closed_lanes.outerhard_shoulder_status_is_present,) = _get_struct_5B().unpack(str[start:end])
      self.special_vehicle_container.road_works_container_basic.closed_lanes.innerhard_shoulder_status_is_present = bool(self.special_vehicle_container.road_works_container_basic.closed_lanes.innerhard_shoulder_status_is_present)
      self.special_vehicle_container.road_works_container_basic.closed_lanes.outerhard_shoulder_status_is_present = bool(self.special_vehicle_container.road_works_container_basic.closed_lanes.outerhard_shoulder_status_is_present)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.special_vehicle_container.road_works_container_basic.closed_lanes.driving_lane_status.value = str[start:end]
      _x = self
      start = end
      end += 3
      (_x.special_vehicle_container.road_works_container_basic.closed_lanes.driving_lane_status.bits_unused, _x.special_vehicle_container.road_works_container_basic.closed_lanes.driving_lane_status_is_present, _x.special_vehicle_container.road_works_container_basic.closed_lanes_is_present,) = _get_struct_3B().unpack(str[start:end])
      self.special_vehicle_container.road_works_container_basic.closed_lanes.driving_lane_status_is_present = bool(self.special_vehicle_container.road_works_container_basic.closed_lanes.driving_lane_status_is_present)
      self.special_vehicle_container.road_works_container_basic.closed_lanes_is_present = bool(self.special_vehicle_container.road_works_container_basic.closed_lanes_is_present)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.special_vehicle_container.rescue_container.light_bar_siren_in_use.value = str[start:end]
      start = end
      end += 1
      (self.special_vehicle_container.rescue_container.light_bar_siren_in_use.bits_unused,) = _get_struct_B().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.special_vehicle_container.emergency_container.light_bar_siren_in_use.value = str[start:end]
      _x = self
      start = end
      end += 132
      (_x.special_vehicle_container.emergency_container.light_bar_siren_in_use.bits_unused, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.choice, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved0.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.traffic_condition1.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.accident2.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.roadworks3.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved4.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.impassability5.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.adverse_weather_condition_adhesion6.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.aquaplaning7.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved8.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.hazardous_location_surface_condition9.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.hazardous_location_obstacle_on_the_road10.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.hazardous_location_animal_on_the_road11.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.human_presence_on_the_road12.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved13.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.wrong_way_driving14.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.rescue_and_recovery_work_in_progress15.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved16.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.adverse_weather_condition_extreme_weather_condition17.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.adverse_weather_condition_visibility18.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.adverse_weather_condition_precipitation19.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.violence20.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved21.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved22.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved23.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved24.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved25.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.slow_vehicle26.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.dangerous_end_of_queue27.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.public_transport_vehicle_approaching28.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved29.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved30.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved31.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved32.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved33.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved34.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved35.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved36.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved37.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved38.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved39.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved40.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved41.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved42.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved43.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved44.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved45.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved46.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved47.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved48.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved49.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved50.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved51.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved52.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved53.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved54.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved55.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved56.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved57.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved58.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved59.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved60.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved61.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved62.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved63.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved64.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved65.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved66.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved67.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved68.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved69.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved70.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved71.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved72.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved73.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved74.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved75.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved76.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved77.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved78.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved79.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved80.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved81.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved82.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved83.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved84.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved85.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved86.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved87.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved88.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved89.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved90.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.vehicle_breakdown91.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.post_crash92.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.human_problem93.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.stationary_vehicle94.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.emergency_vehicle_approaching95.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.hazardous_location_dangerous_curve96.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.collision_risk97.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.signal_violation98.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.dangerous_situation99.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.railway_level_crossing100.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved101.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved102.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved103.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved104.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved105.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved106.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved107.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved108.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved109.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved110.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved111.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved112.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved113.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved114.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved115.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved116.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved117.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved118.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved119.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved120.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved121.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved122.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved123.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved124.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved125.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved126.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved127.value, _x.special_vehicle_container.emergency_container.incident_indication.cc_and_scc.reserved128.value, _x.special_vehicle_container.emergency_container.incident_indication_is_present,) = _get_struct_132B().unpack(str[start:end])
      self.special_vehicle_container.emergency_container.incident_indication_is_present = bool(self.special_vehicle_container.emergency_container.incident_indication_is_present)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.special_vehicle_container.emergency_container.emergency_priority.value = str[start:end]
      _x = self
      start = end
      end += 2
      (_x.special_vehicle_container.emergency_container.emergency_priority.bits_unused, _x.special_vehicle_container.emergency_container.emergency_priority_is_present,) = _get_struct_2B().unpack(str[start:end])
      self.special_vehicle_container.emergency_container.emergency_priority_is_present = bool(self.special_vehicle_container.emergency_container.emergency_priority_is_present)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.special_vehicle_container.safety_car_container.light_bar_siren_in_use.value = str[start:end]
      _x = self
      start = end
      end += 137
      (_x.special_vehicle_container.safety_car_container.light_bar_siren_in_use.bits_unused, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.choice, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved0.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.traffic_condition1.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.accident2.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.roadworks3.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved4.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.impassability5.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.adverse_weather_condition_adhesion6.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.aquaplaning7.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved8.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.hazardous_location_surface_condition9.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.hazardous_location_obstacle_on_the_road10.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.hazardous_location_animal_on_the_road11.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.human_presence_on_the_road12.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved13.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.wrong_way_driving14.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.rescue_and_recovery_work_in_progress15.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved16.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.adverse_weather_condition_extreme_weather_condition17.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.adverse_weather_condition_visibility18.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.adverse_weather_condition_precipitation19.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.violence20.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved21.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved22.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved23.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved24.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved25.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.slow_vehicle26.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.dangerous_end_of_queue27.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.public_transport_vehicle_approaching28.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved29.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved30.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved31.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved32.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved33.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved34.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved35.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved36.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved37.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved38.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved39.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved40.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved41.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved42.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved43.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved44.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved45.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved46.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved47.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved48.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved49.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved50.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved51.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved52.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved53.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved54.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved55.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved56.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved57.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved58.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved59.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved60.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved61.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved62.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved63.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved64.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved65.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved66.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved67.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved68.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved69.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved70.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved71.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved72.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved73.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved74.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved75.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved76.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved77.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved78.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved79.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved80.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved81.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved82.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved83.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved84.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved85.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved86.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved87.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved88.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved89.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved90.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.vehicle_breakdown91.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.post_crash92.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.human_problem93.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.stationary_vehicle94.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.emergency_vehicle_approaching95.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.hazardous_location_dangerous_curve96.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.collision_risk97.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.signal_violation98.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.dangerous_situation99.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.railway_level_crossing100.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved101.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved102.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved103.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved104.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved105.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved106.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved107.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved108.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved109.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved110.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved111.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved112.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved113.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved114.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved115.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved116.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved117.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved118.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved119.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved120.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved121.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved122.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved123.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved124.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved125.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved126.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved127.value, _x.special_vehicle_container.safety_car_container.incident_indication.cc_and_scc.reserved128.value, _x.special_vehicle_container.safety_car_container.incident_indication_is_present, _x.special_vehicle_container.safety_car_container.traffic_rule.value, _x.special_vehicle_container.safety_car_container.traffic_rule_is_present, _x.special_vehicle_container.safety_car_container.speed_limit.value, _x.special_vehicle_container.safety_car_container.speed_limit_is_present, _x.special_vehicle_container_is_present,) = _get_struct_137B().unpack(str[start:end])
      self.special_vehicle_container.safety_car_container.incident_indication_is_present = bool(self.special_vehicle_container.safety_car_container.incident_indication_is_present)
      self.special_vehicle_container.safety_car_container.traffic_rule_is_present = bool(self.special_vehicle_container.safety_car_container.traffic_rule_is_present)
      self.special_vehicle_container.safety_car_container.speed_limit_is_present = bool(self.special_vehicle_container.safety_car_container.speed_limit_is_present)
      self.special_vehicle_container_is_present = bool(self.special_vehicle_container_is_present)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_132B = None
def _get_struct_132B():
    global _struct_132B
    if _struct_132B is None:
        _struct_132B = struct.Struct("<132B")
    return _struct_132B
_struct_137B = None
def _get_struct_137B():
    global _struct_137B
    if _struct_137B is None:
        _struct_137B = struct.Struct("<137B")
    return _struct_137B
_struct_2B = None
def _get_struct_2B():
    global _struct_2B
    if _struct_2B is None:
        _struct_2B = struct.Struct("<2B")
    return _struct_2B
_struct_2BbBh2Bh2Bh4B2iI2B = None
def _get_struct_2BbBh2Bh2Bh4B2iI2B():
    global _struct_2BbBh2Bh2Bh4B2iI2B
    if _struct_2BbBh2Bh2Bh4B2iI2B is None:
        _struct_2BbBh2Bh2Bh4B2iI2B = struct.Struct("<2BbBh2Bh2Bh4B2iI2B")
    return _struct_2BbBh2Bh2Bh4B2iI2B
_struct_3B = None
def _get_struct_3B():
    global _struct_3B
    if _struct_3B is None:
        _struct_3B = struct.Struct("<3B")
    return _struct_3B
_struct_4B = None
def _get_struct_4B():
    global _struct_4B
    if _struct_4B is None:
        _struct_4B = struct.Struct("<4B")
    return _struct_4B
_struct_5B = None
def _get_struct_5B():
    global _struct_5B
    if _struct_5B is None:
        _struct_5B = struct.Struct("<5B")
    return _struct_5B
_struct_B = None
def _get_struct_B():
    global _struct_B
    if _struct_B is None:
        _struct_B = struct.Struct("<B")
    return _struct_B
_struct_B2i3Hi2BHBH2BH2BhBh2BhB = None
def _get_struct_B2i3Hi2BHBH2BH2BhBh2BhB():
    global _struct_B2i3Hi2BHBH2BH2BhBh2BhB
    if _struct_B2i3Hi2BHBH2BH2BhBh2BhB is None:
        _struct_B2i3Hi2BHBH2BH2BhBh2BhB = struct.Struct("<B2i3Hi2BHBH2BH2BhBh2BhB")
    return _struct_B2i3Hi2BHBH2BH2BhBh2BhB
_struct_H = None
def _get_struct_H():
    global _struct_H
    if _struct_H is None:
        _struct_H = struct.Struct("<H")
    return _struct_H
_struct_Q = None
def _get_struct_Q():
    global _struct_Q
    if _struct_Q is None:
        _struct_Q = struct.Struct("<Q")
    return _struct_Q
_struct_h = None
def _get_struct_h():
    global _struct_h
    if _struct_h is None:
        _struct_h = struct.Struct("<h")
    return _struct_h
_struct_i = None
def _get_struct_i():
    global _struct_i
    if _struct_i is None:
        _struct_i = struct.Struct("<i")
    return _struct_i
